// Code generated by go yacc.
//line sql.y:20
package parser

import __yyfmt__ "fmt"

//line sql.y:20
import (
	"errors"

	"github.com/cockroachdb/cockroach/sql/privilege"
)

var errUnimplemented = errors.New("unimplemented")

func unimplemented() {
	panic(errUnimplemented)
}

//line sql.y:36

// sqlSymUnion represents a union of types, providing accessor methods
// to retrieve the underlying type stored in the union's empty interface.
// The purpose of the sqlSymUnion struct is to reduce the memory footprint of
// the sqlSymType because only one value (of a variety of types) is ever needed
// to be stored in the union field at a time.
//
// By using an empty interface, we lose the type checking previously provided
// by yacc and the Go compiler when dealing with union values. Instead, runtime
// type assertions must be relied upon in the methods below, and as such, the
// parser should be thoroughly tested whenever new sytax is added.
//
// It is important to note that when assigning values to sqlSymUnion.val, all
// nil values should be typed so that they are stored as nil instances in the
// empty interface, instead of setting the empty interface to nil. This means
// that:
//     $$ = []String(nil)
// should be used, instead of:
//     $$ = nil
// to assign a nil string slice to the union.
type sqlSymUnion struct {
	val interface{}
}

// The following accessor methods come in two forms, depending on the
// type of the value being accessed. Values and pointers are directly
// type asserted from the empty interface, meaning that they will panic
// if the type assertion is incorrect. Interfaces are handled differently
// because a nil instance of an interface inserted into the empty interface
// becomes a nil instance of the empty interface and therefore will fail a
// direct type assertion. Instead, a guarded type assertion must be used,
// which returns nil if the type assertion fails.
func (u *sqlSymUnion) ival() IntVal {
	return u.val.(IntVal)
}
func (u *sqlSymUnion) bool() bool {
	return u.val.(bool)
}
func (u *sqlSymUnion) strs() []string {
	return u.val.([]string)
}
func (u *sqlSymUnion) qname() *QualifiedName {
	return u.val.(*QualifiedName)
}
func (u *sqlSymUnion) qnames() QualifiedNames {
	return u.val.(QualifiedNames)
}
func (u *sqlSymUnion) tableWithIdx() *TableNameWithIndex {
	return u.val.(*TableNameWithIndex)
}
func (u *sqlSymUnion) tableWithIdxList() TableNameWithIndexList {
	return u.val.(TableNameWithIndexList)
}
func (u *sqlSymUnion) indirectElem() IndirectionElem {
	if indirectElem, ok := u.val.(IndirectionElem); ok {
		return indirectElem
	}
	return nil
}
func (u *sqlSymUnion) indirect() Indirection {
	return u.val.(Indirection)
}
func (u *sqlSymUnion) indexHints() *IndexHints {
	return u.val.(*IndexHints)
}
func (u *sqlSymUnion) stmt() Statement {
	if stmt, ok := u.val.(Statement); ok {
		return stmt
	}
	return nil
}
func (u *sqlSymUnion) stmts() []Statement {
	return u.val.([]Statement)
}
func (u *sqlSymUnion) slct() *Select {
	if selectStmt, ok := u.val.(*Select); ok {
		return selectStmt
	}
	return nil
}
func (u *sqlSymUnion) selectStmt() SelectStatement {
	if selectStmt, ok := u.val.(SelectStatement); ok {
		return selectStmt
	}
	return nil
}
func (u *sqlSymUnion) colDef() *ColumnTableDef {
	return u.val.(*ColumnTableDef)
}
func (u *sqlSymUnion) constraintDef() ConstraintTableDef {
	if constraintDef, ok := u.val.(ConstraintTableDef); ok {
		return constraintDef
	}
	return nil
}
func (u *sqlSymUnion) tblDef() TableDef {
	if tblDef, ok := u.val.(TableDef); ok {
		return tblDef
	}
	return nil
}
func (u *sqlSymUnion) tblDefs() TableDefs {
	return u.val.(TableDefs)
}
func (u *sqlSymUnion) colQual() ColumnQualification {
	if colQual, ok := u.val.(ColumnQualification); ok {
		return colQual
	}
	return nil
}
func (u *sqlSymUnion) colQuals() []ColumnQualification {
	return u.val.([]ColumnQualification)
}
func (u *sqlSymUnion) colType() ColumnType {
	if colType, ok := u.val.(ColumnType); ok {
		return colType
	}
	return nil
}
func (u *sqlSymUnion) colTypes() []ColumnType {
	return u.val.([]ColumnType)
}
func (u *sqlSymUnion) expr() Expr {
	if expr, ok := u.val.(Expr); ok {
		return expr
	}
	return nil
}
func (u *sqlSymUnion) exprs() Exprs {
	return u.val.(Exprs)
}
func (u *sqlSymUnion) selExpr() SelectExpr {
	return u.val.(SelectExpr)
}
func (u *sqlSymUnion) selExprs() SelectExprs {
	return u.val.(SelectExprs)
}
func (u *sqlSymUnion) retExprs() ReturningExprs {
	return ReturningExprs(u.val.(SelectExprs))
}
func (u *sqlSymUnion) aliasClause() AliasClause {
	return u.val.(AliasClause)
}
func (u *sqlSymUnion) tblExpr() TableExpr {
	if tblExpr, ok := u.val.(TableExpr); ok {
		return tblExpr
	}
	return nil
}
func (u *sqlSymUnion) tblExprs() TableExprs {
	return u.val.(TableExprs)
}
func (u *sqlSymUnion) joinCond() JoinCond {
	if joinCond, ok := u.val.(JoinCond); ok {
		return joinCond
	}
	return nil
}
func (u *sqlSymUnion) when() *When {
	return u.val.(*When)
}
func (u *sqlSymUnion) whens() []*When {
	return u.val.([]*When)
}
func (u *sqlSymUnion) updateExpr() *UpdateExpr {
	return u.val.(*UpdateExpr)
}
func (u *sqlSymUnion) updateExprs() UpdateExprs {
	return u.val.(UpdateExprs)
}
func (u *sqlSymUnion) limit() *Limit {
	return u.val.(*Limit)
}
func (u *sqlSymUnion) targetList() TargetList {
	return u.val.(TargetList)
}
func (u *sqlSymUnion) targetListPtr() *TargetList {
	return u.val.(*TargetList)
}
func (u *sqlSymUnion) privilegeType() privilege.Kind {
	return u.val.(privilege.Kind)
}
func (u *sqlSymUnion) privilegeList() privilege.List {
	return u.val.(privilege.List)
}
func (u *sqlSymUnion) orderBy() OrderBy {
	return u.val.(OrderBy)
}
func (u *sqlSymUnion) order() *Order {
	return u.val.(*Order)
}
func (u *sqlSymUnion) orders() []*Order {
	return u.val.([]*Order)
}
func (u *sqlSymUnion) groupBy() GroupBy {
	return u.val.(GroupBy)
}
func (u *sqlSymUnion) dir() Direction {
	return u.val.(Direction)
}
func (u *sqlSymUnion) alterTableCmd() AlterTableCmd {
	if alterTableCmd, ok := u.val.(AlterTableCmd); ok {
		return alterTableCmd
	}
	return nil
}
func (u *sqlSymUnion) alterTableCmds() AlterTableCmds {
	return u.val.(AlterTableCmds)
}
func (u *sqlSymUnion) isoLevel() IsolationLevel {
	return u.val.(IsolationLevel)
}
func (u *sqlSymUnion) userPriority() UserPriority {
	return u.val.(UserPriority)
}
func (u *sqlSymUnion) idxElem() IndexElem {
	return u.val.(IndexElem)
}
func (u *sqlSymUnion) idxElems() IndexElemList {
	return u.val.(IndexElemList)
}

//line sql.y:259
type sqlSymType struct {
	yys   int
	id    int
	pos   int
	empty struct{}
	str   string
	union sqlSymUnion
}

const IDENT = 57346
const FCONST = 57347
const SCONST = 57348
const BCONST = 57349
const ICONST = 57350
const PARAM = 57351
const TYPECAST = 57352
const DOT_DOT = 57353
const LESS_EQUALS = 57354
const GREATER_EQUALS = 57355
const NOT_EQUALS = 57356
const ERROR = 57357
const ACTION = 57358
const ADD = 57359
const ALL = 57360
const ALTER = 57361
const ANALYSE = 57362
const ANALYZE = 57363
const AND = 57364
const ANY = 57365
const ARRAY = 57366
const AS = 57367
const ASC = 57368
const ASYMMETRIC = 57369
const AT = 57370
const BEGIN = 57371
const BETWEEN = 57372
const BIGINT = 57373
const BIT = 57374
const BLOB = 57375
const BOOL = 57376
const BOOLEAN = 57377
const BOTH = 57378
const BY = 57379
const BYTEA = 57380
const BYTES = 57381
const CASCADE = 57382
const CASE = 57383
const CAST = 57384
const CHAR = 57385
const CHARACTER = 57386
const CHARACTERISTICS = 57387
const CHECK = 57388
const COALESCE = 57389
const COLLATE = 57390
const COLLATION = 57391
const COLUMN = 57392
const COLUMNS = 57393
const COMMIT = 57394
const COMMITTED = 57395
const CONCAT = 57396
const CONFLICT = 57397
const CONSTRAINT = 57398
const COVERING = 57399
const CREATE = 57400
const CROSS = 57401
const CUBE = 57402
const CURRENT = 57403
const CURRENT_CATALOG = 57404
const CURRENT_DATE = 57405
const CURRENT_ROLE = 57406
const CURRENT_TIME = 57407
const CURRENT_TIMESTAMP = 57408
const CURRENT_USER = 57409
const CYCLE = 57410
const DATA = 57411
const DATABASE = 57412
const DATABASES = 57413
const DATE = 57414
const DAY = 57415
const DEC = 57416
const DECIMAL = 57417
const DEFAULT = 57418
const DEFERRABLE = 57419
const DELETE = 57420
const DESC = 57421
const DISTINCT = 57422
const DO = 57423
const DOUBLE = 57424
const DROP = 57425
const ELSE = 57426
const END = 57427
const ESCAPE = 57428
const EXCEPT = 57429
const EXISTS = 57430
const EXPLAIN = 57431
const EXTRACT = 57432
const FALSE = 57433
const FETCH = 57434
const FILTER = 57435
const FIRST = 57436
const FLOAT = 57437
const FOLLOWING = 57438
const FOR = 57439
const FORCE_INDEX = 57440
const FOREIGN = 57441
const FROM = 57442
const FULL = 57443
const GRANT = 57444
const GRANTS = 57445
const GREATEST = 57446
const GROUP = 57447
const GROUPING = 57448
const HAVING = 57449
const HIGH = 57450
const HOUR = 57451
const IF = 57452
const IFNULL = 57453
const IN = 57454
const INDEX = 57455
const INDEXES = 57456
const INITIALLY = 57457
const INNER = 57458
const INSERT = 57459
const INT = 57460
const INT64 = 57461
const INTEGER = 57462
const INTERSECT = 57463
const INTERVAL = 57464
const INTO = 57465
const IS = 57466
const ISOLATION = 57467
const JOIN = 57468
const KEY = 57469
const KEYS = 57470
const LATERAL = 57471
const LEADING = 57472
const LEAST = 57473
const LEFT = 57474
const LEVEL = 57475
const LIKE = 57476
const LIMIT = 57477
const LOCAL = 57478
const LOCALTIME = 57479
const LOCALTIMESTAMP = 57480
const LOW = 57481
const LSHIFT = 57482
const MATCH = 57483
const MINUTE = 57484
const MONTH = 57485
const NAME = 57486
const NAMES = 57487
const NATURAL = 57488
const NEXT = 57489
const NO = 57490
const NO_INDEX_JOIN = 57491
const NORMAL = 57492
const NOT = 57493
const NOTHING = 57494
const NULL = 57495
const NULLIF = 57496
const NULLS = 57497
const NUMERIC = 57498
const OF = 57499
const OFF = 57500
const OFFSET = 57501
const ON = 57502
const ONLY = 57503
const OR = 57504
const ORDER = 57505
const ORDINALITY = 57506
const OUT = 57507
const OUTER = 57508
const OVER = 57509
const OVERLAPS = 57510
const OVERLAY = 57511
const PARTIAL = 57512
const PARTITION = 57513
const PLACING = 57514
const POSITION = 57515
const PRECEDING = 57516
const PRECISION = 57517
const PRIMARY = 57518
const PRIORITY = 57519
const RANGE = 57520
const READ = 57521
const REAL = 57522
const RECURSIVE = 57523
const REF = 57524
const REFERENCES = 57525
const RENAME = 57526
const REPEATABLE = 57527
const RELEASE = 57528
const RESTRICT = 57529
const RETURNING = 57530
const REVOKE = 57531
const RIGHT = 57532
const ROLLBACK = 57533
const ROLLUP = 57534
const ROW = 57535
const ROWS = 57536
const RSHIFT = 57537
const SAVEPOINT = 57538
const SEARCH = 57539
const SECOND = 57540
const SELECT = 57541
const SERIALIZABLE = 57542
const SESSION = 57543
const SESSION_USER = 57544
const SET = 57545
const SHOW = 57546
const SIMILAR = 57547
const SIMPLE = 57548
const SMALLINT = 57549
const SNAPSHOT = 57550
const SOME = 57551
const SQL = 57552
const START = 57553
const STRICT = 57554
const STRING = 57555
const STORING = 57556
const SUBSTRING = 57557
const SYMMETRIC = 57558
const TABLE = 57559
const TABLES = 57560
const TEXT = 57561
const THEN = 57562
const TIME = 57563
const TIMESTAMP = 57564
const TO = 57565
const TRAILING = 57566
const TRANSACTION = 57567
const TREAT = 57568
const TRIM = 57569
const TRUE = 57570
const TRUNCATE = 57571
const TYPE = 57572
const UNBOUNDED = 57573
const UNCOMMITTED = 57574
const UNION = 57575
const UNIQUE = 57576
const UNKNOWN = 57577
const UPDATE = 57578
const USER = 57579
const USING = 57580
const VALID = 57581
const VALIDATE = 57582
const VALUE = 57583
const VALUES = 57584
const VARCHAR = 57585
const VARIADIC = 57586
const VARYING = 57587
const WHEN = 57588
const WHERE = 57589
const WINDOW = 57590
const WITH = 57591
const WITHIN = 57592
const WITHOUT = 57593
const YEAR = 57594
const ZONE = 57595
const NOT_LA = 57596
const WITH_LA = 57597
const POSTFIXOP = 57598
const UMINUS = 57599

var sqlToknames = [...]string{
	"$end",
	"error",
	"$unk",
	"IDENT",
	"FCONST",
	"SCONST",
	"BCONST",
	"ICONST",
	"PARAM",
	"TYPECAST",
	"DOT_DOT",
	"LESS_EQUALS",
	"GREATER_EQUALS",
	"NOT_EQUALS",
	"ERROR",
	"ACTION",
	"ADD",
	"ALL",
	"ALTER",
	"ANALYSE",
	"ANALYZE",
	"AND",
	"ANY",
	"ARRAY",
	"AS",
	"ASC",
	"ASYMMETRIC",
	"AT",
	"BEGIN",
	"BETWEEN",
	"BIGINT",
	"BIT",
	"BLOB",
	"BOOL",
	"BOOLEAN",
	"BOTH",
	"BY",
	"BYTEA",
	"BYTES",
	"CASCADE",
	"CASE",
	"CAST",
	"CHAR",
	"CHARACTER",
	"CHARACTERISTICS",
	"CHECK",
	"COALESCE",
	"COLLATE",
	"COLLATION",
	"COLUMN",
	"COLUMNS",
	"COMMIT",
	"COMMITTED",
	"CONCAT",
	"CONFLICT",
	"CONSTRAINT",
	"COVERING",
	"CREATE",
	"CROSS",
	"CUBE",
	"CURRENT",
	"CURRENT_CATALOG",
	"CURRENT_DATE",
	"CURRENT_ROLE",
	"CURRENT_TIME",
	"CURRENT_TIMESTAMP",
	"CURRENT_USER",
	"CYCLE",
	"DATA",
	"DATABASE",
	"DATABASES",
	"DATE",
	"DAY",
	"DEC",
	"DECIMAL",
	"DEFAULT",
	"DEFERRABLE",
	"DELETE",
	"DESC",
	"DISTINCT",
	"DO",
	"DOUBLE",
	"DROP",
	"ELSE",
	"END",
	"ESCAPE",
	"EXCEPT",
	"EXISTS",
	"EXPLAIN",
	"EXTRACT",
	"FALSE",
	"FETCH",
	"FILTER",
	"FIRST",
	"FLOAT",
	"FOLLOWING",
	"FOR",
	"FORCE_INDEX",
	"FOREIGN",
	"FROM",
	"FULL",
	"GRANT",
	"GRANTS",
	"GREATEST",
	"GROUP",
	"GROUPING",
	"HAVING",
	"HIGH",
	"HOUR",
	"IF",
	"IFNULL",
	"IN",
	"INDEX",
	"INDEXES",
	"INITIALLY",
	"INNER",
	"INSERT",
	"INT",
	"INT64",
	"INTEGER",
	"INTERSECT",
	"INTERVAL",
	"INTO",
	"IS",
	"ISOLATION",
	"JOIN",
	"KEY",
	"KEYS",
	"LATERAL",
	"LEADING",
	"LEAST",
	"LEFT",
	"LEVEL",
	"LIKE",
	"LIMIT",
	"LOCAL",
	"LOCALTIME",
	"LOCALTIMESTAMP",
	"LOW",
	"LSHIFT",
	"MATCH",
	"MINUTE",
	"MONTH",
	"NAME",
	"NAMES",
	"NATURAL",
	"NEXT",
	"NO",
	"NO_INDEX_JOIN",
	"NORMAL",
	"NOT",
	"NOTHING",
	"NULL",
	"NULLIF",
	"NULLS",
	"NUMERIC",
	"OF",
	"OFF",
	"OFFSET",
	"ON",
	"ONLY",
	"OR",
	"ORDER",
	"ORDINALITY",
	"OUT",
	"OUTER",
	"OVER",
	"OVERLAPS",
	"OVERLAY",
	"PARTIAL",
	"PARTITION",
	"PLACING",
	"POSITION",
	"PRECEDING",
	"PRECISION",
	"PRIMARY",
	"PRIORITY",
	"RANGE",
	"READ",
	"REAL",
	"RECURSIVE",
	"REF",
	"REFERENCES",
	"RENAME",
	"REPEATABLE",
	"RELEASE",
	"RESTRICT",
	"RETURNING",
	"REVOKE",
	"RIGHT",
	"ROLLBACK",
	"ROLLUP",
	"ROW",
	"ROWS",
	"RSHIFT",
	"SAVEPOINT",
	"SEARCH",
	"SECOND",
	"SELECT",
	"SERIALIZABLE",
	"SESSION",
	"SESSION_USER",
	"SET",
	"SHOW",
	"SIMILAR",
	"SIMPLE",
	"SMALLINT",
	"SNAPSHOT",
	"SOME",
	"SQL",
	"START",
	"STRICT",
	"STRING",
	"STORING",
	"SUBSTRING",
	"SYMMETRIC",
	"TABLE",
	"TABLES",
	"TEXT",
	"THEN",
	"TIME",
	"TIMESTAMP",
	"TO",
	"TRAILING",
	"TRANSACTION",
	"TREAT",
	"TRIM",
	"TRUE",
	"TRUNCATE",
	"TYPE",
	"UNBOUNDED",
	"UNCOMMITTED",
	"UNION",
	"UNIQUE",
	"UNKNOWN",
	"UPDATE",
	"USER",
	"USING",
	"VALID",
	"VALIDATE",
	"VALUE",
	"VALUES",
	"VARCHAR",
	"VARIADIC",
	"VARYING",
	"WHEN",
	"WHERE",
	"WINDOW",
	"WITH",
	"WITHIN",
	"WITHOUT",
	"YEAR",
	"ZONE",
	"NOT_LA",
	"WITH_LA",
	"'<'",
	"'>'",
	"'='",
	"POSTFIXOP",
	"'|'",
	"'^'",
	"'#'",
	"'&'",
	"'+'",
	"'-'",
	"'*'",
	"'/'",
	"'%'",
	"UMINUS",
	"'~'",
	"'['",
	"']'",
	"'('",
	"')'",
	"'.'",
	"';'",
	"','",
	"'@'",
	"'{'",
	"'}'",
	"':'",
}
var sqlStatenames = [...]string{}

const sqlEofCode = 1
const sqlErrCode = 2
const sqlInitialStackSize = 16

//line sql.y:4216

//line yacctab:1
var sqlExca = [...]int{
	-1, 0,
	1, 21,
	276, 21,
	-2, 318,
	-1, 1,
	1, -1,
	-2, 0,
	-1, 32,
	1, 289,
	160, 289,
	188, 289,
	274, 289,
	276, 289,
	-2, 299,
	-1, 44,
	1, 292,
	160, 292,
	188, 292,
	274, 292,
	276, 292,
	-2, 298,
	-1, 53,
	1, 21,
	276, 21,
	-2, 318,
	-1, 237,
	1, 138,
	276, 138,
	-2, 788,
	-1, 268,
	135, 328,
	159, 328,
	-2, 295,
	-1, 271,
	135, 327,
	159, 327,
	-2, 293,
	-1, 381,
	135, 327,
	159, 327,
	-2, 296,
	-1, 437,
	273, 733,
	-2, 728,
	-1, 438,
	273, 734,
	-2, 729,
	-1, 444,
	6, 454,
	273, 454,
	-2, 869,
	-1, 466,
	6, 424,
	-2, 846,
	-1, 467,
	6, 451,
	273, 451,
	-2, 847,
	-1, 468,
	6, 432,
	-2, 848,
	-1, 469,
	6, 431,
	-2, 849,
	-1, 470,
	6, 451,
	273, 451,
	-2, 852,
	-1, 471,
	6, 451,
	273, 451,
	-2, 853,
	-1, 472,
	6, 452,
	-2, 856,
	-1, 473,
	6, 419,
	-2, 857,
	-1, 474,
	6, 419,
	-2, 858,
	-1, 475,
	6, 434,
	-2, 861,
	-1, 476,
	6, 420,
	-2, 866,
	-1, 477,
	6, 421,
	-2, 867,
	-1, 478,
	6, 422,
	-2, 868,
	-1, 479,
	6, 419,
	-2, 872,
	-1, 480,
	6, 425,
	-2, 877,
	-1, 481,
	6, 423,
	-2, 879,
	-1, 482,
	6, 453,
	-2, 883,
	-1, 483,
	6, 449,
	273, 449,
	-2, 887,
	-1, 741,
	87, 299,
	121, 299,
	135, 299,
	159, 299,
	163, 299,
	233, 299,
	-2, 556,
	-1, 749,
	273, 713,
	-2, 702,
	-1, 943,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 487,
	-1, 944,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 488,
	-1, 945,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 489,
	-1, 949,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 493,
	-1, 950,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 494,
	-1, 951,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 495,
	-1, 954,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 500,
	-1, 985,
	168, 626,
	-2, 629,
	-1, 1137,
	87, 299,
	121, 299,
	135, 299,
	159, 299,
	163, 299,
	233, 299,
	-2, 376,
	-1, 1145,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 501,
	-1, 1150,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 502,
	-1, 1169,
	168, 625,
	-2, 628,
	-1, 1312,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 503,
	-1, 1317,
	124, 0,
	-2, 513,
	-1, 1326,
	168, 627,
	-2, 630,
	-1, 1366,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 537,
	-1, 1367,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 538,
	-1, 1368,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 539,
	-1, 1372,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 543,
	-1, 1373,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 544,
	-1, 1374,
	12, 0,
	13, 0,
	14, 0,
	256, 0,
	257, 0,
	258, 0,
	-2, 545,
	-1, 1472,
	124, 0,
	-2, 514,
	-1, 1476,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 517,
	-1, 1477,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 519,
	-1, 1559,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 518,
	-1, 1560,
	30, 0,
	112, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 520,
	-1, 1568,
	124, 0,
	-2, 546,
	-1, 1607,
	124, 0,
	-2, 547,
	-1, 1652,
	30, 0,
	134, 0,
	205, 0,
	254, 0,
	-2, 845,
}

const sqlNprod = 979
const sqlPrivate = 57344

var sqlTokenNames []string
var sqlStates []string

const sqlLast = 20152

var sqlAct = [...]int{

	982, 1672, 1651, 1513, 1634, 1612, 1635, 1650, 1636, 827,
	883, 1576, 1346, 272, 1546, 1460, 1535, 436, 435, 428,
	1436, 86, 579, 1437, 1318, 238, 1454, 820, 496, 1404,
	744, 294, 1448, 1227, 1134, 1081, 524, 867, 277, 31,
	998, 870, 1133, 1172, 1289, 1226, 746, 484, 1298, 869,
	892, 502, 14, 679, 1319, 1124, 828, 400, 796, 699,
	805, 1120, 1037, 1002, 970, 775, 31, 967, 992, 895,
	279, 43, 779, 552, 537, 701, 20, 10, 695, 1086,
	65, 507, 505, 369, 401, 410, 320, 370, 314, 271,
	6, 497, 31, 498, 312, 309, 862, 534, 43, 282,
	44, 316, 563, 872, 67, 66, 45, 63, 384, 235,
	554, 81, 321, 533, 893, 550, 385, 72, 68, 383,
	311, 305, 1552, 280, 43, 1553, 821, 526, 995, 825,
	526, 1648, 1642, 1641, 1534, 887, 887, 1633, 1628, 1132,
	1475, 887, 276, 1609, 269, 1603, 1475, 1165, 887, 1598,
	268, 1595, 261, 49, 1534, 1586, 1091, 1561, 1534, 703,
	1475, 276, 1040, 703, 996, 1556, 290, 317, 887, 297,
	1543, 51, 284, 1534, 306, 516, 1199, 300, 1215, 1216,
	1217, 1533, 1518, 1517, 1534, 887, 887, 1498, 1478, 1474,
	1165, 1165, 1475, 1537, 702, 1167, 52, 997, 994, 1414,
	1168, 1322, 887, 47, 1165, 1280, 1379, 1275, 1276, 48,
	1276, 1244, 1242, 1241, 1245, 1165, 1165, 1325, 1240, 1169,
	1212, 1165, 1165, 1166, 1104, 794, 888, 46, 1165, 887,
	793, 531, 1122, 792, 532, 1106, 887, 842, 529, 978,
	499, 49, 882, 395, 500, 856, 1431, 396, 673, 672,
	544, 543, 49, 999, 337, 289, 1171, 388, 499, 51,
	49, 704, 500, 722, 723, 724, 53, 500, 578, 356,
	51, 1649, 975, 725, 527, 1165, 1647, 527, 51, 706,
	1604, 731, 382, 1542, 52, 1503, 402, 402, 1499, 1491,
	376, 47, 1490, 1485, 1484, 52, 503, 48, 1483, 705,
	1482, 1469, 47, 52, 1394, 719, 1213, 993, 48, 1389,
	1388, 1387, 381, 1329, 1307, 64, 344, 1288, 1247, 430,
	345, 491, 1246, 1234, 495, 1225, 824, 752, 1143, 368,
	1198, 1195, 1193, 1577, 46, 1348, 1091, 1108, 1182, 1176,
	702, 1105, 1052, 1009, 490, 1008, 395, 394, 1597, 1578,
	1570, 1549, 976, 1540, 1532, 1510, 1496, 1463, 1444, 1430,
	1558, 1214, 1316, 732, 525, 1306, 1286, 676, 1285, 1283,
	320, 320, 373, 1467, 1259, 730, 1258, 375, 582, 1224,
	269, 1190, 1189, 1181, 1162, 727, 268, 687, 689, 1158,
	972, 720, 780, 783, 696, 1066, 321, 321, 1065, 1047,
	1007, 704, 886, 486, 583, 397, 735, 736, 737, 738,
	739, 675, 1199, 726, 785, 742, 499, 773, 306, 706,
	500, 772, 1209, 1210, 1211, 517, 1208, 1205, 1206, 1207,
	1200, 1201, 1202, 1203, 1204, 755, 771, 770, 769, 705,
	768, 767, 766, 765, 1199, 719, 721, 764, 704, 763,
	762, 761, 541, 760, 749, 540, 729, 759, 750, 748,
	46, 677, 574, 295, 399, 567, 706, 663, 1557, 747,
	667, 668, 669, 666, 670, 1309, 1308, 492, 1554, 1199,
	1435, 1092, 350, 1144, 674, 365, 705, 1199, 1212, 269,
	351, 757, 269, 269, 685, 691, 697, 1066, 692, 693,
	789, 684, 683, 1449, 821, 728, 1349, 716, 717, 718,
	1003, 715, 712, 713, 714, 707, 708, 709, 710, 711,
	776, 1185, 582, 790, 788, 1088, 1618, 508, 1500, 509,
	1662, 720, 391, 392, 1661, 1422, 777, 778, 260, 848,
	259, 254, 1213, 266, 255, 1526, 1525, 781, 583, 704,
	799, 1100, 784, 1271, 320, 837, 314, 31, 438, 1585,
	1251, 1250, 1180, 806, 229, 1179, 786, 706, 810, 812,
	31, 823, 1178, 704, 1213, 1177, 798, 743, 1199, 1146,
	321, 959, 1270, 841, 65, 371, 721, 705, 263, 85,
	817, 706, 85, 510, 753, 816, 844, 1214, 372, 85,
	582, 861, 43, 969, 933, 348, 85, 85, 67, 66,
	85, 705, 802, 85, 85, 85, 809, 1213, 85, 85,
	85, 85, 68, 319, 836, 838, 583, 815, 850, 1214,
	845, 849, 846, 843, 840, 317, 818, 1466, 485, 839,
	349, 85, 798, 1584, 1620, 1261, 835, 520, 797, 999,
	57, 715, 712, 713, 714, 707, 708, 709, 710, 711,
	1630, 1669, 1208, 1205, 1206, 1207, 1200, 1201, 1202, 1203,
	1204, 573, 1214, 880, 881, 1082, 1631, 969, 1080, 720,
	572, 560, 571, 1003, 565, 1515, 514, 513, 1661, 58,
	264, 1579, 1101, 808, 1208, 1205, 1206, 1207, 1200, 1201,
	1202, 1203, 1204, 402, 709, 710, 711, 267, 934, 935,
	936, 937, 938, 939, 940, 941, 942, 943, 944, 945,
	946, 947, 948, 949, 950, 951, 952, 953, 954, 889,
	1099, 932, 1013, 404, 721, 1202, 1203, 1204, 1205, 1206,
	1207, 1200, 1201, 1202, 1203, 1204, 526, 1638, 275, 1268,
	511, 807, 575, 1338, 347, 582, 973, 865, 346, 897,
	864, 704, 1010, 774, 1021, 1262, 1031, 1033, 1038, 1041,
	1042, 1043, 1566, 788, 740, 508, 1188, 509, 788, 706,
	1299, 583, 274, 508, 1199, 509, 276, 890, 387, 85,
	85, 866, 1148, 503, 983, 340, 342, 1637, 577, 705,
	443, 1016, 714, 707, 708, 709, 710, 711, 59, 999,
	347, 1668, 576, 1660, 1051, 795, 1639, 488, 995, 85,
	1335, 85, 1083, 85, 276, 85, 974, 707, 708, 709,
	710, 711, 1200, 1201, 1202, 1203, 1204, 1017, 60, 852,
	85, 510, 1516, 1061, 1055, 854, 704, 55, 1658, 510,
	487, 85, 1640, 1336, 996, 1447, 1085, 876, 1063, 359,
	855, 386, 85, 85, 706, 85, 968, 338, 853, 957,
	1018, 1015, 366, 1094, 336, 1199, 1056, 1375, 320, 1334,
	1675, 61, 1494, 696, 705, 387, 1520, 997, 994, 1667,
	56, 720, 1519, 527, 273, 85, 1508, 85, 1076, 1421,
	440, 1109, 1461, 1090, 321, 1682, 1420, 319, 319, 999,
	979, 984, 1093, 987, 1213, 581, 85, 1096, 85, 85,
	85, 85, 1253, 85, 367, 31, 1019, 1107, 1032, 1103,
	1102, 85, 1098, 1060, 1044, 1045, 1046, 85, 1095, 1115,
	566, 561, 1077, 999, 1097, 1418, 721, 1139, 1376, 877,
	506, 958, 682, 1462, 1377, 85, 1145, 43, 85, 1495,
	1150, 1113, 678, 1117, 1116, 1613, 1138, 386, 1127, 1214,
	671, 545, 1142, 955, 1509, 1068, 720, 1118, 1067, 1164,
	1014, 1419, 1681, 1130, 1457, 62, 70, 1294, 1673, 1173,
	781, 1123, 784, 1297, 54, 778, 777, 993, 511, 1128,
	1293, 1170, 346, 549, 1186, 1213, 511, 304, 1191, 274,
	378, 715, 712, 713, 714, 707, 708, 709, 710, 711,
	1417, 1290, 1121, 1149, 903, 1147, 73, 1674, 1006, 742,
	1569, 721, 1229, 1127, 547, 1038, 1038, 1038, 1200, 1201,
	1202, 1203, 1204, 1676, 956, 548, 78, 1493, 1130, 1228,
	1023, 74, 1315, 85, 1194, 1249, 1157, 1129, 1125, 581,
	1214, 1155, 847, 364, 1128, 1184, 1256, 85, 758, 362,
	75, 85, 1153, 361, 85, 85, 360, 357, 1126, 85,
	303, 85, 85, 402, 85, 77, 665, 85, 85, 85,
	1005, 319, 1456, 503, 85, 85, 1401, 1231, 1232, 1233,
	707, 708, 709, 710, 711, 1266, 1264, 1252, 923, 1265,
	1111, 1267, 878, 1248, 875, 530, 528, 523, 1277, 515,
	1273, 690, 1129, 903, 512, 1255, 1257, 1343, 1207, 1200,
	1201, 1202, 1203, 1204, 1151, 1161, 1269, 581, 1156, 1163,
	1272, 1527, 1662, 389, 1279, 1311, 287, 1312, 1278, 569,
	884, 798, 1174, 1175, 582, 1303, 1282, 813, 1317, 798,
	1529, 814, 1284, 353, 3, 811, 1327, 76, 1274, 1537,
	1455, 1581, 1327, 1292, 1302, 704, 1295, 1300, 1301, 704,
	583, 1606, 1296, 1291, 253, 1599, 1344, 1331, 1332, 1333,
	393, 1223, 826, 706, 1141, 1353, 698, 542, 1355, 1123,
	1679, 1680, 1236, 885, 79, 390, 73, 923, 288, 1152,
	1199, 704, 1468, 705, 69, 1328, 1154, 705, 296, 1337,
	1339, 1340, 256, 257, 85, 857, 78, 423, 858, 1384,
	1385, 74, 1395, 354, 1350, 85, 85, 1341, 1391, 1392,
	1393, 1127, 1354, 1310, 80, 1243, 1050, 1352, 1049, 1048,
	75, 1000, 859, 1480, 1356, 1342, 1130, 860, 83, 751,
	1382, 239, 85, 262, 85, 77, 1125, 1514, 83, 71,
	664, 358, 1128, 1383, 1487, 283, 283, 411, 1629, 293,
	1187, 1565, 293, 299, 293, 1386, 1126, 293, 307, 293,
	239, 1450, 581, 1396, 1400, 1545, 1004, 756, 25, 1439,
	416, 1442, 1441, 1443, 1442, 1441, 1443, 1446, 1402, 1254,
	339, 871, 584, 1434, 31, 570, 1472, 559, 1415, 1416,
	439, 1476, 1477, 1445, 363, 1323, 1479, 553, 1432, 291,
	1129, 1481, 291, 562, 302, 1012, 489, 291, 441, 302,
	900, 1473, 1465, 922, 1452, 1453, 1486, 76, 1458, 442,
	1489, 965, 901, 782, 85, 85, 85, 429, 898, 315,
	85, 829, 963, 85, 1001, 1183, 1464, 754, 415, 85,
	85, 85, 85, 85, 421, 85, 85, 420, 980, 412,
	1497, 1459, 1131, 85, 79, 85, 343, 1380, 1492, 233,
	234, 85, 1084, 1429, 822, 879, 686, 1263, 1390, 265,
	85, 85, 1196, 1030, 1022, 1020, 85, 1011, 374, 501,
	830, 355, 891, 1140, 398, 319, 694, 286, 285, 868,
	352, 1521, 961, 546, 960, 851, 518, 258, 966, 1504,
	1580, 1507, 85, 1617, 85, 85, 1260, 85, 50, 19,
	17, 1539, 922, 1505, 16, 15, 85, 13, 1442, 1441,
	1443, 1528, 12, 85, 1451, 85, 1538, 1550, 239, 239,
	1523, 1524, 1442, 1441, 1443, 1541, 11, 1530, 18, 1536,
	1114, 1559, 1560, 9, 8, 7, 24, 1522, 903, 23,
	1548, 22, 5, 4, 2, 1, 0, 0, 83, 0,
	293, 0, 239, 0, 379, 1564, 0, 0, 1024, 962,
	0, 1573, 0, 0, 0, 902, 964, 0, 1551, 283,
	0, 1575, 903, 0, 0, 0, 0, 0, 0, 903,
	293, 1571, 925, 1555, 0, 0, 0, 0, 0, 0,
	1562, 293, 293, 503, 521, 0, 1574, 1588, 0, 0,
	291, 1410, 0, 1405, 0, 0, 1590, 1596, 0, 1592,
	903, 1403, 1442, 1441, 1443, 924, 0, 0, 1589, 0,
	0, 0, 923, 1591, 538, 788, 538, 0, 1601, 0,
	493, 1411, 0, 0, 0, 0, 582, 1602, 0, 1605,
	0, 291, 519, 0, 0, 239, 0, 538, 239, 239,
	239, 0, 239, 1410, 0, 1608, 923, 0, 0, 1624,
	83, 0, 583, 923, 902, 899, 681, 1619, 1623, 1600,
	1622, 0, 1627, 1626, 1621, 1442, 1441, 1443, 1625, 1644,
	0, 925, 0, 1411, 283, 85, 0, 700, 1643, 0,
	1645, 1655, 1655, 1646, 923, 0, 903, 1614, 1615, 1656,
	0, 0, 0, 1659, 1657, 0, 1406, 0, 1407, 1663,
	85, 0, 1665, 1655, 924, 1666, 0, 0, 0, 0,
	0, 0, 0, 85, 1677, 85, 0, 85, 1678, 0,
	85, 1409, 1199, 1664, 1215, 1216, 1217, 0, 1412, 0,
	1655, 85, 1683, 0, 85, 0, 0, 0, 0, 0,
	85, 581, 0, 0, 85, 0, 85, 0, 1406, 0,
	1407, 1024, 1024, 1594, 899, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 1212, 0, 0, 0,
	923, 0, 293, 1409, 0, 0, 0, 0, 0, 1408,
	1412, 0, 0, 0, 0, 0, 803, 0, 0, 0,
	293, 0, 903, 293, 819, 0, 0, 85, 293, 0,
	833, 834, 0, 293, 0, 0, 293, 239, 239, 1024,
	1024, 1024, 0, 538, 700, 0, 0, 0, 0, 1632,
	0, 0, 787, 0, 1219, 241, 0, 0, 0, 0,
	0, 1408, 0, 0, 0, 0, 1218, 0, 0, 252,
	291, 0, 0, 302, 0, 903, 0, 922, 831, 0,
	0, 0, 1213, 302, 0, 0, 302, 0, 0, 85,
	85, 85, 0, 0, 0, 0, 903, 85, 85, 0,
	0, 0, 243, 85, 0, 85, 923, 85, 85, 85,
	85, 922, 0, 0, 0, 85, 0, 0, 922, 0,
	0, 242, 244, 0, 85, 0, 0, 0, 0, 0,
	0, 0, 85, 85, 0, 0, 85, 1214, 0, 0,
	0, 0, 0, 0, 0, 85, 85, 0, 0, 922,
	0, 0, 0, 0, 245, 0, 0, 0, 0, 923,
	0, 1024, 1024, 0, 246, 247, 0, 0, 0, 0,
	903, 0, 0, 863, 0, 0, 0, 0, 0, 248,
	923, 0, 0, 0, 293, 803, 0, 85, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 1209, 1210,
	1211, 0, 1208, 1205, 1206, 1207, 1200, 1201, 1202, 1203,
	1204, 293, 0, 239, 1024, 1024, 1024, 1024, 1024, 1024,
	1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
	1024, 1024, 0, 1024, 291, 922, 0, 0, 0, 902,
	85, 0, 85, 0, 85, 0, 0, 0, 0, 0,
	0, 85, 0, 0, 923, 0, 925, 704, 0, 0,
	0, 291, 0, 0, 0, 0, 0, 0, 0, 249,
	0, 0, 250, 902, 0, 706, 251, 0, 0, 0,
	902, 0, 0, 0, 0, 0, 85, 0, 85, 924,
	925, 0, 0, 0, 0, 705, 85, 925, 1159, 1160,
	0, 0, 85, 293, 1058, 1059, 0, 0, 0, 803,
	0, 902, 1064, 0, 0, 0, 0, 0, 1069, 1070,
	1072, 1074, 1075, 924, 1078, 1079, 0, 0, 925, 0,
	924, 0, 293, 0, 1089, 0, 0, 0, 0, 899,
	293, 922, 0, 0, 0, 0, 0, 0, 0, 863,
	538, 0, 0, 1057, 0, 863, 1220, 1221, 1222, 0,
	0, 924, 0, 0, 85, 85, 0, 0, 85, 0,
	0, 0, 0, 899, 0, 0, 85, 0, 0, 0,
	899, 681, 1087, 239, 293, 0, 1112, 720, 85, 0,
	1087, 0, 0, 581, 922, 1119, 0, 902, 0, 0,
	0, 0, 1136, 0, 293, 0, 0, 0, 0, 0,
	0, 899, 0, 0, 925, 922, 85, 85, 85, 0,
	85, 0, 0, 0, 0, 1024, 0, 417, 32, 0,
	0, 0, 0, 0, 1110, 0, 0, 85, 0, 0,
	0, 0, 721, 0, 0, 0, 0, 924, 0, 0,
	0, 0, 0, 0, 291, 32, 0, 0, 0, 85,
	0, 0, 704, 0, 722, 723, 724, 0, 0, 0,
	0, 270, 0, 0, 278, 0, 0, 0, 1313, 1314,
	706, 32, 731, 0, 0, 0, 0, 0, 0, 922,
	0, 0, 278, 0, 0, 0, 0, 899, 0, 0,
	705, 0, 0, 902, 0, 0, 719, 1024, 712, 713,
	714, 707, 708, 709, 710, 711, 0, 0, 0, 0,
	925, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365,
	1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 0,
	1378, 0, 0, 924, 0, 0, 902, 0, 0, 0,
	0, 0, 0, 0, 732, 0, 0, 0, 0, 0,
	0, 0, 0, 925, 700, 0, 730, 902, 0, 0,
	0, 0, 0, 1024, 0, 0, 727, 0, 0, 0,
	0, 0, 720, 0, 925, 0, 0, 0, 0, 293,
	0, 0, 0, 899, 0, 0, 924, 0, 0, 0,
	0, 0, 1281, 0, 803, 0, 681, 0, 0, 1287,
	0, 0, 0, 0, 0, 0, 0, 924, 0, 0,
	293, 0, 704, 293, 722, 723, 724, 0, 0, 1136,
	0, 0, 0, 1305, 725, 1136, 0, 721, 0, 831,
	706, 902, 731, 0, 0, 0, 899, 729, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 925, 0,
	705, 0, 0, 0, 0, 0, 719, 899, 0, 0,
	291, 0, 0, 291, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 1347, 0, 0, 0,
	0, 924, 0, 0, 0, 0, 728, 270, 716, 717,
	718, 0, 715, 712, 713, 714, 707, 708, 709, 710,
	711, 0, 0, 0, 0, 0, 0, 1199, 0, 1215,
	1216, 1217, 0, 0, 732, 0, 0, 0, 0, 1471,
	0, 0, 1511, 0, 0, 704, 730, 722, 723, 724,
	0, 899, 0, 0, 0, 0, 727, 725, 1398, 1399,
	803, 0, 720, 706, 0, 731, 700, 700, 0, 0,
	0, 1212, 1423, 0, 1424, 0, 293, 1426, 1427, 1428,
	0, 0, 0, 705, 293, 0, 0, 0, 0, 719,
	0, 1438, 0, 803, 1438, 0, 0, 0, 0, 0,
	0, 293, 293, 0, 0, 293, 0, 0, 0, 0,
	0, 0, 0, 0, 700, 1136, 270, 721, 0, 270,
	270, 0, 0, 0, 1568, 0, 1425, 729, 0, 0,
	0, 0, 0, 0, 1433, 0, 0, 0, 0, 0,
	0, 1218, 741, 0, 0, 0, 745, 732, 0, 0,
	0, 291, 291, 0, 0, 291, 1488, 1213, 0, 730,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 727,
	0, 21, 0, 0, 0, 720, 728, 0, 716, 717,
	718, 35, 715, 712, 713, 714, 707, 708, 709, 710,
	711, 0, 1199, 0, 1215, 1216, 1217, 726, 0, 0,
	1607, 0, 0, 0, 37, 0, 0, 0, 0, 803,
	42, 1506, 1214, 239, 0, 0, 0, 0, 0, 0,
	293, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	721, 0, 0, 0, 0, 26, 1212, 38, 1438, 0,
	729, 27, 0, 0, 0, 0, 32, 0, 0, 0,
	0, 0, 1438, 0, 28, 293, 0, 1547, 0, 32,
	0, 0, 0, 0, 0, 293, 0, 0, 0, 0,
	1512, 700, 0, 1209, 1210, 1211, 0, 1208, 1205, 1206,
	1207, 1200, 1201, 1202, 1203, 1204, 0, 0, 0, 728,
	0, 716, 717, 718, 0, 715, 712, 713, 714, 707,
	708, 709, 710, 711, 0, 1544, 1218, 1053, 0, 0,
	0, 0, 0, 0, 0, 291, 1054, 0, 0, 0,
	0, 0, 1213, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1582, 1583, 0, 0, 1587, 40, 0,
	0, 29, 1438, 39, 0, 239, 0, 0, 30, 0,
	0, 49, 0, 0, 0, 33, 34, 700, 0, 0,
	0, 0, 0, 36, 0, 0, 0, 0, 0, 51,
	0, 0, 0, 0, 0, 0, 0, 1214, 0, 0,
	0, 41, 0, 0, 0, 700, 700, 293, 0, 239,
	0, 0, 0, 0, 52, 0, 0, 0, 0, 0,
	0, 47, 0, 0, 0, 1438, 1547, 48, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 46, 0, 0, 293, 0,
	0, 894, 0, 0, 0, 0, 0, 1616, 1209, 1210,
	1211, 0, 1208, 1205, 1206, 1207, 1200, 1201, 1202, 1203,
	1204, 0, 0, 0, 0, 0, 437, 0, 0, 0,
	971, 0, 0, 0, 0, 0, 0, 0, 87, 88,
	0, 89, 0, 0, 0, 0, 0, 0, 831, 0,
	90, 91, 186, 187, 188, 92, 189, 190, 0, 93,
	191, 192, 94, 0, 452, 193, 194, 195, 0, 462,
	0, 445, 0, 95, 96, 97, 0, 98, 0, 99,
	0, 324, 100, 101, 0, 446, 448, 0, 447, 449,
	102, 103, 104, 105, 197, 106, 198, 199, 0, 0,
	107, 0, 0, 0, 108, 109, 0, 0, 0, 0,
	200, 110, 453, 0, 0, 111, 112, 202, 113, 0,
	114, 0, 278, 325, 0, 115, 463, 0, 204, 0,
	116, 117, 459, 461, 0, 0, 118, 0, 326, 119,
	207, 208, 209, 0, 210, 0, 327, 120, 328, 121,
	122, 0, 0, 464, 329, 123, 330, 0, 124, 0,
	0, 125, 0, 126, 127, 128, 129, 130, 331, 131,
	132, 135, 133, 0, 134, 0, 460, 136, 213, 137,
	138, 0, 0, 0, 32, 0, 139, 214, 332, 140,
	333, 454, 141, 142, 1137, 455, 143, 217, 0, 144,
	145, 146, 218, 147, 148, 0, 150, 151, 149, 152,
	0, 153, 334, 154, 155, 219, 156, 0, 240, 157,
	158, 0, 159, 160, 450, 161, 162, 335, 163, 220,
	164, 0, 165, 166, 168, 221, 167, 456, 0, 0,
	169, 170, 0, 223, 224, 0, 0, 171, 457, 458,
	0, 172, 173, 174, 175, 0, 971, 176, 177, 451,
	0, 178, 179, 180, 227, 228, 0, 181, 0, 0,
	741, 0, 182, 183, 184, 185, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 1440, 0, 0, 0, 0,
	0, 0, 0, 437, 425, 426, 427, 424, 413, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 0, 419, 0, 0, 741, 90, 91, 0,
	466, 467, 92, 468, 469, 0, 93, 191, 192, 94,
	434, 452, 470, 471, 195, 0, 462, 0, 445, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	1654, 0, 446, 448, 0, 447, 449, 102, 103, 104,
	105, 472, 106, 473, 474, 0, 0, 107, 0, 0,
	0, 465, 109, 0, 0, 0, 0, 418, 110, 453,
	432, 0, 111, 112, 475, 113, 0, 114, 0, 0,
	325, 0, 115, 463, 0, 204, 0, 116, 117, 459,
	461, 0, 0, 118, 0, 326, 119, 476, 477, 478,
	894, 444, 0, 894, 120, 328, 121, 122, 0, 0,
	464, 329, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	408, 134, 433, 460, 136, 479, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 332, 140, 333, 454, 141,
	142, 0, 455, 143, 217, 0, 144, 145, 146, 480,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 422, 156, 0, 240, 157, 158, 0, 159,
	160, 450, 161, 162, 0, 163, 481, 164, 0, 165,
	166, 168, 221, 167, 456, 0, 0, 169, 170, 0,
	223, 482, 0, 0, 171, 457, 458, 431, 172, 173,
	1653, 175, 0, 0, 176, 177, 451, 0, 178, 179,
	180, 227, 483, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 405, 406, 0, 0, 0, 0, 407,
	0, 0, 414, 32, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 894, 894, 0, 0, 894, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1531, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 580, 0,
	0, 0, 0, 0, 0, 894, 0, 0, 0, 0,
	87, 88, 585, 89, 586, 587, 588, 589, 590, 591,
	592, 593, 90, 91, 186, 187, 188, 92, 189, 190,
	594, 93, 191, 192, 94, 595, 596, 193, 194, 195,
	597, 196, 598, 323, 599, 95, 96, 97, 0, 98,
	600, 99, 601, 324, 100, 101, 602, 603, 604, 605,
	606, 607, 102, 103, 104, 105, 197, 106, 198, 199,
	608, 609, 107, 610, 611, 612, 108, 109, 613, 614,
	741, 615, 200, 110, 201, 616, 617, 111, 112, 202,
	113, 618, 114, 619, 620, 325, 621, 115, 203, 622,
	204, 623, 116, 117, 205, 206, 624, 625, 118, 626,
	326, 119, 207, 208, 209, 627, 210, 628, 327, 120,
	328, 121, 122, 629, 630, 211, 329, 123, 330, 631,
	124, 632, 633, 125, 0, 126, 127, 128, 129, 130,
	331, 131, 132, 135, 133, 634, 134, 635, 212, 136,
	213, 137, 138, 636, 637, 638, 639, 640, 139, 214,
	332, 140, 333, 215, 141, 142, 641, 216, 143, 217,
	642, 144, 145, 146, 218, 147, 148, 643, 150, 151,
	149, 152, 644, 153, 334, 154, 155, 219, 156, 0,
	240, 157, 158, 645, 159, 160, 646, 161, 162, 335,
	163, 220, 164, 647, 165, 166, 168, 221, 167, 222,
	648, 649, 169, 170, 650, 223, 224, 651, 652, 171,
	225, 226, 653, 172, 173, 174, 175, 654, 655, 176,
	177, 656, 657, 178, 179, 180, 227, 228, 658, 181,
	659, 660, 661, 662, 182, 183, 184, 185, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 580, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1304, 87, 88, 585, 89, 586, 587,
	588, 589, 590, 591, 592, 593, 90, 91, 186, 187,
	188, 92, 189, 190, 594, 93, 191, 192, 94, 595,
	596, 193, 194, 195, 597, 196, 598, 323, 599, 95,
	96, 97, 0, 98, 600, 99, 601, 324, 100, 101,
	602, 603, 604, 605, 606, 607, 102, 103, 104, 105,
	197, 106, 198, 199, 608, 609, 107, 610, 611, 612,
	108, 109, 613, 614, 0, 615, 200, 110, 201, 616,
	617, 111, 112, 202, 113, 618, 114, 619, 620, 325,
	621, 115, 203, 622, 204, 623, 116, 117, 205, 206,
	624, 625, 118, 626, 326, 119, 207, 208, 209, 627,
	210, 628, 327, 120, 328, 121, 122, 629, 630, 211,
	329, 123, 330, 631, 124, 632, 633, 125, 0, 126,
	127, 128, 129, 130, 331, 131, 132, 135, 133, 634,
	134, 635, 212, 136, 213, 137, 138, 636, 637, 638,
	639, 640, 139, 214, 332, 140, 333, 215, 141, 142,
	641, 216, 143, 217, 642, 144, 145, 146, 218, 147,
	148, 643, 150, 151, 149, 152, 644, 153, 334, 154,
	155, 219, 156, 0, 240, 157, 158, 645, 159, 160,
	646, 161, 162, 335, 163, 220, 164, 647, 165, 166,
	168, 221, 167, 222, 648, 649, 169, 170, 650, 223,
	224, 651, 652, 171, 225, 226, 653, 172, 173, 174,
	175, 654, 655, 176, 177, 656, 657, 178, 179, 180,
	227, 228, 658, 181, 659, 660, 661, 662, 182, 183,
	184, 185, 0, 580, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 791, 87, 88, 585, 89, 586,
	587, 588, 589, 590, 591, 592, 593, 90, 91, 186,
	187, 188, 92, 189, 190, 594, 93, 191, 192, 94,
	595, 596, 193, 194, 195, 597, 196, 598, 323, 599,
	95, 96, 97, 0, 98, 600, 99, 601, 324, 100,
	101, 602, 603, 604, 605, 606, 607, 102, 103, 104,
	105, 197, 106, 198, 199, 608, 609, 107, 610, 611,
	612, 108, 109, 613, 614, 0, 615, 200, 110, 201,
	616, 617, 111, 112, 202, 113, 618, 114, 619, 620,
	325, 621, 115, 203, 622, 204, 623, 116, 117, 205,
	206, 624, 625, 118, 626, 326, 119, 207, 208, 209,
	627, 210, 628, 327, 120, 328, 121, 122, 629, 630,
	211, 329, 123, 330, 631, 124, 632, 633, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	634, 134, 635, 212, 136, 213, 137, 138, 636, 637,
	638, 639, 640, 139, 214, 332, 140, 333, 215, 141,
	142, 641, 216, 143, 217, 642, 144, 145, 146, 218,
	147, 148, 643, 150, 151, 149, 152, 644, 153, 334,
	154, 155, 219, 156, 0, 240, 157, 158, 645, 159,
	160, 646, 161, 162, 335, 163, 220, 164, 647, 165,
	166, 168, 221, 167, 222, 648, 649, 169, 170, 650,
	223, 224, 651, 652, 171, 225, 226, 653, 172, 173,
	174, 175, 654, 655, 176, 177, 656, 657, 178, 179,
	180, 227, 228, 658, 181, 659, 660, 661, 662, 182,
	183, 184, 185, 437, 425, 426, 427, 424, 413, 0,
	0, 0, 0, 0, 0, 87, 88, 989, 89, 0,
	0, 0, 0, 419, 0, 0, 0, 90, 91, 186,
	466, 467, 92, 468, 469, 0, 93, 191, 192, 94,
	434, 452, 470, 471, 195, 0, 462, 0, 445, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 446, 448, 0, 447, 449, 102, 103, 104,
	105, 472, 106, 473, 474, 0, 0, 107, 0, 990,
	0, 465, 109, 0, 0, 0, 0, 418, 110, 453,
	432, 0, 111, 112, 475, 113, 0, 114, 0, 0,
	325, 0, 115, 463, 0, 204, 0, 116, 117, 459,
	461, 0, 0, 118, 0, 326, 119, 476, 477, 478,
	0, 444, 0, 327, 120, 328, 121, 122, 0, 0,
	464, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	408, 134, 433, 460, 136, 479, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 332, 140, 333, 454, 141,
	142, 0, 455, 143, 217, 0, 144, 145, 146, 480,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 422, 156, 0, 240, 157, 158, 0, 159,
	160, 450, 161, 162, 335, 163, 481, 164, 0, 165,
	166, 168, 221, 167, 456, 0, 0, 169, 170, 0,
	223, 482, 0, 0, 171, 457, 458, 431, 172, 173,
	174, 175, 0, 0, 176, 177, 451, 0, 178, 179,
	180, 227, 483, 988, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 409, 0, 437, 425, 426, 427, 424,
	413, 0, 0, 405, 406, 991, 0, 87, 88, 407,
	89, 0, 414, 986, 0, 419, 0, 0, 0, 90,
	91, 186, 466, 467, 92, 468, 469, 0, 93, 191,
	192, 94, 434, 452, 470, 471, 195, 0, 462, 0,
	445, 0, 95, 96, 97, 0, 98, 0, 99, 0,
	324, 100, 101, 0, 446, 448, 0, 447, 449, 102,
	103, 104, 105, 472, 106, 473, 474, 504, 0, 107,
	0, 0, 0, 465, 109, 0, 0, 0, 0, 418,
	110, 453, 432, 0, 111, 112, 475, 113, 0, 114,
	0, 0, 325, 0, 115, 463, 0, 204, 0, 116,
	117, 459, 461, 0, 0, 118, 0, 326, 119, 476,
	477, 478, 0, 444, 0, 327, 120, 328, 121, 122,
	0, 0, 464, 329, 123, 330, 0, 124, 0, 0,
	125, 0, 126, 127, 128, 129, 130, 331, 131, 132,
	135, 133, 408, 134, 433, 460, 136, 479, 137, 138,
	0, 0, 0, 0, 0, 139, 214, 332, 140, 333,
	454, 141, 142, 0, 455, 143, 217, 0, 144, 145,
	146, 480, 147, 148, 0, 150, 151, 149, 152, 0,
	153, 334, 154, 155, 422, 156, 0, 240, 157, 158,
	49, 159, 160, 450, 161, 162, 335, 163, 481, 164,
	0, 165, 166, 168, 221, 167, 456, 0, 51, 169,
	170, 0, 223, 482, 0, 0, 171, 457, 458, 431,
	172, 173, 174, 175, 0, 0, 176, 177, 451, 0,
	178, 179, 180, 322, 483, 0, 181, 0, 0, 0,
	47, 182, 183, 184, 185, 409, 48, 437, 425, 426,
	427, 424, 413, 0, 0, 405, 406, 0, 0, 87,
	88, 407, 89, 0, 414, 0, 0, 419, 0, 0,
	0, 90, 91, 186, 466, 467, 92, 468, 469, 0,
	93, 191, 192, 94, 434, 452, 470, 471, 195, 0,
	462, 0, 445, 0, 95, 96, 97, 0, 98, 0,
	99, 0, 324, 100, 101, 0, 446, 448, 0, 447,
	449, 102, 103, 104, 105, 472, 106, 473, 474, 0,
	0, 107, 0, 0, 0, 465, 109, 0, 0, 0,
	0, 418, 110, 453, 432, 0, 111, 112, 475, 113,
	0, 114, 0, 0, 325, 0, 115, 463, 0, 204,
	0, 116, 117, 459, 461, 0, 0, 118, 0, 326,
	119, 476, 477, 478, 0, 444, 0, 327, 120, 328,
	121, 122, 0, 0, 464, 329, 123, 330, 0, 124,
	0, 0, 125, 0, 126, 127, 128, 129, 130, 331,
	131, 132, 135, 133, 408, 134, 433, 460, 136, 479,
	137, 138, 0, 0, 0, 0, 0, 139, 214, 332,
	140, 333, 454, 141, 142, 0, 455, 143, 217, 0,
	144, 145, 146, 480, 147, 148, 0, 150, 151, 149,
	152, 0, 153, 334, 154, 155, 422, 156, 0, 240,
	157, 158, 49, 159, 160, 450, 161, 162, 335, 163,
	481, 164, 0, 165, 166, 168, 221, 167, 456, 0,
	51, 169, 170, 0, 223, 482, 0, 0, 171, 457,
	458, 431, 172, 173, 174, 175, 0, 0, 176, 177,
	451, 0, 178, 179, 180, 322, 483, 0, 181, 0,
	0, 0, 47, 182, 183, 184, 185, 409, 48, 437,
	425, 426, 427, 424, 413, 0, 0, 405, 406, 0,
	0, 87, 88, 407, 89, 0, 414, 0, 0, 419,
	0, 0, 0, 90, 91, 186, 466, 467, 92, 468,
	469, 1034, 93, 191, 192, 94, 434, 452, 470, 471,
	195, 0, 462, 0, 445, 0, 95, 96, 97, 0,
	98, 0, 99, 0, 324, 100, 101, 0, 446, 448,
	0, 447, 449, 102, 103, 104, 105, 472, 106, 473,
	474, 0, 0, 107, 0, 0, 0, 465, 109, 0,
	0, 0, 0, 418, 110, 453, 432, 0, 111, 112,
	475, 113, 0, 114, 0, 1039, 325, 0, 115, 463,
	0, 204, 0, 116, 117, 459, 461, 0, 0, 118,
	0, 326, 119, 476, 477, 478, 0, 444, 0, 327,
	120, 328, 121, 122, 0, 1035, 464, 329, 123, 330,
	0, 124, 0, 0, 125, 0, 126, 127, 128, 129,
	130, 331, 131, 132, 135, 133, 408, 134, 433, 460,
	136, 479, 137, 138, 0, 0, 0, 0, 0, 139,
	214, 332, 140, 333, 454, 141, 142, 0, 455, 143,
	217, 0, 144, 145, 146, 480, 147, 148, 0, 150,
	151, 149, 152, 0, 153, 334, 154, 155, 422, 156,
	0, 240, 157, 158, 0, 159, 160, 450, 161, 162,
	335, 163, 481, 164, 0, 165, 166, 168, 221, 167,
	456, 0, 0, 169, 170, 0, 223, 482, 0, 1036,
	171, 457, 458, 431, 172, 173, 174, 175, 0, 0,
	176, 177, 451, 0, 178, 179, 180, 227, 483, 0,
	181, 0, 0, 0, 0, 182, 183, 184, 185, 409,
	0, 437, 425, 426, 427, 424, 413, 0, 0, 405,
	406, 0, 0, 87, 88, 407, 89, 0, 414, 0,
	0, 419, 0, 0, 0, 90, 91, 186, 466, 467,
	92, 468, 469, 0, 93, 191, 192, 94, 434, 452,
	470, 471, 195, 0, 462, 0, 445, 0, 95, 96,
	97, 0, 98, 0, 99, 0, 324, 100, 101, 0,
	446, 448, 0, 447, 449, 102, 103, 104, 105, 472,
	106, 473, 474, 0, 0, 107, 0, 0, 0, 465,
	109, 0, 0, 0, 0, 418, 110, 453, 432, 0,
	111, 112, 475, 113, 0, 114, 0, 0, 325, 0,
	115, 463, 0, 204, 0, 116, 117, 459, 461, 0,
	0, 118, 0, 326, 119, 476, 477, 478, 0, 444,
	0, 327, 120, 328, 121, 122, 0, 0, 464, 329,
	123, 330, 0, 124, 0, 0, 125, 0, 126, 127,
	128, 129, 130, 331, 131, 132, 135, 133, 408, 134,
	433, 460, 136, 479, 137, 138, 0, 0, 0, 0,
	0, 139, 214, 332, 140, 333, 454, 141, 142, 0,
	455, 143, 217, 0, 144, 145, 146, 480, 147, 148,
	0, 150, 151, 149, 152, 0, 153, 334, 154, 155,
	422, 156, 0, 240, 157, 158, 0, 159, 160, 450,
	161, 162, 335, 163, 481, 164, 0, 165, 166, 168,
	221, 167, 456, 0, 0, 169, 170, 0, 223, 482,
	0, 0, 171, 457, 458, 431, 172, 173, 174, 175,
	0, 0, 176, 177, 451, 0, 178, 179, 180, 227,
	483, 0, 181, 0, 0, 0, 0, 182, 183, 184,
	185, 409, 0, 437, 425, 426, 427, 424, 413, 0,
	0, 405, 406, 0, 0, 87, 88, 407, 89, 0,
	414, 1381, 0, 419, 0, 0, 0, 90, 91, 186,
	466, 467, 92, 468, 469, 0, 93, 191, 192, 94,
	434, 452, 470, 471, 195, 0, 462, 0, 445, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 446, 448, 0, 447, 449, 102, 103, 104,
	105, 472, 106, 473, 474, 0, 0, 107, 0, 0,
	0, 465, 109, 0, 0, 0, 0, 418, 110, 453,
	432, 0, 111, 112, 475, 113, 0, 114, 0, 0,
	325, 0, 115, 463, 0, 204, 0, 116, 117, 459,
	461, 0, 0, 118, 0, 326, 119, 476, 477, 478,
	0, 444, 0, 327, 120, 328, 121, 122, 0, 0,
	464, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	408, 134, 433, 460, 136, 479, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 332, 140, 333, 454, 141,
	142, 0, 455, 143, 217, 0, 144, 145, 146, 480,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 422, 156, 0, 240, 157, 158, 0, 159,
	160, 450, 161, 162, 335, 163, 481, 164, 0, 165,
	166, 168, 221, 167, 456, 0, 0, 169, 170, 0,
	223, 482, 0, 0, 171, 457, 458, 431, 172, 173,
	174, 175, 0, 0, 176, 177, 451, 0, 178, 179,
	180, 227, 483, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 409, 0, 437, 425, 426, 427, 424,
	413, 0, 0, 405, 406, 0, 0, 87, 88, 407,
	89, 0, 414, 1324, 0, 419, 0, 0, 0, 90,
	91, 186, 466, 467, 92, 468, 469, 0, 93, 191,
	192, 94, 434, 452, 470, 471, 195, 0, 462, 0,
	445, 0, 95, 96, 97, 0, 98, 0, 99, 0,
	324, 100, 101, 0, 446, 448, 0, 447, 449, 102,
	103, 104, 105, 472, 106, 473, 474, 0, 0, 107,
	0, 0, 0, 465, 109, 0, 0, 0, 0, 418,
	110, 453, 432, 0, 111, 112, 475, 113, 0, 114,
	0, 0, 325, 0, 115, 463, 0, 204, 0, 116,
	117, 459, 461, 0, 0, 118, 0, 326, 119, 476,
	477, 478, 0, 444, 0, 327, 120, 328, 121, 122,
	0, 0, 464, 329, 123, 330, 0, 124, 0, 0,
	125, 0, 126, 127, 128, 129, 130, 331, 131, 132,
	135, 133, 408, 134, 433, 460, 136, 479, 137, 138,
	0, 0, 0, 0, 0, 139, 214, 332, 140, 333,
	454, 141, 142, 0, 455, 143, 217, 0, 144, 145,
	146, 480, 147, 148, 0, 150, 151, 149, 152, 0,
	153, 334, 154, 155, 422, 156, 0, 240, 157, 158,
	0, 159, 160, 450, 161, 162, 335, 163, 481, 164,
	0, 165, 166, 168, 221, 167, 456, 0, 0, 169,
	170, 0, 223, 482, 0, 0, 171, 457, 458, 431,
	172, 173, 174, 175, 0, 0, 176, 177, 451, 0,
	178, 179, 180, 227, 483, 0, 181, 0, 0, 0,
	0, 182, 183, 184, 185, 409, 0, 437, 425, 426,
	427, 424, 413, 0, 0, 405, 406, 0, 0, 87,
	88, 407, 89, 0, 414, 985, 0, 419, 0, 0,
	0, 90, 91, 186, 466, 467, 92, 468, 469, 0,
	93, 191, 192, 94, 434, 452, 470, 471, 195, 0,
	462, 0, 445, 0, 95, 96, 97, 0, 98, 0,
	99, 0, 324, 100, 101, 0, 446, 448, 0, 447,
	449, 102, 103, 104, 105, 472, 106, 473, 474, 0,
	0, 107, 0, 0, 0, 465, 109, 0, 0, 0,
	0, 418, 110, 453, 432, 0, 111, 112, 475, 113,
	0, 114, 0, 0, 325, 0, 115, 463, 0, 204,
	0, 116, 117, 459, 461, 0, 0, 118, 0, 326,
	119, 476, 477, 478, 0, 444, 0, 327, 120, 328,
	121, 122, 0, 0, 464, 329, 123, 330, 0, 124,
	0, 0, 125, 0, 126, 127, 128, 129, 130, 331,
	131, 132, 135, 133, 408, 134, 433, 460, 136, 479,
	137, 138, 0, 0, 0, 0, 0, 139, 214, 332,
	140, 333, 454, 141, 142, 0, 455, 143, 217, 0,
	144, 145, 146, 480, 147, 148, 0, 150, 151, 149,
	152, 0, 153, 334, 154, 155, 422, 156, 0, 240,
	157, 158, 0, 159, 160, 450, 161, 162, 335, 163,
	481, 164, 0, 165, 166, 168, 221, 167, 456, 0,
	0, 169, 170, 0, 223, 482, 0, 0, 171, 457,
	458, 431, 172, 173, 174, 175, 0, 0, 176, 177,
	451, 0, 178, 179, 180, 227, 483, 0, 181, 0,
	0, 0, 0, 182, 183, 184, 185, 409, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 405, 406, 0,
	0, 0, 0, 407, 747, 981, 414, 437, 425, 426,
	427, 424, 413, 0, 0, 0, 0, 0, 0, 87,
	88, 0, 89, 0, 0, 0, 0, 419, 0, 0,
	0, 90, 91, 186, 466, 467, 92, 468, 469, 0,
	93, 191, 192, 94, 434, 452, 470, 471, 195, 0,
	462, 0, 445, 0, 95, 96, 97, 0, 98, 0,
	99, 0, 324, 100, 101, 0, 446, 448, 0, 447,
	449, 102, 103, 104, 105, 472, 106, 473, 474, 0,
	0, 107, 0, 0, 0, 465, 109, 0, 0, 0,
	0, 418, 110, 453, 432, 0, 111, 112, 475, 113,
	0, 114, 0, 0, 325, 0, 115, 463, 0, 204,
	0, 116, 117, 459, 461, 0, 0, 118, 0, 326,
	119, 476, 477, 478, 0, 444, 0, 327, 120, 328,
	121, 122, 0, 0, 464, 329, 123, 330, 0, 124,
	0, 0, 125, 0, 126, 127, 128, 129, 130, 331,
	131, 132, 135, 133, 408, 134, 433, 460, 136, 479,
	137, 138, 0, 0, 0, 0, 0, 139, 214, 332,
	140, 333, 454, 141, 142, 0, 455, 143, 217, 0,
	144, 145, 146, 480, 147, 148, 0, 150, 151, 149,
	152, 0, 153, 334, 154, 155, 422, 156, 0, 240,
	157, 158, 0, 159, 160, 450, 161, 162, 335, 163,
	481, 164, 0, 165, 166, 168, 221, 167, 456, 0,
	0, 169, 170, 0, 223, 482, 0, 0, 171, 457,
	458, 431, 172, 173, 174, 175, 0, 0, 176, 177,
	451, 0, 178, 179, 180, 227, 483, 1330, 181, 0,
	0, 0, 0, 182, 183, 184, 185, 409, 0, 437,
	425, 426, 427, 424, 413, 0, 0, 405, 406, 0,
	0, 87, 88, 407, 89, 0, 414, 0, 0, 419,
	0, 0, 0, 90, 91, 186, 466, 467, 92, 468,
	469, 0, 93, 191, 192, 94, 434, 452, 470, 471,
	195, 0, 462, 0, 445, 0, 95, 96, 97, 0,
	98, 0, 99, 0, 324, 100, 101, 0, 446, 448,
	0, 447, 449, 102, 103, 104, 105, 472, 106, 473,
	474, 504, 0, 107, 0, 0, 0, 465, 109, 0,
	0, 0, 0, 418, 110, 453, 432, 0, 111, 112,
	475, 113, 0, 114, 0, 0, 325, 0, 115, 463,
	0, 204, 0, 116, 117, 459, 461, 0, 0, 118,
	0, 326, 119, 476, 477, 478, 0, 444, 0, 327,
	120, 328, 121, 122, 0, 0, 464, 329, 123, 330,
	0, 124, 0, 0, 125, 0, 126, 127, 128, 129,
	130, 331, 131, 132, 135, 133, 408, 134, 433, 460,
	136, 479, 137, 138, 0, 0, 0, 0, 0, 139,
	214, 332, 140, 333, 454, 141, 142, 0, 455, 143,
	217, 0, 144, 145, 146, 480, 147, 148, 0, 150,
	151, 149, 152, 0, 153, 334, 154, 155, 422, 156,
	0, 240, 157, 158, 0, 159, 160, 450, 161, 162,
	335, 163, 481, 164, 0, 165, 166, 168, 221, 167,
	456, 0, 0, 169, 170, 0, 223, 482, 0, 0,
	171, 457, 458, 431, 172, 173, 174, 175, 0, 0,
	176, 177, 451, 0, 178, 179, 180, 227, 483, 0,
	181, 0, 0, 0, 0, 182, 183, 184, 185, 409,
	0, 437, 425, 426, 427, 424, 413, 0, 0, 405,
	406, 0, 0, 87, 88, 407, 89, 0, 414, 0,
	0, 419, 0, 0, 0, 90, 91, 186, 466, 467,
	92, 468, 469, 0, 93, 191, 192, 94, 434, 452,
	470, 471, 195, 0, 462, 0, 445, 0, 95, 96,
	97, 0, 98, 0, 99, 0, 324, 100, 101, 0,
	446, 448, 0, 447, 449, 102, 103, 104, 105, 472,
	106, 473, 474, 0, 0, 107, 0, 0, 0, 465,
	109, 0, 0, 0, 0, 418, 110, 453, 432, 0,
	111, 112, 475, 113, 0, 114, 0, 0, 325, 0,
	115, 463, 0, 204, 0, 116, 117, 459, 461, 0,
	0, 118, 0, 326, 119, 476, 477, 478, 0, 444,
	0, 327, 120, 328, 121, 122, 0, 0, 464, 329,
	123, 330, 0, 124, 0, 0, 125, 0, 126, 127,
	128, 129, 130, 331, 131, 132, 135, 133, 408, 134,
	433, 460, 136, 479, 137, 138, 0, 0, 0, 0,
	0, 139, 214, 332, 140, 333, 454, 141, 142, 0,
	455, 143, 217, 0, 144, 145, 146, 480, 147, 148,
	0, 150, 151, 149, 152, 0, 153, 334, 154, 155,
	422, 156, 0, 240, 157, 158, 0, 159, 160, 450,
	161, 162, 335, 163, 481, 164, 0, 165, 166, 168,
	221, 167, 456, 0, 0, 169, 170, 0, 223, 482,
	0, 0, 171, 457, 458, 431, 172, 173, 174, 175,
	0, 0, 176, 177, 451, 0, 178, 179, 180, 227,
	483, 0, 181, 0, 0, 0, 0, 182, 183, 184,
	185, 409, 0, 437, 425, 426, 427, 424, 413, 0,
	0, 405, 406, 403, 0, 87, 88, 407, 89, 0,
	414, 0, 0, 419, 0, 0, 0, 90, 91, 186,
	466, 467, 92, 468, 469, 0, 93, 191, 192, 94,
	434, 452, 470, 471, 195, 0, 462, 0, 445, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 446, 448, 0, 447, 449, 102, 103, 104,
	105, 472, 106, 473, 474, 0, 0, 107, 0, 0,
	0, 465, 109, 0, 0, 0, 0, 418, 110, 453,
	432, 0, 111, 112, 475, 113, 0, 114, 0, 1039,
	325, 0, 115, 463, 0, 204, 0, 116, 117, 459,
	461, 0, 0, 118, 0, 326, 119, 476, 477, 478,
	0, 444, 0, 327, 120, 328, 121, 122, 0, 0,
	464, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	408, 134, 433, 460, 136, 479, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 332, 140, 333, 454, 141,
	142, 0, 455, 143, 217, 0, 144, 145, 146, 480,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 422, 156, 0, 240, 157, 158, 0, 159,
	160, 450, 161, 162, 335, 163, 481, 164, 0, 165,
	166, 168, 221, 167, 456, 0, 0, 169, 170, 0,
	223, 482, 0, 0, 171, 457, 458, 431, 172, 173,
	174, 175, 0, 0, 176, 177, 451, 0, 178, 179,
	180, 227, 483, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 409, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 405, 406, 0, 0, 0, 0, 407,
	0, 0, 414, 437, 425, 426, 427, 424, 413, 0,
	0, 0, 0, 0, 0, 87, 88, 688, 89, 0,
	0, 0, 0, 419, 0, 0, 0, 90, 91, 186,
	466, 467, 92, 468, 469, 0, 93, 191, 192, 94,
	434, 452, 470, 471, 195, 0, 462, 0, 445, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 446, 448, 0, 447, 449, 102, 103, 104,
	105, 472, 106, 473, 474, 0, 0, 107, 0, 0,
	0, 465, 109, 0, 0, 0, 0, 418, 110, 453,
	432, 0, 111, 112, 475, 113, 0, 114, 0, 0,
	325, 0, 115, 463, 0, 204, 0, 116, 117, 459,
	461, 0, 0, 118, 0, 326, 119, 476, 477, 478,
	0, 444, 0, 327, 120, 328, 121, 122, 0, 0,
	464, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	408, 134, 433, 460, 136, 479, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 332, 140, 333, 454, 141,
	142, 0, 455, 143, 217, 0, 144, 145, 146, 480,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 422, 156, 0, 240, 157, 158, 0, 159,
	160, 450, 161, 162, 335, 163, 481, 164, 0, 165,
	166, 168, 221, 167, 456, 0, 0, 169, 170, 0,
	223, 482, 0, 0, 171, 457, 458, 431, 172, 173,
	174, 175, 0, 0, 176, 177, 451, 0, 178, 179,
	180, 227, 483, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 409, 0, 437, 425, 426, 427, 424,
	413, 0, 0, 405, 406, 0, 0, 87, 88, 407,
	89, 0, 414, 0, 0, 419, 0, 0, 0, 90,
	91, 186, 466, 467, 92, 468, 469, 0, 93, 191,
	192, 94, 434, 452, 470, 471, 195, 0, 462, 0,
	445, 0, 95, 96, 97, 0, 98, 0, 99, 0,
	324, 100, 1654, 0, 446, 448, 0, 447, 449, 102,
	103, 104, 105, 472, 106, 473, 474, 0, 0, 107,
	0, 0, 0, 465, 109, 0, 0, 0, 0, 418,
	110, 453, 432, 0, 111, 112, 475, 113, 0, 114,
	0, 0, 325, 0, 115, 463, 0, 204, 0, 116,
	117, 459, 461, 0, 0, 118, 0, 326, 119, 476,
	477, 478, 0, 444, 0, 327, 120, 328, 121, 122,
	0, 0, 464, 329, 123, 330, 0, 124, 0, 0,
	125, 0, 126, 127, 128, 129, 130, 331, 131, 132,
	135, 133, 408, 134, 433, 460, 136, 479, 137, 138,
	0, 0, 0, 0, 0, 139, 214, 332, 140, 333,
	454, 141, 142, 0, 455, 143, 217, 0, 144, 145,
	146, 480, 147, 148, 0, 150, 151, 149, 152, 0,
	153, 334, 154, 155, 422, 156, 0, 240, 157, 158,
	0, 159, 160, 450, 161, 162, 335, 163, 481, 164,
	0, 165, 166, 168, 221, 167, 456, 0, 0, 169,
	170, 0, 223, 482, 0, 0, 171, 457, 458, 431,
	172, 173, 1653, 175, 0, 0, 176, 177, 451, 0,
	178, 179, 180, 227, 483, 0, 181, 0, 0, 0,
	0, 182, 183, 184, 185, 409, 0, 437, 425, 426,
	427, 424, 413, 0, 0, 405, 406, 0, 0, 87,
	88, 407, 89, 0, 414, 0, 0, 419, 0, 0,
	0, 90, 91, 1652, 466, 467, 92, 468, 469, 0,
	93, 191, 192, 94, 434, 452, 470, 471, 195, 0,
	462, 0, 445, 0, 95, 96, 97, 0, 98, 0,
	99, 0, 324, 100, 1654, 0, 446, 448, 0, 447,
	449, 102, 103, 104, 105, 472, 106, 473, 474, 0,
	0, 107, 0, 0, 0, 465, 109, 0, 0, 0,
	0, 418, 110, 453, 432, 0, 111, 112, 475, 113,
	0, 114, 0, 0, 325, 0, 115, 463, 0, 204,
	0, 116, 117, 459, 461, 0, 0, 118, 0, 326,
	119, 476, 477, 478, 0, 444, 0, 327, 120, 328,
	121, 122, 0, 0, 464, 329, 123, 330, 0, 124,
	0, 0, 125, 0, 126, 127, 128, 129, 130, 331,
	131, 132, 135, 133, 408, 134, 433, 460, 136, 479,
	137, 138, 0, 0, 0, 0, 0, 139, 214, 332,
	140, 333, 454, 141, 142, 0, 455, 143, 217, 0,
	144, 145, 146, 480, 147, 148, 0, 150, 151, 149,
	152, 0, 153, 334, 154, 155, 422, 156, 0, 240,
	157, 158, 0, 159, 160, 450, 161, 162, 335, 163,
	481, 164, 0, 165, 166, 168, 221, 167, 456, 0,
	0, 169, 170, 0, 223, 482, 0, 0, 171, 457,
	458, 431, 172, 173, 1653, 175, 0, 0, 176, 177,
	451, 0, 178, 179, 180, 227, 483, 0, 181, 0,
	0, 0, 0, 182, 183, 184, 185, 409, 0, 437,
	425, 426, 427, 424, 413, 0, 0, 405, 406, 0,
	0, 87, 88, 407, 89, 0, 414, 0, 0, 419,
	0, 0, 0, 90, 91, 186, 466, 467, 92, 468,
	469, 0, 93, 191, 192, 94, 434, 452, 470, 471,
	195, 0, 462, 0, 445, 0, 95, 96, 97, 0,
	98, 0, 99, 0, 324, 100, 101, 0, 446, 448,
	0, 447, 449, 102, 103, 104, 105, 472, 106, 473,
	474, 0, 0, 107, 0, 0, 0, 465, 109, 0,
	0, 0, 0, 418, 110, 453, 432, 0, 111, 112,
	475, 113, 0, 114, 0, 0, 325, 0, 115, 463,
	0, 204, 0, 116, 117, 459, 461, 0, 0, 118,
	0, 326, 119, 476, 477, 478, 0, 444, 0, 327,
	120, 328, 121, 122, 0, 0, 464, 329, 123, 330,
	0, 124, 0, 0, 125, 0, 126, 127, 128, 129,
	130, 331, 131, 132, 135, 133, 408, 134, 433, 460,
	136, 479, 137, 138, 0, 0, 0, 0, 0, 139,
	214, 332, 140, 333, 454, 141, 142, 0, 455, 143,
	217, 0, 144, 145, 146, 480, 147, 148, 0, 150,
	151, 149, 152, 0, 153, 334, 154, 155, 422, 156,
	0, 240, 157, 158, 0, 159, 160, 450, 161, 162,
	335, 163, 481, 164, 0, 165, 166, 168, 221, 167,
	456, 0, 0, 169, 170, 0, 223, 482, 0, 0,
	171, 457, 458, 431, 172, 173, 174, 175, 0, 0,
	176, 177, 451, 0, 178, 179, 180, 227, 483, 0,
	181, 0, 0, 0, 0, 182, 183, 184, 185, 409,
	0, 437, 425, 426, 427, 424, 413, 0, 0, 405,
	406, 0, 0, 87, 88, 407, 89, 0, 414, 0,
	0, 419, 0, 0, 0, 90, 91, 186, 466, 467,
	92, 468, 469, 0, 93, 191, 192, 94, 434, 452,
	470, 471, 195, 0, 462, 0, 445, 0, 95, 96,
	97, 0, 98, 0, 99, 0, 324, 100, 101, 0,
	446, 448, 0, 447, 449, 102, 103, 104, 105, 472,
	106, 473, 474, 0, 0, 107, 0, 0, 0, 465,
	109, 0, 0, 0, 0, 418, 110, 453, 432, 0,
	111, 112, 475, 113, 0, 114, 0, 0, 325, 0,
	115, 463, 0, 204, 0, 116, 117, 459, 461, 0,
	0, 118, 0, 326, 119, 476, 477, 478, 0, 444,
	0, 327, 120, 328, 121, 122, 0, 0, 464, 329,
	123, 330, 0, 124, 0, 0, 125, 0, 126, 127,
	128, 129, 130, 331, 131, 132, 135, 133, 0, 134,
	433, 460, 136, 479, 137, 138, 0, 0, 0, 0,
	0, 139, 214, 332, 140, 333, 454, 141, 142, 0,
	455, 143, 217, 0, 144, 145, 146, 480, 147, 148,
	0, 150, 151, 149, 152, 0, 153, 334, 154, 155,
	1029, 156, 0, 240, 157, 158, 0, 159, 160, 450,
	161, 162, 335, 163, 481, 164, 0, 165, 166, 168,
	221, 167, 456, 0, 0, 169, 170, 0, 223, 482,
	0, 0, 171, 457, 458, 431, 172, 173, 174, 175,
	0, 0, 176, 177, 451, 0, 178, 179, 180, 227,
	483, 0, 181, 0, 0, 0, 0, 182, 183, 184,
	185, 318, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1025, 1026, 87, 88, 0, 89, 1027, 0, 0,
	1028, 0, 0, 0, 0, 90, 91, 186, 187, 188,
	92, 189, 190, 0, 93, 191, 192, 94, 0, 0,
	193, 194, 195, 0, 196, 0, 323, 0, 95, 96,
	97, 0, 98, 0, 99, 0, 324, 100, 101, 0,
	0, 0, 0, 0, 0, 102, 103, 104, 105, 197,
	106, 198, 199, 0, 0, 107, 0, 0, 0, 108,
	109, 0, 0, 0, 0, 200, 110, 201, 0, 0,
	111, 112, 202, 113, 0, 114, 0, 0, 325, 0,
	115, 203, 0, 204, 0, 116, 117, 205, 206, 0,
	0, 118, 0, 326, 119, 207, 208, 209, 0, 210,
	0, 327, 120, 328, 121, 122, 0, 0, 211, 329,
	123, 330, 0, 124, 0, 0, 125, 0, 126, 127,
	128, 129, 130, 331, 131, 132, 135, 133, 0, 134,
	0, 212, 136, 213, 137, 138, 0, 0, 0, 0,
	0, 139, 214, 332, 140, 333, 215, 141, 142, 0,
	216, 143, 217, 0, 144, 145, 146, 218, 147, 148,
	0, 150, 151, 149, 152, 0, 153, 334, 154, 155,
	219, 156, 0, 240, 157, 158, 49, 159, 160, 0,
	161, 162, 335, 163, 220, 164, 0, 165, 166, 168,
	221, 167, 222, 0, 51, 169, 170, 0, 223, 224,
	0, 0, 171, 225, 226, 0, 172, 173, 174, 175,
	0, 0, 176, 177, 0, 0, 178, 179, 180, 322,
	228, 0, 181, 0, 0, 0, 47, 182, 183, 184,
	185, 0, 48, 318, 560, 564, 0, 565, 555, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	46, 0, 0, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 323, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 568, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	557, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	325, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 326, 119, 207, 208, 209,
	0, 210, 0, 327, 120, 328, 121, 122, 0, 0,
	211, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 558,
	0, 0, 0, 139, 214, 332, 140, 333, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 335, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 556, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 318, 560, 564, 0, 565, 555, 0,
	0, 0, 0, 566, 561, 87, 88, 0, 89, 0,
	0, 0, 0, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 323, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 551, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	557, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	325, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 326, 119, 207, 208, 209,
	0, 210, 0, 327, 120, 328, 121, 122, 0, 0,
	211, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 558,
	0, 0, 0, 139, 214, 332, 140, 333, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 335, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 556, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 318, 560, 564, 0, 565, 555, 0,
	0, 0, 0, 566, 561, 87, 88, 0, 89, 0,
	0, 0, 0, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 323, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	557, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	325, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 326, 119, 207, 208, 209,
	0, 210, 0, 327, 120, 328, 121, 122, 0, 0,
	211, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 558,
	0, 0, 0, 139, 214, 332, 140, 333, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 335, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 556, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 84, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 0, 566, 561, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	292, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 49, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 51, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 322, 228, 0, 181, 0, 0, 0, 47, 182,
	183, 184, 185, 84, 48, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 896, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 49, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 51, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 322, 228, 0, 181, 0, 0, 0, 47, 182,
	183, 184, 185, 84, 48, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 46, 0, 1135, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 84, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 0, 395, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	292, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 84, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 896, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 84, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 832, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 84, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 1348, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 84, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 494, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 536,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 535, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 539, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 318, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 539, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 323, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 324, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	325, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 326, 119, 207, 208, 209,
	0, 210, 0, 327, 120, 328, 121, 122, 0, 0,
	211, 329, 123, 330, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 331, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 332, 140, 333, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 334,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 335, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 806, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 804, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 809, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 873, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 808, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 874, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 84, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 0, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 806, 196, 0, 0, 801,
	95, 96, 97, 0, 98, 804, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 809, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 800,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 808, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 807, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 84, 181, 0, 0, 0, 0, 182,
	183, 184, 185, 0, 0, 87, 88, 0, 89, 0,
	0, 0, 0, 0, 1135, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	292, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 298,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	292, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 1073,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 1071,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 1062,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 680,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 82, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 522, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 0, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 380,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 377,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 341, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 237, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	236, 224, 0, 0, 232, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 237, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	236, 224, 0, 0, 232, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 313,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 310,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 308,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 301,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	281, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 230, 0, 0, 125, 0,
	126, 127, 128, 129, 237, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	142, 0, 216, 143, 217, 0, 144, 145, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 156, 0, 240, 157, 158, 0, 159,
	231, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	236, 224, 0, 0, 232, 225, 226, 0, 172, 173,
	174, 175, 0, 84, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 0, 181, 87, 88, 0, 89, 182,
	183, 184, 185, 0, 0, 0, 0, 90, 91, 186,
	187, 188, 92, 189, 190, 0, 93, 191, 192, 94,
	0, 0, 193, 194, 195, 0, 196, 0, 0, 0,
	95, 96, 97, 0, 98, 0, 99, 0, 0, 100,
	101, 0, 0, 0, 0, 0, 0, 102, 103, 104,
	105, 197, 106, 198, 199, 0, 0, 107, 0, 0,
	0, 108, 109, 0, 0, 0, 0, 200, 110, 201,
	0, 0, 111, 112, 202, 113, 0, 114, 0, 0,
	0, 0, 115, 203, 0, 204, 0, 116, 117, 205,
	206, 0, 0, 118, 0, 0, 119, 207, 208, 209,
	0, 210, 0, 0, 120, 0, 121, 122, 0, 0,
	211, 0, 123, 0, 0, 124, 0, 0, 125, 0,
	126, 127, 128, 129, 130, 0, 131, 132, 135, 133,
	0, 134, 0, 212, 136, 213, 137, 138, 0, 0,
	0, 0, 0, 139, 214, 0, 140, 0, 215, 141,
	0, 0, 216, 143, 217, 0, 144, 0, 146, 218,
	147, 148, 0, 150, 151, 149, 152, 0, 153, 0,
	154, 155, 219, 0, 0, 240, 157, 158, 0, 159,
	160, 0, 161, 162, 0, 163, 220, 164, 0, 165,
	166, 168, 221, 167, 222, 0, 0, 169, 170, 0,
	223, 224, 0, 0, 171, 225, 226, 0, 172, 173,
	174, 175, 0, 0, 176, 177, 0, 0, 178, 179,
	180, 227, 228, 704, 181, 722, 723, 724, 0, 182,
	183, 184, 185, 0, 0, 725, 0, 0, 0, 0,
	0, 706, 0, 731, 0, 0, 0, 0, 704, 0,
	722, 723, 724, 0, 0, 0, 0, 0, 0, 0,
	725, 705, 0, 0, 0, 0, 706, 719, 731, 0,
	0, 0, 0, 0, 0, 0, 0, 704, 0, 722,
	723, 724, 0, 0, 0, 0, 705, 0, 0, 725,
	0, 0, 719, 0, 0, 706, 0, 731, 0, 0,
	0, 0, 704, 0, 722, 723, 724, 0, 0, 0,
	0, 0, 0, 0, 725, 705, 0, 0, 0, 0,
	706, 719, 731, 0, 0, 732, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 730, 0, 0,
	705, 0, 0, 0, 0, 0, 719, 727, 0, 0,
	732, 0, 0, 720, 0, 0, 0, 0, 0, 0,
	0, 0, 730, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 727, 0, 0, 726, 0, 0, 720, 732,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 730, 0, 0, 0, 0, 0, 0, 0, 0,
	726, 727, 0, 0, 732, 0, 0, 720, 721, 0,
	0, 0, 0, 0, 0, 0, 730, 0, 729, 0,
	0, 0, 0, 0, 0, 0, 727, 0, 0, 726,
	0, 0, 720, 721, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 729, 0, 704, 0, 0, 0, 0,
	0, 0, 0, 0, 726, 0, 0, 0, 0, 0,
	0, 0, 721, 706, 0, 731, 0, 728, 0, 716,
	717, 718, 729, 715, 712, 713, 714, 707, 708, 709,
	710, 711, 0, 705, 0, 0, 0, 721, 0, 719,
	1239, 0, 728, 0, 716, 717, 718, 729, 715, 712,
	713, 714, 707, 708, 709, 710, 711, 0, 0, 0,
	0, 0, 0, 0, 0, 1238, 0, 0, 0, 0,
	0, 728, 0, 716, 717, 718, 0, 715, 712, 713,
	714, 707, 708, 709, 710, 711, 0, 0, 0, 0,
	0, 0, 0, 0, 1237, 0, 728, 732, 716, 717,
	718, 0, 715, 712, 713, 714, 707, 708, 709, 710,
	711, 704, 0, 722, 723, 724, 1611, 0, 0, 727,
	0, 0, 0, 725, 0, 720, 0, 0, 0, 706,
	704, 731, 722, 723, 724, 0, 0, 0, 0, 0,
	0, 0, 725, 0, 0, 0, 0, 0, 706, 705,
	731, 0, 0, 0, 0, 719, 0, 704, 0, 722,
	723, 724, 0, 0, 0, 0, 0, 0, 705, 725,
	0, 0, 0, 0, 719, 706, 0, 731, 0, 0,
	721, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	729, 0, 0, 0, 0, 705, 0, 0, 0, 0,
	0, 719, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 732, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 730, 0, 0, 0, 0,
	0, 0, 732, 0, 0, 727, 0, 0, 0, 728,
	0, 720, 0, 0, 730, 715, 712, 713, 714, 707,
	708, 709, 710, 711, 727, 0, 0, 0, 0, 732,
	720, 0, 0, 726, 0, 0, 0, 0, 0, 0,
	0, 730, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 727, 726, 0, 0, 0, 0, 720, 0, 0,
	0, 0, 0, 0, 0, 0, 721, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 729, 0, 0, 726,
	0, 0, 0, 0, 0, 721, 704, 0, 722, 723,
	724, 0, 0, 0, 0, 729, 0, 0, 725, 0,
	0, 0, 0, 0, 706, 0, 731, 0, 0, 0,
	0, 0, 721, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 729, 0, 705, 728, 0, 716, 717, 718,
	719, 715, 712, 713, 714, 707, 708, 709, 710, 711,
	0, 0, 0, 0, 728, 1610, 716, 717, 718, 0,
	715, 712, 713, 714, 707, 708, 709, 710, 711, 0,
	0, 0, 0, 0, 1593, 0, 0, 0, 0, 0,
	0, 728, 0, 716, 717, 718, 0, 715, 712, 713,
	714, 707, 708, 709, 710, 711, 0, 0, 732, 0,
	0, 1572, 0, 704, 0, 722, 723, 724, 0, 0,
	730, 0, 0, 0, 0, 725, 0, 0, 0, 0,
	727, 706, 0, 731, 0, 0, 720, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 705, 0, 0, 0, 0, 0, 719, 726, 0,
	0, 0, 0, 0, 0, 0, 0, 704, 0, 722,
	723, 724, 0, 0, 0, 0, 0, 0, 0, 725,
	0, 0, 0, 0, 0, 706, 0, 731, 0, 0,
	704, 721, 722, 723, 724, 0, 0, 0, 0, 0,
	0, 729, 725, 0, 0, 705, 0, 0, 706, 0,
	731, 719, 0, 0, 0, 732, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 730, 705, 0,
	0, 0, 0, 0, 719, 0, 0, 727, 0, 0,
	0, 0, 0, 720, 0, 0, 0, 0, 0, 0,
	728, 0, 716, 717, 718, 0, 715, 712, 713, 714,
	707, 708, 709, 710, 711, 726, 0, 0, 0, 732,
	1567, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 730, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 727, 732, 0, 0, 0, 0, 720, 721, 0,
	0, 0, 0, 0, 730, 0, 0, 0, 729, 0,
	0, 0, 0, 0, 727, 0, 0, 0, 0, 726,
	720, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 726, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 721, 0, 0, 0, 0, 728, 0, 716,
	717, 718, 729, 715, 712, 713, 714, 707, 708, 709,
	710, 711, 0, 0, 0, 721, 0, 1563, 0, 0,
	0, 0, 0, 0, 0, 729, 0, 0, 704, 0,
	722, 723, 724, 0, 0, 0, 0, 0, 0, 0,
	725, 0, 0, 0, 0, 0, 706, 0, 731, 0,
	0, 728, 0, 716, 717, 718, 0, 715, 712, 713,
	714, 707, 708, 709, 710, 711, 705, 0, 0, 0,
	0, 1502, 719, 0, 728, 0, 716, 717, 718, 0,
	715, 712, 713, 714, 707, 708, 709, 710, 711, 0,
	0, 0, 0, 0, 1501, 0, 0, 0, 0, 0,
	0, 0, 704, 0, 722, 723, 724, 0, 0, 0,
	0, 0, 0, 0, 725, 0, 0, 0, 0, 0,
	706, 0, 731, 0, 0, 704, 0, 722, 723, 724,
	732, 0, 0, 0, 0, 0, 0, 725, 0, 0,
	705, 0, 730, 706, 0, 731, 719, 0, 0, 0,
	0, 0, 727, 0, 0, 0, 0, 0, 720, 0,
	0, 0, 0, 705, 0, 0, 0, 0, 0, 719,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	726, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 704,
	0, 722, 723, 724, 732, 0, 0, 0, 0, 0,
	0, 725, 0, 721, 0, 0, 730, 706, 0, 731,
	0, 0, 0, 729, 0, 0, 727, 732, 0, 0,
	0, 0, 720, 0, 0, 0, 0, 705, 0, 730,
	0, 0, 0, 719, 0, 0, 0, 0, 0, 727,
	0, 0, 0, 0, 726, 720, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 728, 0, 716, 717, 718, 726, 715, 712,
	713, 714, 707, 708, 709, 710, 711, 721, 0, 0,
	0, 0, 1413, 0, 0, 0, 704, 729, 722, 723,
	724, 732, 0, 0, 0, 0, 0, 0, 725, 0,
	721, 0, 0, 730, 706, 0, 731, 0, 0, 0,
	729, 0, 0, 727, 0, 0, 0, 0, 0, 720,
	0, 0, 0, 0, 705, 0, 0, 0, 0, 0,
	719, 0, 0, 0, 0, 0, 728, 0, 716, 717,
	718, 726, 715, 712, 713, 714, 707, 708, 709, 710,
	711, 0, 0, 0, 0, 0, 1351, 0, 0, 728,
	0, 716, 717, 718, 0, 715, 712, 713, 714, 707,
	708, 709, 710, 711, 721, 0, 0, 0, 0, 1326,
	0, 0, 0, 704, 729, 722, 723, 724, 732, 0,
	0, 0, 0, 0, 0, 725, 0, 0, 0, 0,
	730, 706, 0, 731, 0, 0, 0, 0, 0, 0,
	727, 0, 0, 0, 0, 0, 720, 0, 0, 0,
	0, 705, 0, 0, 0, 0, 0, 719, 0, 0,
	0, 0, 0, 728, 0, 716, 717, 718, 726, 715,
	712, 713, 714, 707, 708, 709, 710, 711, 0, 0,
	0, 0, 0, 977, 0, 0, 0, 0, 0, 0,
	0, 0, 704, 0, 722, 723, 724, 0, 0, 1671,
	0, 721, 0, 0, 725, 0, 0, 0, 0, 0,
	706, 729, 731, 0, 0, 732, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 730, 0, 0,
	705, 0, 0, 0, 0, 0, 719, 727, 0, 0,
	0, 0, 0, 720, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	728, 0, 716, 717, 718, 726, 715, 712, 713, 714,
	707, 708, 709, 710, 711, 0, 0, 1670, 1397, 1229,
	0, 704, 1228, 722, 723, 724, 0, 0, 0, 0,
	0, 0, 0, 725, 732, 0, 0, 884, 721, 706,
	0, 731, 0, 0, 0, 734, 730, 0, 729, 0,
	0, 704, 0, 722, 723, 724, 727, 0, 0, 705,
	0, 0, 720, 725, 0, 719, 733, 0, 0, 706,
	0, 731, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 726, 0, 0, 0, 0, 705,
	885, 0, 0, 0, 0, 719, 0, 728, 0, 716,
	717, 718, 0, 715, 712, 713, 714, 707, 708, 709,
	710, 711, 0, 0, 0, 0, 0, 721, 0, 0,
	0, 0, 0, 732, 0, 0, 0, 729, 704, 0,
	722, 723, 724, 0, 0, 730, 0, 0, 0, 0,
	725, 0, 0, 0, 0, 727, 706, 0, 731, 0,
	0, 720, 0, 732, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 730, 705, 0, 0, 0,
	0, 0, 719, 726, 0, 727, 728, 0, 716, 717,
	718, 720, 715, 712, 713, 714, 707, 708, 709, 710,
	711, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 726, 0, 0, 721, 0, 0, 0,
	0, 0, 0, 0, 0, 704, 729, 722, 723, 724,
	0, 0, 0, 0, 0, 0, 0, 725, 0, 0,
	732, 0, 0, 706, 0, 731, 721, 0, 0, 0,
	0, 0, 730, 0, 0, 0, 729, 0, 0, 0,
	0, 0, 727, 705, 0, 0, 0, 0, 720, 719,
	0, 0, 0, 0, 0, 728, 0, 716, 717, 718,
	0, 715, 712, 713, 714, 707, 708, 709, 710, 711,
	726, 276, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 728, 0, 716, 717, 718,
	0, 715, 712, 713, 714, 707, 708, 709, 710, 711,
	0, 0, 704, 721, 722, 723, 724, 732, 0, 0,
	0, 0, 0, 729, 725, 0, 0, 0, 0, 730,
	706, 0, 731, 0, 0, 0, 0, 0, 0, 727,
	0, 0, 0, 0, 0, 720, 0, 0, 0, 0,
	705, 0, 0, 0, 0, 0, 719, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 726, 0, 0,
	0, 0, 728, 0, 716, 717, 718, 0, 715, 712,
	713, 714, 707, 708, 709, 710, 711, 0, 0, 704,
	0, 722, 723, 724, 0, 0, 0, 0, 0, 0,
	721, 725, 1235, 0, 1230, 0, 0, 706, 0, 731,
	729, 0, 0, 0, 732, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 1345, 730, 705, 0, 0,
	0, 0, 0, 719, 0, 0, 727, 0, 0, 0,
	0, 0, 720, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 728,
	0, 716, 717, 718, 726, 715, 712, 713, 714, 707,
	708, 709, 710, 711, 0, 0, 704, 0, 722, 723,
	724, 0, 0, 0, 0, 0, 0, 0, 725, 0,
	0, 732, 0, 0, 706, 0, 731, 721, 0, 0,
	0, 0, 0, 730, 0, 0, 0, 729, 0, 0,
	0, 0, 0, 727, 705, 0, 0, 0, 0, 720,
	719, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 726, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 728, 0, 716, 717,
	718, 0, 715, 712, 713, 714, 707, 708, 709, 710,
	711, 0, 0, 704, 721, 722, 723, 724, 732, 0,
	0, 0, 0, 0, 729, 725, 0, 0, 1192, 0,
	730, 706, 0, 731, 0, 0, 0, 0, 0, 0,
	727, 0, 0, 0, 0, 0, 720, 0, 0, 0,
	0, 705, 0, 0, 0, 0, 0, 719, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 726, 0,
	0, 0, 0, 728, 0, 716, 717, 718, 1197, 715,
	712, 713, 714, 707, 708, 709, 710, 711, 704, 0,
	722, 723, 724, 0, 0, 0, 0, 0, 0, 0,
	725, 721, 0, 0, 0, 0, 706, 0, 731, 0,
	0, 729, 0, 0, 0, 732, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 705, 730, 0, 0,
	0, 0, 719, 0, 0, 0, 0, 727, 0, 0,
	0, 0, 1199, 720, 1215, 1216, 1217, 0, 0, 0,
	0, 0, 0, 0, 1470, 0, 0, 0, 0, 0,
	728, 0, 716, 717, 718, 726, 715, 712, 713, 714,
	707, 708, 709, 710, 711, 704, 0, 722, 723, 724,
	0, 0, 0, 0, 0, 0, 1212, 0, 0, 0,
	732, 0, 0, 706, 0, 731, 0, 0, 721, 0,
	0, 0, 730, 0, 0, 0, 0, 0, 729, 0,
	0, 0, 727, 705, 0, 0, 0, 0, 720, 719,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 1199, 0, 1215, 1216, 1217,
	726, 0, 0, 0, 0, 0, 0, 1321, 0, 0,
	1199, 0, 1215, 1216, 1217, 0, 1218, 728, 0, 716,
	717, 718, 1320, 715, 712, 713, 714, 707, 708, 709,
	710, 711, 1213, 721, 0, 0, 0, 732, 0, 1212,
	0, 0, 0, 729, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 1212, 0, 0, 0, 0, 727,
	0, 0, 0, 0, 0, 720, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 1214, 0, 0,
	0, 0, 728, 0, 716, 717, 718, 0, 715, 712,
	713, 714, 707, 708, 709, 710, 711, 0, 0, 1218,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	721, 0, 0, 0, 1218, 1213, 0, 0, 0, 0,
	729, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1213, 0, 0, 0, 0, 0, 0, 0, 1209, 1210,
	1211, 0, 1208, 1205, 1206, 1207, 1200, 1201, 1202, 1203,
	1204, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 728,
	1214, 716, 717, 718, 0, 715, 712, 713, 714, 707,
	708, 709, 710, 711, 0, 1214, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1209, 1210, 1211, 0, 1208, 1205, 1206, 1207, 1200,
	1201, 1202, 1203, 1204, 0, 0, 1209, 1210, 1211, 0,
	1208, 1205, 1206, 1207, 1200, 1201, 1202, 1203, 1204, 913,
	928, 904, 921, 920, 0, 0, 906, 905, 0, 0,
	0, 930, 929, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	926, 0, 918, 917, 0, 0, 0, 0, 0, 0,
	916, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 915, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 909, 910, 911, 0,
	577, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 919, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 914, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 912, 0, 0, 0, 0,
	0, 908, 0, 0, 0, 0, 0, 907, 0, 0,
	927, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 931,
}
var sqlPact = [...]int{

	2572, -1000, -10, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, 777, -1000, -1000, -1000, 572, 768, 42, 968, 968,
	14429, -1000, -1000, 16959, 1771, 316, 319, 316, 316, 315,
	14429, 371, 473, 61, -1000, 661, -46, 16729, 13279, 1128,
	-22, 12819, 190, 2572, 13049, 13279, 16499, 980, 884, 12819,
	16269, 16039, 15809, -1000, 8677, -1000, -1000, -1000, -1000, 714,
	-1000, -23, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	707, -1000, 13279, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	15579, 15349, 633, -1000, -1000, 382, 237, 1157, -1000, -6,
	-1000, -1000, -1000, 977, -1000, 699, 976, 973, 969, 963,
	232, 747, -1000, 633, -1000, 633, -1000, -1000, -1000, 375,
	14429, -1000, 12819, -1000, 15119, 897, 14889, -1000, 661, -1000,
	-1000, -1000, 726, 1125, 1125, 1125, 1153, 73, 72, 61,
	-30, 13279, -1000, 191, -30, 6897, 6897, -1000, -1000, 190,
	-1000, 211, 11169, -13, -1000, 6645, -1000, 766, 1036, 503,
	502, 1031, -103, 12819, 13279, 444, 14659, -1000, 1029, 87,
	1028, -1000, -39, 1027, -1000, -43, -1000, -1000, -1000, -1000,
	-1000, -1000, 190, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, 11419, 1148, 11419, -1000,
	-1000, 1172, -1000, -1000, -26, -27, 838, 895, 9179, 8929,
	1088, 676, -1000, -1000, -1000, -7, 4109, 13279, 989, 11419,
	13279, 13279, 13279, -1000, 13279, -1000, 837, -1000, -1000, -28,
	-29, -1000, 14429, -1000, 90, -1000, 188, 811, 14199, -1000,
	801, -1000, 726, -1000, 629, 832, 7419, 8175, 61, -1000,
	-1000, 61, 61, 8175, -1000, -1000, 13279, -30, 1171, 13279,
	63, -1000, 18911, -1000, -1000, 8175, 8175, 8175, 8175, 8175,
	606, -1000, -1000, -1000, 4863, -1000, -1000, -13, 187, 198,
	-1000, -1000, 186, -13, -1000, -1000, -1000, -1000, 185, 1253,
	321, -1000, -1000, -1000, 8175, 241, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, 971, 184, 180, -1000, -1000,
	-1000, -1000, 178, 177, 176, 174, 170, 169, 168, 167,
	165, 164, 163, 148, 144, 588, -1000, 275, -1000, -1000,
	275, 275, -1000, 119, 119, 120, -1000, -1000, -1000, 119,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, 141,
	63, -1000, -1000, -1000, 13279, -13, -1000, -1000, -1000, 8175,
	3858, -44, -1000, 19508, -1000, -52, 592, -1000, 12349, 1109,
	1101, 1105, 12819, 372, 367, 13279, 13279, 257, 53, 1167,
	10669, -1000, 13279, 13279, -1000, 13279, -1000, -1000, 13279, 13279,
	13279, -46, 11879, 360, -40, 11649, 13279, -1000, -8, -1000,
	-1000, 962, 314, 577, 877, 660, -1000, -1000, -1000, -1000,
	-32, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, 1220, -1000, -1000, -1000, -1000, 1244, -32, -1000, -1000,
	-1000, -1000, -1000, 1251, -1000, -1000, -1000, -1000, 4109, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, 13279, -1000, -1000, -1000, -1000,
	-1000, -1000, 577, 877, -1000, -1000, 12819, 12109, 1026, 697,
	798, -1000, 1024, -1000, -1000, -1000, -1000, 19508, -1000, 19508,
	480, 888, -1000, 888, -35, -1000, 18881, -1000, 129, -48,
	-1000, 257, 6897, 10419, 19908, 13279, 383, 8175, 8175, 8175,
	8175, 8175, 8175, 8175, 8175, 8175, 8175, 8175, 8175, 8175,
	8175, 8175, 8175, 8175, 8175, 8175, 8175, 8175, 839, 358,
	1271, 650, 117, 4109, -1000, 1201, 1201, 1201, 2172, 2172,
	79, -31, 18519, -38, -13, -1000, -1000, 6123, 5871, -13,
	4359, -1000, 745, 1243, 264, 19508, 997, 923, 127, 71,
	69, 8175, 728, 8175, 8427, 8175, 8175, 5115, 8175, 8175,
	8175, 8175, 8175, 8175, -1000, 126, -1000, -1000, -1000, -1000,
	1241, -1000, -1000, 1240, -1000, 1238, 257, 68, -1000, 2455,
	-1000, -1000, 6645, -1000, 510, 13279, 13279, 13279, -1000, -1000,
	782, 13969, -1000, 19908, 13279, -1000, 125, 122, 851, 848,
	13279, 13279, 13739, 13509, 13279, 758, 13279, 13279, 494, -1000,
	487, 8175, 696, -1000, 9919, 283, 13279, 59, -1000, -1000,
	-1000, 223, 13279, -1000, -1000, -1000, 87, -1000, -39, -1000,
	-1000, 13279, 11649, -40, -41, -1000, -1000, 13279, 877, -1000,
	-1000, -1000, 498, -1000, 513, -1000, 9429, -1000, -1000, -1000,
	745, -1000, -53, -1000, -1000, -1000, -1000, 67, -42, -1000,
	-1000, -1000, -1000, 13279, 224, 13279, 13279, 1022, 13279, -1000,
	-1000, -1000, 8175, -1000, -1000, -1000, -46, 13279, -1000, 917,
	-1000, -45, 1140, -139, 12589, -1000, 9669, -1000, 1170, -1000,
	-1000, -1000, -1000, 55, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, -1000, -1000, 120, 588, 119, 119, 119,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, 275, 275,
	275, -1000, -1000, 230, 438, 438, 1165, 1165, 1165, 539,
	539, 836, 1967, 17645, 17645, 17645, 751, 563, 563, 17645,
	17645, 17645, 2172, 2342, 391, 8175, 356, 576, 117, 8175,
	-1000, 981, -1000, -1000, -1000, 956, 116, 8427, 8427, -1000,
	-1000, -1000, 4863, -1000, -1000, 111, 8175, -1000, 8175, -49,
	-77, -1000, 19508, -1000, -55, -1000, -1000, -21, 8175, 8175,
	8175, 65, -1000, 352, -1000, 349, 342, 339, -1000, 110,
	64, 437, -1000, 8175, 609, 109, 108, 8175, -1000, -1000,
	19433, 58, 954, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	57, 19336, 56, 1662, -1000, 8427, 8427, 8427, 4863, 106,
	51, 18792, -130, 19249, 7149, 7149, 7149, 49, 19172, 8175,
	-130, 17477, 17448, 17423, -56, -61, -62, 1237, -63, 48,
	44, 917, -1000, -1000, 8175, -1000, -1000, -1000, 338, 337,
	1019, -1000, 771, -1000, 517, 8175, 13279, 103, 101, 562,
	-1000, 1018, 706, 1017, 706, -1000, -52, 526, -1000, -1000,
	330, -1000, 6897, 19508, 487, 1113, -67, -1000, -1000, -1000,
	257, 10669, 6645, -69, -1000, -53, -1000, -53, -1000, -1000,
	-1000, -1000, -1000, -1000, 13279, -1000, 12109, 96, 13279, 95,
	93, 13279, -1000, -1000, 43, -1000, -1000, -1000, -1000, -1000,
	914, 1146, 10419, 874, 861, 10419, 867, 614, 614, 614,
	-1000, 12589, 3594, -1000, -1000, 13279, 92, 10169, 40, 1140,
	205, 204, -1000, 1235, 8175, 391, 8175, 8427, 8427, -1000,
	391, -1000, -1000, -1000, -1000, 952, 89, 8175, 19908, 19670,
	19655, -73, 5619, -60, 18445, 8175, -1000, -1000, 198, -1000,
	39, 6393, -1000, 18988, -2, -2, -1000, 736, 711, 611,
	451, 1229, 1249, 1042, -1000, 8175, 19075, -1000, 10919, 259,
	623, 18422, 19908, -1000, 8175, -1000, 949, 8175, -1000, 19908,
	8427, 8427, 8427, 8427, 8427, 8427, 8427, 8427, 8427, 8427,
	8427, 8427, 8427, 8427, 8427, 8427, 8427, 8427, 797, 8427,
	1200, 1200, 1200, -71, 5367, -1000, 935, 949, 8175, 8175,
	19908, 37, 36, 35, -1000, 8175, -130, 8175, 8175, 8175,
	-1000, -1000, -1000, 30, -1000, 1224, -1000, -1000, 914, 18616,
	13279, 13279, 13279, 1008, 1495, -1000, 18348, -75, 13279, 13279,
	-1000, 869, 830, 305, 13279, -1000, 13279, -1000, 13279, 13279,
	13279, 13279, -83, -1000, 86, -46, 13279, 487, -1000, -1000,
	222, -1000, -1000, 2872, 85, 12109, 2872, 695, -1000, 255,
	8175, 8175, 1140, 10419, 10419, 932, 858, 10419, -1000, -1000,
	-1000, -1000, -1000, -1000, 804, 84, 13279, 12589, 365, 1204,
	27, 1169, 391, 19562, 2437, 8175, 19908, 19595, -85, -1000,
	8175, 8175, -1000, -86, -1000, 8175, -1000, 19508, -1000, 1247,
	8175, 26, 24, 20, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, 19, -1000, -1000, 19508, 8175, -1000, -1000, 17189, 8175,
	18, -1000, 15, 19508, 935, 19508, -1000, 469, 469, 1200,
	1200, 1200, 865, 865, 774, 477, 434, 434, 434, 402,
	568, 568, 434, 434, 434, 947, 802, 83, 2602, 8175,
	-87, -1000, -1000, -1000, 19508, 19508, 14, -1000, -1000, -1000,
	-130, 251, 18150, 18127, -1000, 11, 255, -1000, -1000, -1000,
	-1000, 13279, -1000, 13279, -1000, 13279, 743, -1000, -1000, 847,
	82, 8427, 13279, -1000, 628, -91, -92, 739, -1000, 733,
	8175, -1000, 19908, 706, 706, -1000, 323, 322, -1000, 1060,
	2872, 1104, -1000, -1000, -1000, 81, -93, -1000, 145, 1121,
	8175, -1000, -1000, 80, 2872, 9, -104, 13279, -1000, 13279,
	19508, -130, -1000, 932, -1000, 78, 8175, 10419, -1000, -155,
	-1000, 220, -1000, 13279, -109, -1000, -1000, 196, 88, -1000,
	8175, 8175, 19595, -117, -1000, 19908, 391, 391, -1000, 18073,
	-1000, 18988, -1000, -1000, -1000, -1000, 19508, 601, -1000, 17966,
	-1000, -1000, -1000, 8427, 930, 77, 19908, 17807, -1000, -1000,
	8175, -1000, -1000, -1000, -1000, -1000, 1547, -1000, -1000, -1000,
	8175, 2602, 60, -1000, 76, -1000, -1000, -1000, 508, -1000,
	-1000, 19508, 1123, -1000, -1000, 13279, 13279, 407, -119, 13279,
	-1000, -1000, 4611, 628, 2872, 1124, -13, 13279, 1124, 17780,
	4359, -123, -1000, 628, 75, -128, -1000, 1160, -1000, 13279,
	19508, -1000, 804, -1000, 4109, -129, -1000, -1000, -1000, 391,
	391, -1000, -1000, -1000, 6, 623, 1144, -1000, 166, 8427,
	19908, -131, -1000, 17761, -1000, 17502, 824, 13279, 13279, 13279,
	288, 13279, -1000, -1000, 441, -1000, 257, -1000, -1000, -1000,
	-1000, -1000, -1000, 1121, -21, 628, -1000, 2872, 13279, 62,
	-136, -1000, -1000, -1000, -1000, 482, 8175, 166, -137, -1000,
	-1000, -1000, 637, 646, -141, -142, 60, -1000, 8175, -1000,
	10669, -1000, 1124, 2, -1000, -143, -1000, -1000, -1000, -3,
	7923, 7923, -130, -1000, -1000, 688, 653, 452, -1000, -1000,
	-1000, -1000, -1000, 824, 19508, -121, -1000, -1000, 628, -1000,
	-1000, -1000, 3149, 715, 468, 18713, -1000, -1000, 1064, -1000,
	298, 840, 840, 637, -1000, -1000, 1178, -1000, -1000, -1000,
	-1000, -1000, -1000, 1185, -1000, -1000, 829, -1000, -1000, 7671,
	-1000, -1000, -1000, -1000,
}
var sqlPgo = [...]int{

	0, 1485, 1484, 1164, 1483, 1482, 1481, 1479, 1476, 90,
	1475, 1474, 107, 1473, 77, 1470, 1468, 1466, 1452, 52,
	1447, 1445, 1444, 1440, 1439, 76, 38, 106, 2147, 100,
	1438, 1436, 1433, 10, 81, 82, 1430, 36, 83, 87,
	1227, 53, 1427, 111, 19, 16, 1277, 74, 1426, 120,
	95, 1425, 1423, 1420, 37, 1419, 1418, 1417, 11, 43,
	13, 1416, 20, 59, 1414, 1413, 75, 1412, 79, 97,
	25, 94, 162, 1411, 57, 9, 56, 1410, 30, 1409,
	31, 61, 119, 1408, 35, 257, 48, 26, 55, 1407,
	1405, 1404, 1403, 62, 68, 40, 1402, 1399, 58, 1397,
	108, 116, 1396, 1395, 1394, 1393, 1392, 1390, 564, 1389,
	1386, 329, 3, 41, 49, 27, 93, 91, 28, 1382,
	15, 1381, 0, 1050, 733, 1379, 45, 33, 64, 44,
	46, 24, 1378, 85, 1377, 1374, 1368, 1367, 1365, 63,
	1364, 51, 110, 34, 42, 78, 23, 50, 69, 114,
	121, 84, 1361, 101, 1359, 54, 1358, 1357, 900, 72,
	1353, 1352, 1349, 850, 817, 800, 319, 1340, 1338, 638,
	403, 1336, 1335, 65, 1333, 1327, 115, 1324, 109, 22,
	1320, 102, 1317, 73, 1315, 558, 47, 21, 1312, 103,
	60, 1311, 1309, 1308, 29, 4, 8, 5, 6, 1,
	18, 17, 1300, 1299, 99, 70, 1298, 123, 1297, 1296,
	32, 1295, 1281, 14, 1280, 12, 1278, 7, 2, 1274,
	113, 1271, 96, 1270, 1214, 1269, 117, 1267, 1263, 1184,
	67,
}
var sqlR1 = [...]int{

	0, 1, 2, 2, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 4, 4, 35, 35, 34, 34, 34, 34,
	34, 34, 34, 34, 34, 34, 34, 34, 34, 34,
	34, 31, 31, 37, 37, 37, 36, 36, 32, 32,
	5, 5, 5, 9, 10, 10, 10, 10, 10, 10,
	71, 71, 70, 70, 73, 73, 11, 11, 12, 12,
	12, 12, 154, 154, 153, 13, 18, 220, 220, 220,
	224, 224, 225, 225, 226, 226, 226, 226, 226, 226,
	226, 222, 222, 21, 21, 21, 21, 108, 108, 110,
	110, 110, 110, 39, 107, 107, 107, 107, 109, 109,
	109, 109, 178, 176, 176, 183, 183, 183, 51, 51,
	51, 51, 51, 52, 52, 52, 175, 175, 175, 175,
	184, 184, 184, 184, 184, 184, 53, 53, 53, 182,
	182, 22, 22, 22, 22, 22, 22, 22, 22, 22,
	22, 22, 22, 22, 177, 177, 221, 221, 223, 223,
	8, 8, 54, 54, 55, 55, 114, 114, 114, 113,
	192, 192, 193, 193, 193, 194, 194, 194, 194, 194,
	194, 194, 191, 191, 189, 189, 190, 190, 190, 190,
	227, 227, 112, 112, 58, 58, 197, 197, 197, 197,
	195, 195, 195, 195, 195, 198, 196, 199, 199, 199,
	199, 199, 142, 142, 142, 24, 7, 7, 97, 97,
	62, 62, 146, 146, 146, 45, 45, 33, 33, 33,
	17, 17, 17, 17, 17, 17, 17, 17, 17, 98,
	98, 99, 99, 16, 20, 23, 23, 23, 23, 23,
	229, 229, 42, 42, 42, 42, 43, 43, 111, 111,
	111, 111, 111, 38, 6, 6, 14, 48, 48, 104,
	104, 104, 106, 106, 106, 105, 105, 105, 84, 84,
	25, 75, 75, 76, 76, 152, 77, 77, 19, 19,
	28, 28, 26, 26, 26, 26, 26, 26, 27, 27,
	29, 29, 29, 29, 29, 29, 29, 205, 205, 205,
	207, 207, 204, 15, 15, 15, 15, 206, 206, 228,
	228, 85, 85, 85, 57, 56, 56, 60, 60, 59,
	61, 61, 145, 82, 82, 82, 82, 100, 101, 101,
	102, 102, 103, 103, 81, 81, 129, 129, 30, 30,
	66, 66, 67, 67, 120, 120, 121, 121, 119, 119,
	119, 147, 147, 147, 147, 148, 148, 148, 148, 148,
	148, 143, 143, 143, 143, 144, 144, 88, 88, 88,
	88, 86, 86, 87, 87, 149, 149, 149, 149, 83,
	83, 150, 150, 150, 115, 115, 155, 155, 155, 65,
	65, 65, 156, 156, 156, 156, 156, 156, 156, 156,
	156, 156, 156, 157, 157, 157, 157, 159, 159, 159,
	158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
	158, 158, 158, 160, 160, 167, 167, 168, 168, 169,
	170, 161, 161, 162, 162, 163, 164, 171, 171, 171,
	173, 173, 165, 165, 166, 94, 94, 94, 94, 94,
	94, 94, 94, 94, 94, 94, 94, 94, 94, 95,
	95, 122, 122, 122, 122, 122, 122, 122, 122, 122,
	122, 122, 122, 122, 122, 122, 122, 122, 122, 122,
	122, 122, 122, 122, 122, 122, 122, 122, 122, 122,
	122, 122, 122, 122, 122, 122, 122, 122, 122, 122,
	122, 122, 122, 122, 122, 122, 122, 122, 122, 122,
	122, 122, 122, 123, 123, 123, 123, 123, 123, 123,
	123, 123, 123, 123, 123, 123, 123, 123, 123, 123,
	123, 123, 123, 123, 123, 123, 123, 123, 123, 123,
	124, 124, 124, 124, 124, 124, 124, 124, 124, 124,
	124, 124, 200, 200, 200, 200, 200, 200, 200, 202,
	202, 203, 203, 201, 201, 201, 201, 201, 201, 201,
	201, 201, 201, 201, 201, 201, 201, 201, 201, 201,
	201, 201, 201, 201, 201, 201, 201, 201, 208, 208,
	209, 209, 210, 210, 211, 211, 213, 214, 214, 214,
	215, 219, 219, 212, 212, 216, 216, 216, 217, 217,
	218, 218, 218, 218, 218, 133, 133, 133, 134, 134,
	135, 72, 72, 131, 131, 130, 130, 130, 132, 132,
	89, 172, 172, 172, 172, 172, 172, 172, 90, 90,
	96, 91, 91, 92, 92, 92, 92, 92, 92, 126,
	127, 93, 93, 93, 128, 128, 136, 140, 140, 139,
	138, 138, 137, 137, 118, 118, 118, 118, 117, 116,
	78, 78, 230, 230, 141, 141, 79, 79, 80, 74,
	74, 151, 151, 151, 151, 68, 68, 50, 50, 69,
	69, 46, 46, 49, 47, 47, 47, 47, 63, 63,
	64, 64, 44, 44, 125, 125, 125, 125, 125, 125,
	125, 125, 125, 125, 125, 174, 174, 174, 40, 40,
	40, 41, 41, 180, 180, 180, 181, 181, 181, 181,
	179, 179, 179, 179, 179, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 185, 185, 185, 185, 185,
	185, 185, 185, 185, 185, 187, 187, 187, 187, 187,
	187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
	187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
	187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
	187, 187, 187, 187, 187, 187, 187, 187, 186, 186,
	186, 186, 186, 186, 186, 186, 186, 186, 186, 186,
	186, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 188, 188, 188, 188, 188, 188, 188, 188,
}
var sqlR2 = [...]int{

	0, 1, 3, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 0, 4, 6, 1, 3, 2, 5, 3, 6,
	4, 6, 6, 6, 4, 8, 2, 3, 3, 6,
	4, 3, 2, 1, 1, 0, 2, 0, 2, 0,
	1, 1, 1, 6, 3, 5, 4, 6, 3, 5,
	1, 3, 1, 2, 2, 3, 2, 5, 1, 1,
	1, 1, 1, 3, 1, 6, 6, 1, 2, 2,
	1, 1, 1, 3, 1, 1, 1, 1, 1, 1,
	1, 1, 3, 2, 3, 6, 3, 2, 1, 1,
	1, 3, 3, 2, 3, 3, 3, 3, 1, 3,
	3, 2, 1, 1, 3, 1, 1, 1, 2, 2,
	1, 2, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 3, 1, 1, 1, 1, 1, 0, 1,
	1, 2, 2, 4, 2, 4, 4, 4, 4, 3,
	3, 4, 3, 2, 2, 0, 2, 0, 2, 0,
	6, 9, 1, 0, 1, 3, 1, 1, 1, 3,
	2, 0, 3, 1, 2, 2, 1, 1, 2, 4,
	2, 5, 6, 7, 3, 1, 4, 5, 5, 10,
	1, 1, 4, 0, 3, 0, 2, 2, 2, 0,
	1, 1, 2, 2, 0, 3, 3, 2, 1, 1,
	2, 2, 1, 2, 1, 4, 10, 13, 1, 0,
	1, 3, 3, 3, 5, 2, 0, 1, 1, 0,
	6, 6, 8, 6, 8, 8, 10, 8, 10, 1,
	0, 2, 0, 2, 2, 3, 3, 2, 2, 2,
	1, 0, 1, 3, 2, 0, 2, 1, 1, 1,
	3, 3, 0, 3, 3, 6, 7, 1, 3, 1,
	4, 2, 8, 5, 0, 4, 3, 0, 2, 0,
	8, 1, 3, 1, 1, 3, 5, 5, 1, 1,
	3, 3, 1, 2, 3, 2, 3, 4, 1, 1,
	8, 8, 1, 2, 4, 4, 4, 2, 2, 3,
	1, 3, 6, 1, 1, 1, 1, 1, 0, 1,
	0, 1, 1, 0, 1, 1, 0, 1, 0, 3,
	1, 3, 2, 2, 2, 1, 1, 2, 2, 3,
	1, 1, 1, 1, 3, 0, 2, 0, 2, 3,
	2, 0, 1, 3, 3, 1, 1, 3, 2, 4,
	0, 3, 2, 1, 4, 3, 4, 5, 4, 5,
	4, 5, 2, 4, 1, 1, 0, 2, 2, 2,
	1, 1, 0, 4, 2, 1, 2, 2, 4, 1,
	3, 1, 2, 3, 2, 0, 2, 5, 2, 3,
	4, 0, 1, 1, 1, 1, 2, 4, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 3, 5, 0,
	1, 1, 1, 1, 1, 1, 2, 2, 2, 2,
	2, 1, 1, 3, 0, 1, 1, 1, 1, 5,
	2, 1, 1, 1, 1, 4, 1, 2, 2, 1,
	1, 0, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 3, 3, 3, 3, 3, 3, 3, 0, 1,
	4, 1, 3, 3, 5, 2, 2, 2, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 2, 2,
	3, 4, 4, 5, 3, 4, 3, 3, 4, 3,
	4, 3, 4, 5, 6, 6, 7, 6, 7, 6,
	7, 3, 4, 1, 3, 2, 2, 2, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 5, 6, 6, 7,
	1, 1, 1, 3, 1, 1, 1, 2, 2, 2,
	1, 1, 3, 5, 6, 8, 6, 6, 4, 4,
	1, 1, 1, 5, 1, 3, 1, 3, 1, 1,
	1, 1, 6, 4, 4, 4, 4, 6, 5, 5,
	5, 4, 8, 6, 6, 4, 4, 4, 5, 0,
	5, 0, 2, 0, 1, 3, 3, 2, 2, 0,
	6, 1, 0, 3, 0, 2, 2, 0, 1, 4,
	2, 2, 2, 2, 2, 4, 3, 5, 4, 3,
	5, 1, 3, 1, 3, 3, 3, 2, 1, 3,
	3, 1, 1, 1, 1, 1, 1, 1, 4, 3,
	2, 3, 0, 3, 3, 2, 2, 1, 0, 2,
	2, 3, 2, 1, 1, 3, 5, 1, 2, 4,
	2, 0, 1, 0, 1, 1, 3, 5, 2, 2,
	1, 2, 1, 0, 1, 1, 1, 3, 3, 1,
	3, 3, 2, 1, 1, 1, 3, 1, 3, 1,
	3, 1, 2, 3, 1, 2, 2, 1, 1, 3,
	3, 0, 1, 2, 1, 1, 1, 1, 6, 2,
	3, 5, 1, 1, 1, 1, 2, 2, 1, 1,
	1, 1, 0, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1,
}
var sqlChk = [...]int{

	-1000, -1, -2, -3, -4, -5, -9, -10, -11, -13,
	-14, -17, -18, -20, -19, -21, -22, -23, -16, -24,
	-25, 19, -6, -7, -8, -206, 83, 89, 102, 189,
	196, -26, -28, 203, 204, 29, 211, 52, 85, 191,
	186, 229, 58, -205, -29, -27, 273, 249, 255, 199,
	-30, 217, 242, 276, 217, 70, 113, 78, 117, 236,
	70, 113, 217, -12, 273, -19, -14, -25, -9, -224,
	18, -225, -226, 58, 83, 102, 199, 117, 78, 236,
	-224, -43, 196, -40, 4, -185, -187, 16, 17, 19,
	28, 29, 33, 37, 40, 51, 52, 53, 55, 57,
	60, 61, 68, 69, 70, 71, 73, 78, 82, 83,
	89, 93, 94, 96, 98, 103, 108, 109, 114, 117,
	125, 127, 128, 133, 136, 139, 141, 142, 143, 144,
	145, 147, 148, 150, 152, 149, 155, 157, 158, 164,
	167, 170, 171, 174, 177, 178, 179, 181, 182, 186,
	184, 185, 187, 189, 191, 192, 194, 197, 198, 200,
	201, 203, 204, 206, 208, 210, 211, 214, 212, 218,
	219, 225, 229, 230, 231, 232, 235, 236, 239, 240,
	241, 245, 250, 251, 252, 253, 30, 31, 32, 34,
	35, 38, 39, 43, 44, 45, 47, 72, 74, 75,
	88, 90, 95, 104, 106, 110, 111, 118, 119, 120,
	122, 131, 154, 156, 165, 169, 173, 175, 180, 193,
	207, 213, 215, 221, 222, 226, 227, 242, 243, -108,
	136, 201, 225, -109, -107, -178, 221, 145, -70, -40,
	196, 4, 70, 51, 71, 103, 113, 114, 128, 218,
	221, 225, 18, -229, 225, 225, -229, -229, -42, 225,
	223, -43, -228, 217, 217, -97, 70, 234, -27, -29,
	-28, -59, -60, 233, 121, 87, 163, -26, -28, -205,
	-207, 181, -204, -40, -207, -56, -57, 18, 80, 277,
	-149, -46, 161, -40, -80, 273, -3, -149, 110, -40,
	-49, 110, -46, 100, 123, -150, -149, -40, 110, -50,
	110, -49, -71, 110, -70, -154, -153, -181, 4, -185,
	-187, -186, 242, 49, 59, 101, 116, 124, 126, 132,
	134, 146, 166, 168, 190, 205, 160, 277, 160, -40,
	-108, 45, -108, -110, -38, -39, 125, 177, 223, 258,
	100, 253, -53, 6, 76, -73, 275, 100, -221, 160,
	100, 100, 100, -177, 100, 253, 125, 177, -111, -38,
	-39, -111, 223, -43, -83, -149, -70, 110, 113, -40,
	110, -59, -60, -82, -100, -101, 135, 159, -85, 18,
	80, -85, -85, 37, 274, 274, 277, -207, -64, 273,
	-74, -151, -122, 266, -124, 264, 265, 270, 151, 254,
	-133, -46, -125, 9, 273, -136, -202, -28, 88, 24,
	-134, -135, 193, -40, 8, 5, 6, 7, -44, -157,
	-166, 228, 91, 153, 41, -200, -201, 4, -185, -180,
	-158, -168, -162, -165, 122, 49, 63, 66, 64, 67,
	202, 237, 42, 90, 169, 173, 215, 226, 227, 110,
	154, 111, 47, 104, 131, 82, 31, 32, 34, 35,
	43, 44, 72, 74, 75, 95, 118, 119, 120, 156,
	180, 207, 222, 243, -186, -169, -170, -163, -164, -171,
	-74, -80, 266, -46, 273, -78, -118, -117, -116, 271,
	275, -79, -141, -122, 76, -35, 184, -34, 17, 19,
	83, 240, 88, 184, 184, 88, 278, -150, -48, -46,
	203, -40, 25, 88, -37, 277, 40, 187, 88, 277,
	88, 274, 277, -220, -69, 217, 70, -47, -40, 266,
	-226, -220, 25, 277, 277, 133, -52, 139, 150, 108,
	-176, 76, -183, -175, -142, 9, 228, 91, 160, -182,
	5, 265, -174, -181, 6, 8, 264, -176, 76, 61,
	-184, 6, 4, -166, -142, 76, 136, 122, 275, -179,
	4, -185, -187, -186, -188, 18, 20, 21, 22, 23,
	24, 25, 26, 27, 36, 41, 42, 46, 48, 50,
	56, 58, 62, 63, 64, 65, 66, 67, 76, 77,
	79, 80, 81, 84, 85, 87, 91, 92, 97, 99,
	100, 102, 105, 107, 112, 113, 115, 121, 123, 129,
	130, 135, 137, 138, 151, 153, 159, 160, 161, 162,
	163, 172, 176, 183, 188, 199, 202, 209, 216, 217,
	220, 223, 224, 228, 233, 234, 237, 238, 244, 246,
	247, 248, 249, -178, -223, 97, -220, -178, -178, -178,
	-178, 133, 277, 277, -43, -37, 277, 273, 151, -41,
	110, -40, 151, -82, -101, -100, -102, -122, 18, -122,
	-124, -27, -27, -27, -61, -145, -122, -204, 25, -63,
	-40, -66, 277, 100, 10, 48, 28, 264, 265, 266,
	267, 268, 261, 262, 263, 260, 256, 257, 258, 54,
	140, 195, 12, 13, 14, 22, 162, 134, 254, 205,
	124, 30, 112, 25, 4, -122, -122, -122, -122, -122,
	168, -28, -122, -72, -78, -28, -130, 271, 273, -78,
	273, 6, 6, 273, -137, -122, -208, 250, 97, 273,
	273, 273, 273, 273, 273, 273, 273, 273, 273, 273,
	273, 273, 273, 273, 175, -173, 245, -173, -173, -159,
	273, -159, -160, 273, -159, 273, -66, -46, -118, -122,
	-179, 266, 277, 274, 277, 223, -98, 56, 50, -113,
	110, 50, -189, -40, 56, -190, 46, 234, 176, 99,
	-98, 56, -98, 56, 56, -149, 223, 223, -49, -40,
	-115, 247, -104, -19, 273, 76, 25, -75, -76, -152,
	-77, -46, 273, -40, -40, -49, -50, -70, -71, -12,
	-153, 223, 277, -69, -63, -117, -116, 100, 225, -39,
	-38, -51, 179, 208, 185, 200, 277, 5, 8, 8,
	6, -179, -222, -40, -39, -38, -149, -54, -55, -114,
	-113, -191, -189, 113, 234, 88, 160, 151, 88, -103,
	193, 194, 277, -33, 26, 79, 273, 277, 274, -115,
	-151, -67, -147, -149, -28, -148, 273, -155, -156, -158,
	-167, -161, -165, -166, 33, 39, 38, 219, 213, 118,
	119, 120, 207, 31, 180, 95, 82, 75, 74, 156,
	35, 34, -169, -170, -163, -164, 72, 222, 32, 44,
	43, 243, -70, 221, -122, -122, -122, -122, -122, -122,
	-122, -122, -122, -122, -122, -122, -122, -122, -122, -122,
	-122, -122, -122, -122, -122, 134, 205, 30, 112, 223,
	153, 151, 228, 91, 235, 80, 157, -230, 216, 27,
	-128, -28, 273, -179, -133, 193, 273, 274, 277, -72,
	-132, 272, -122, -130, -72, 274, 274, -72, 244, 18,
	80, 266, -94, 252, 143, 73, 109, 142, -95, 198,
	8, -140, -139, 246, -209, 93, 105, 273, 274, 274,
	-122, -89, -172, 4, 252, 143, 73, 109, 142, 198,
	-90, -122, -91, -123, -124, 264, 265, 270, 273, 193,
	-92, -122, -72, -122, 36, 130, 224, -93, -122, 100,
	-72, -122, -122, -122, -72, -72, -72, 273, 8, 8,
	8, -115, 274, 272, 281, -141, -34, -46, -40, -40,
	151, -113, 110, -155, -40, 273, 273, 127, 127, -40,
	-40, 110, -40, 110, -40, -40, -35, 184, -40, -40,
	184, -84, 188, -122, -106, 160, -68, -46, 242, -40,
	-66, 277, 258, -68, -37, -222, -47, -222, -38, 232,
	53, 179, -183, -94, 277, 274, 277, -41, 113, -70,
	-46, 88, -40, -145, -15, -19, -14, -25, -9, -40,
	-81, 105, 277, 59, -88, 126, 146, 101, 132, 190,
	116, -119, 278, -144, -143, 25, -40, -28, -148, -147,
	-65, 24, -94, 273, 253, -122, 223, -230, 216, -128,
	-122, 153, 228, 91, 235, 80, 157, 100, 273, -123,
	-123, -72, 273, -72, -122, 277, 272, 272, 277, 274,
	-60, 277, -59, -122, -72, -72, 274, 223, 223, 223,
	223, 273, 274, -138, -139, 84, -122, -214, 167, 273,
	273, -122, 25, 274, 100, 274, -96, 172, 274, 10,
	264, 265, 266, 267, 268, 261, 262, 263, 260, 256,
	257, 258, 54, 140, 195, 12, 13, 14, 124, 112,
	-123, -123, -123, -72, 273, 274, -126, -127, 100, 97,
	25, -93, -93, -93, 274, 100, -72, 277, 277, 277,
	274, 274, 274, 8, 274, 277, 274, 274, -81, -122,
	223, 223, 88, 151, -192, -190, -122, -63, 273, 273,
	-31, 83, 203, -99, 88, -37, 88, -37, 223, -98,
	56, 223, -74, -84, 55, 274, 277, -115, -76, -141,
	274, -40, -114, 273, -41, 273, 273, -40, 274, -129,
	107, 37, -147, 126, 126, -147, -88, 126, -86, 166,
	-86, -86, -144, -179, 279, -40, 273, 274, 271, 271,
	8, -122, -122, -123, -123, 100, 273, -122, -131, -155,
	22, 22, 274, -72, 274, 277, 274, -122, -130, 274,
	244, -60, -60, -60, 143, 109, 142, -95, 142, -95,
	-95, 8, 6, 85, -122, 220, -215, -40, 273, 247,
	-59, 274, -155, -122, -126, -122, -155, -123, -123, -123,
	-123, -123, -123, -123, -123, -123, -123, -123, -123, -123,
	-123, -123, -123, -123, -123, 80, 151, 157, -123, 277,
	-72, 274, -127, -126, -122, -122, -155, 274, 274, 274,
	-72, -122, -122, -122, 274, 8, -129, 272, -40, -40,
	-113, 88, -193, 56, -194, 48, 151, 153, 234, 176,
	46, 76, 183, 274, 274, -63, -63, 151, 76, 151,
	76, 69, 230, -40, -40, -46, -40, -40, -40, -105,
	273, 160, -19, -46, -84, 258, -62, -146, -40, -203,
	273, -200, -201, -44, 273, -54, -62, 160, -210, 248,
	-122, -72, -147, -147, -87, 238, 160, 126, -147, -121,
	-120, 98, 149, 273, -63, -143, 272, 8, 8, 274,
	22, 22, -122, -131, 274, 277, -122, -122, 274, -122,
	6, -122, 274, 274, 274, 274, -122, -219, -40, -122,
	274, 274, -127, 100, 80, 157, 273, -122, 274, 274,
	277, 274, 274, 274, -210, -113, -40, -70, 153, 127,
	273, -123, -46, -112, -227, 57, 214, 274, 274, 153,
	153, -122, -155, -37, -37, 223, 223, 81, -62, 56,
	-80, -28, 273, 274, 277, -45, -78, 48, -45, -122,
	273, -62, 274, 274, -46, -211, -213, -40, -87, 273,
	-122, -147, 277, 280, 258, -63, 274, 272, 272, -122,
	-122, 274, -155, 274, -60, -212, 171, 274, -123, 100,
	273, -131, 274, -122, -194, -122, -58, 273, 273, 183,
	-36, 48, -40, -40, 236, 152, 274, -40, -112, -146,
	-33, -70, -33, 274, -72, 274, -112, 273, 277, 25,
	-63, -120, -179, 274, 274, -60, 37, -123, -131, 274,
	274, 274, -197, 141, -63, -63, -46, -32, 238, -70,
	203, -115, -45, -60, -112, -62, -213, -215, 274, -216,
	178, 194, -72, 274, -195, -198, -196, 160, 101, 170,
	206, 274, 274, -58, -122, -75, -33, 274, 274, 274,
	-217, -218, 30, 231, 61, -122, -217, -196, 160, -198,
	160, 236, 78, -197, -115, -112, -218, 174, 96, 193,
	174, 96, -199, 148, 187, 40, 203, -199, -195, 22,
	16, 153, 76, -218,
}
var sqlDef = [...]int{

	-2, -2, 1, 3, 4, 5, 6, 7, 8, 9,
	10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
	20, 0, 50, 51, 52, 0, 0, 318, 0, 0,
	0, 288, -2, 0, 0, 251, 0, 251, 251, 255,
	0, 320, 219, 317, -2, 328, 0, 0, 0, 326,
	302, 0, 0, -2, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 66, 0, 68, 69, 70, 71, 0,
	80, 81, 82, 84, 85, 86, 87, 88, 89, 90,
	0, 244, 815, 257, 728, 729, 730, 745, 746, 747,
	748, 749, 750, 751, 752, 753, 754, 755, 756, 757,
	758, 759, 760, 761, 762, 763, 764, 765, 766, 767,
	768, 769, 770, 771, 772, 773, 774, 775, 776, 777,
	778, 779, 780, 781, 782, 783, 784, 785, 786, 787,
	788, 789, 790, 791, 792, 793, 794, 795, 796, 797,
	798, 799, 800, 801, 802, 803, 804, 805, 806, 807,
	808, 809, 810, 811, 812, 813, 814, 816, 817, 818,
	819, 820, 821, 822, 823, 824, 825, 826, 827, 828,
	829, 830, 831, 832, 833, 834, 835, 836, 837, 838,
	839, 840, 841, 842, 843, 844, 845, 846, 847, 848,
	849, 850, 851, 852, 853, 854, 855, 856, 857, 858,
	859, 860, 861, 862, 863, 864, 865, 866, 867, 868,
	869, 870, 871, 872, 873, 874, 875, 876, 877, 878,
	879, 880, 881, 882, 883, 884, 885, 886, 887, 93,
	782, 819, 830, 98, 108, 0, 882, -2, 112, 62,
	815, 141, 142, 0, 144, 157, 0, 0, 0, 155,
	0, 0, 153, 262, 250, 262, 247, 248, 249, 252,
	0, 243, 0, 319, 0, 0, 0, 218, -2, 298,
	299, -2, 0, 323, 323, 323, 0, 0, 299, 0,
	307, 805, 310, 711, 308, 0, 0, 325, 324, 0,
	303, 385, 0, 701, 348, 0, 2, 0, 864, 0,
	0, 864, 0, 0, 0, 0, 391, 54, 864, 45,
	864, 697, 58, 864, 60, 0, 72, 74, 736, 737,
	738, 739, 886, 888, 889, 890, 891, 892, 893, 894,
	895, 896, 897, 898, 899, 900, 0, 0, 0, 256,
	94, 854, 96, 97, 99, 100, 0, 0, 0, 0,
	0, 0, 111, 136, 137, 63, 0, 0, 159, 0,
	0, 0, 0, 149, 0, 150, 0, 152, 245, 258,
	259, 246, 0, 254, 45, 389, 0, 864, 732, 264,
	864, -2, 0, 294, 335, 336, 0, 0, 0, 321,
	322, 0, 0, 0, 290, 291, 0, 309, 0, 0,
	351, 689, 693, 694, 471, 0, 0, 0, 0, 0,
	0, 550, 551, 552, 0, 554, 555, 556, 859, 0,
	560, 561, 878, 701, 714, 715, 716, 717, 0, 0,
	0, 722, 723, 724, 673, 599, 570, -2, -2, 712,
	413, 414, 415, 416, -2, 888, 574, 576, 578, 579,
	580, 581, 0, 860, 874, 875, 881, 884, 885, 864,
	871, 865, 855, 862, 870, 766, -2, -2, -2, -2,
	-2, -2, -2, -2, -2, -2, -2, -2, -2, -2,
	-2, -2, -2, -2, 735, 437, 438, 443, 444, 446,
	351, 349, 386, 387, 0, 702, 680, 674, 675, 0,
	0, 0, 686, 684, 685, 22, 240, 24, 0, 240,
	240, 0, 0, 0, 0, 0, 0, 395, 0, 267,
	0, 392, 0, 0, 56, 0, 43, 44, 0, 0,
	0, 318, 0, 0, 77, 0, 762, 699, 704, 707,
	83, 0, 0, 0, 0, 0, 103, 123, 124, 125,
	104, 106, 113, 115, 116, 117, 126, 127, 128, 129,
	212, 0, 214, 139, 140, 725, 0, 105, 107, 109,
	110, 130, 131, 0, 133, 134, 135, 454, 0, 64,
	740, 741, 742, 743, 744, 901, 902, 903, 904, 905,
	906, 907, 908, 909, 910, 911, 912, 913, 914, 915,
	916, 917, 918, 919, 920, 921, 922, 923, 924, 925,
	926, 927, 928, 929, 930, 931, 932, 933, 934, 935,
	936, 937, 938, 939, 940, 941, 942, 943, 944, 945,
	946, 947, 948, 949, 950, 951, 952, 953, 954, 955,
	956, 957, 958, 959, 960, 961, 962, 963, 964, 965,
	966, 967, 968, 969, 970, 971, 972, 973, 974, 975,
	976, 977, 978, 143, 145, 0, 156, 146, 147, 148,
	154, 151, 0, 0, 253, 215, 0, 163, 0, 0,
	864, 731, 0, 297, 333, 334, 337, 340, 341, 338,
	471, 304, 305, 306, 329, 330, 229, 311, 0, 0,
	708, 395, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 683, 0, 0, 692, 475, 476, 477, 498, 499,
	0, -2, 631, 0, 557, 558, 559, 0, 0, -2,
	0, 719, 468, 0, 0, 672, 601, 0, 0, 0,
	0, 0, 0, 0, 652, 658, 0, 0, 0, 0,
	0, 0, 0, 0, 427, 440, 450, 448, 447, 429,
	0, 428, 426, 0, 430, 0, 395, 0, 681, 0,
	678, 679, 0, 688, 0, 0, 0, 0, 239, 26,
	864, 0, 36, 0, 0, 185, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 703,
	279, 0, 274, 269, 0, 0, 0, 351, 281, 283,
	284, 0, 0, 393, 55, 698, 45, 61, 59, 67,
	73, 0, 0, 78, 79, 705, 706, 0, 0, 101,
	102, 263, 0, 120, 0, 122, 0, 213, 727, 726,
	468, 65, 158, 91, 260, 261, 390, 0, 162, 164,
	166, 167, 168, 732, 0, 0, 0, 0, 0, 339,
	342, 343, 0, 332, 227, 228, 318, 0, 710, 345,
	690, 350, 352, 360, 376, 363, 0, 472, 401, 402,
	403, 404, 405, 468, 408, 409, 410, 411, 412, 420,
	421, 422, 423, 424, 425, 434, 0, 419, 419, 419,
	431, 432, 435, 436, 441, 442, 452, 453, 451, 451,
	451, 449, 473, 0, 478, 479, 480, 481, 482, 483,
	484, 485, 486, -2, -2, -2, 490, 491, 492, -2,
	-2, -2, 496, 497, -2, 0, 0, 683, 0, 0,
	504, 0, 507, 509, 511, 0, 0, 0, 0, 682,
	521, 664, 0, 691, 506, 0, 0, 553, 0, 0,
	0, 637, 631, 638, 0, -2, 562, 328, 0, 0,
	0, 0, 720, 455, 456, 457, 458, 459, 460, 469,
	0, 671, 667, 0, 609, 0, 0, 0, 575, 577,
	0, 0, 0, 641, 642, 643, 644, 645, 646, 647,
	0, 0, 0, 0, 523, 0, 0, 0, 0, 878,
	0, 631, 657, 0, 0, 0, 0, 0, 631, 0,
	663, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 345, 388, 676, 0, 687, 25, 231, 0, 0,
	0, 28, 864, 171, 0, 0, 0, 0, 0, 242,
	37, 864, 45, 864, 45, 38, 23, 240, 230, 233,
	0, 53, 0, 394, 279, 0, 0, 695, 271, 268,
	395, 0, 0, 0, 57, 75, 700, 76, 95, 118,
	119, 121, 114, 132, 0, 160, 0, 0, 732, 0,
	0, 0, 265, 331, 0, 313, 314, 315, 316, 709,
	347, 0, 0, 0, 0, 0, 0, 382, 382, 382,
	380, 376, 0, 362, 375, 0, 374, -2, 363, 0,
	396, 398, 406, 0, 0, -2, 0, 0, 0, 522,
	-2, 505, 508, 510, 512, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 632, 0, 635, 636, 0, -2,
	0, 0, 327, 328, 328, 328, 568, 0, 0, 0,
	0, 0, 0, 0, 668, 0, 0, 569, 0, 0,
	0, 0, 0, 583, 0, 584, 0, 0, 585, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	525, 526, 527, 0, 0, 586, 655, 656, 0, 0,
	0, 0, 0, 0, 591, 0, 662, 0, 0, 0,
	595, 596, 597, 0, 417, 0, 433, 445, 347, 0,
	0, 0, 0, 0, 169, 184, 0, 0, 0, 0,
	30, 0, 0, 0, 0, 34, 0, 40, 0, 0,
	0, 0, 278, 266, 277, 0, 0, 279, 282, 285,
	0, 92, 165, 0, 0, 163, 0, 0, 312, 603,
	0, 0, 353, 0, 0, 0, 0, 0, 377, 381,
	378, 379, 361, 358, 0, 372, 0, 365, 0, 0,
	0, 474, -2, 0, 0, 0, 0, -2, 0, 633,
	0, 0, 665, 0, 626, 0, -2, 632, 639, 563,
	0, 0, 0, 0, 461, 462, 463, 464, 465, 466,
	467, 0, 721, 666, 670, 0, 607, 608, 612, 0,
	0, 573, 0, 640, 649, 650, 524, 528, 529, 530,
	531, 532, 533, 534, 535, 536, -2, -2, -2, 540,
	541, 542, -2, -2, -2, 0, 0, 0, 651, 0,
	0, 629, 653, 654, 659, 660, 0, 588, 589, 590,
	661, 0, 0, 0, 439, 0, 603, 677, 235, 237,
	27, 0, 170, 0, 173, 0, 0, 176, 177, 0,
	0, 0, 0, 186, 193, 0, 0, 0, 42, 0,
	0, 241, 0, 45, 45, 232, 0, 0, 234, 0,
	0, 0, 270, 696, 280, 0, 0, 220, 226, 226,
	0, 571, 572, 0, 0, 0, 0, 0, 300, 0,
	346, 344, 366, 0, 368, 0, 0, 0, 370, 0,
	356, 0, 355, 0, 0, 364, 399, 0, 0, 407,
	0, 0, -2, 0, 515, 0, -2, -2, 625, 632,
	718, 328, 564, 566, 567, 470, 669, 614, 611, 0,
	598, 582, 648, 0, 0, 0, 0, 632, 628, 587,
	0, 593, 594, 418, 301, 29, 0, 174, 175, 178,
	0, 180, 195, 187, 0, 190, 191, 188, 0, 31,
	32, 41, 47, 33, 39, 0, 0, 0, 0, 0,
	286, 287, 0, 193, 0, 229, 713, 0, 229, 0,
	0, 0, 161, 193, 0, 602, 604, 0, 367, 0,
	384, 369, 0, 359, 0, 0, 373, 400, 397, -2,
	-2, 516, 634, 627, 0, 328, 0, 600, -2, 0,
	0, 0, 630, 0, 172, 0, 199, 0, 0, 0,
	49, 0, 236, 238, 0, 273, 395, 276, 182, 221,
	222, 225, 223, 226, 328, 193, 216, 0, 0, 0,
	0, 357, 354, 371, 565, 617, 0, -2, 0, 548,
	592, 179, 204, 0, 0, 0, 195, 35, 0, 46,
	0, 275, 229, 0, 183, 0, 605, 606, 383, 0,
	0, 0, 613, 549, 181, 200, 201, 0, 196, 197,
	198, 194, 192, 199, 48, 395, 224, 563, 193, 610,
	615, 618, -2, 833, 759, 0, 616, 202, 0, 203,
	0, 0, 0, 204, 272, 217, 0, 620, 621, 622,
	623, 624, 205, 0, 208, 209, 0, 206, 189, 0,
	207, 210, 211, 619,
}
var sqlTok1 = [...]int{

	1, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 262, 3, 268, 263, 3,
	273, 274, 266, 264, 277, 265, 275, 267, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 281, 276,
	256, 258, 257, 3, 278, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 271, 3, 272, 261, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 279, 260, 280, 270,
}
var sqlTok2 = [...]int{

	2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
	22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
	42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
	52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
	62, 63, 64, 65, 66, 67, 68, 69, 70, 71,
	72, 73, 74, 75, 76, 77, 78, 79, 80, 81,
	82, 83, 84, 85, 86, 87, 88, 89, 90, 91,
	92, 93, 94, 95, 96, 97, 98, 99, 100, 101,
	102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
	112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
	122, 123, 124, 125, 126, 127, 128, 129, 130, 131,
	132, 133, 134, 135, 136, 137, 138, 139, 140, 141,
	142, 143, 144, 145, 146, 147, 148, 149, 150, 151,
	152, 153, 154, 155, 156, 157, 158, 159, 160, 161,
	162, 163, 164, 165, 166, 167, 168, 169, 170, 171,
	172, 173, 174, 175, 176, 177, 178, 179, 180, 181,
	182, 183, 184, 185, 186, 187, 188, 189, 190, 191,
	192, 193, 194, 195, 196, 197, 198, 199, 200, 201,
	202, 203, 204, 205, 206, 207, 208, 209, 210, 211,
	212, 213, 214, 215, 216, 217, 218, 219, 220, 221,
	222, 223, 224, 225, 226, 227, 228, 229, 230, 231,
	232, 233, 234, 235, 236, 237, 238, 239, 240, 241,
	242, 243, 244, 245, 246, 247, 248, 249, 250, 251,
	252, 253, 254, 255, 259, 269,
}
var sqlTok3 = [...]int{
	0,
}

var sqlErrorMessages = [...]struct {
	state int
	token int
	msg   string
}{}

//line yaccpar:1

/*	parser for yacc output	*/

var (
	sqlDebug        = 0
	sqlErrorVerbose = false
)

type sqlLexer interface {
	Lex(lval *sqlSymType) int
	Error(s string)
}

type sqlParser interface {
	Parse(sqlLexer) int
	Lookahead() int
}

type sqlParserImpl struct {
	lval  sqlSymType
	stack [sqlInitialStackSize]sqlSymType
	char  int
}

func (p *sqlParserImpl) Lookahead() int {
	return p.char
}

func sqlNewParser() sqlParser {
	return &sqlParserImpl{}
}

const sqlFlag = -1000

func sqlTokname(c int) string {
	if c >= 1 && c-1 < len(sqlToknames) {
		if sqlToknames[c-1] != "" {
			return sqlToknames[c-1]
		}
	}
	return __yyfmt__.Sprintf("tok-%v", c)
}

func sqlStatname(s int) string {
	if s >= 0 && s < len(sqlStatenames) {
		if sqlStatenames[s] != "" {
			return sqlStatenames[s]
		}
	}
	return __yyfmt__.Sprintf("state-%v", s)
}

func sqlErrorMessage(state, lookAhead int) string {
	const TOKSTART = 4

	if !sqlErrorVerbose {
		return "syntax error"
	}

	for _, e := range sqlErrorMessages {
		if e.state == state && e.token == lookAhead {
			return "syntax error: " + e.msg
		}
	}

	res := "syntax error: unexpected " + sqlTokname(lookAhead)

	// To match Bison, suggest at most four expected tokens.
	expected := make([]int, 0, 4)

	// Look for shiftable tokens.
	base := sqlPact[state]
	for tok := TOKSTART; tok-1 < len(sqlToknames); tok++ {
		if n := base + tok; n >= 0 && n < sqlLast && sqlChk[sqlAct[n]] == tok {
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}
	}

	if sqlDef[state] == -2 {
		i := 0
		for sqlExca[i] != -1 || sqlExca[i+1] != state {
			i += 2
		}

		// Look for tokens that we accept or reduce.
		for i += 2; sqlExca[i] >= 0; i += 2 {
			tok := sqlExca[i]
			if tok < TOKSTART || sqlExca[i+1] == 0 {
				continue
			}
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}

		// If the default action is to accept or reduce, give up.
		if sqlExca[i+1] != 0 {
			return res
		}
	}

	for i, tok := range expected {
		if i == 0 {
			res += ", expecting "
		} else {
			res += " or "
		}
		res += sqlTokname(tok)
	}
	return res
}

func sqllex1(lex sqlLexer, lval *sqlSymType) (char, token int) {
	token = 0
	char = lex.Lex(lval)
	if char <= 0 {
		token = sqlTok1[0]
		goto out
	}
	if char < len(sqlTok1) {
		token = sqlTok1[char]
		goto out
	}
	if char >= sqlPrivate {
		if char < sqlPrivate+len(sqlTok2) {
			token = sqlTok2[char-sqlPrivate]
			goto out
		}
	}
	for i := 0; i < len(sqlTok3); i += 2 {
		token = sqlTok3[i+0]
		if token == char {
			token = sqlTok3[i+1]
			goto out
		}
	}

out:
	if token == 0 {
		token = sqlTok2[1] /* unknown char */
	}
	if sqlDebug >= 3 {
		__yyfmt__.Printf("lex %s(%d)\n", sqlTokname(token), uint(char))
	}
	return char, token
}

func sqlParse(sqllex sqlLexer) int {
	return sqlNewParser().Parse(sqllex)
}

func (sqlrcvr *sqlParserImpl) Parse(sqllex sqlLexer) int {
	var sqln int
	var sqlVAL sqlSymType
	var sqlDollar []sqlSymType
	_ = sqlDollar // silence set and not used
	sqlS := sqlrcvr.stack[:]

	Nerrs := 0   /* number of errors */
	Errflag := 0 /* error recovery flag */
	sqlstate := 0
	sqlrcvr.char = -1
	sqltoken := -1 // sqlrcvr.char translated into internal numbering
	defer func() {
		// Make sure we report no lookahead when not parsing.
		sqlstate = -1
		sqlrcvr.char = -1
		sqltoken = -1
	}()
	sqlp := -1
	goto sqlstack

ret0:
	return 0

ret1:
	return 1

sqlstack:
	/* put a state and value onto the stack */
	if sqlDebug >= 4 {
		__yyfmt__.Printf("char %v in %v\n", sqlTokname(sqltoken), sqlStatname(sqlstate))
	}

	sqlp++
	if sqlp >= len(sqlS) {
		nyys := make([]sqlSymType, len(sqlS)*2)
		copy(nyys, sqlS)
		sqlS = nyys
	}
	sqlS[sqlp] = sqlVAL
	sqlS[sqlp].yys = sqlstate

sqlnewstate:
	sqln = sqlPact[sqlstate]
	if sqln <= sqlFlag {
		goto sqldefault /* simple state */
	}
	if sqlrcvr.char < 0 {
		sqlrcvr.char, sqltoken = sqllex1(sqllex, &sqlrcvr.lval)
	}
	sqln += sqltoken
	if sqln < 0 || sqln >= sqlLast {
		goto sqldefault
	}
	sqln = sqlAct[sqln]
	if sqlChk[sqln] == sqltoken { /* valid shift */
		sqlrcvr.char = -1
		sqltoken = -1
		sqlVAL = sqlrcvr.lval
		sqlstate = sqln
		if Errflag > 0 {
			Errflag--
		}
		goto sqlstack
	}

sqldefault:
	/* default state action */
	sqln = sqlDef[sqlstate]
	if sqln == -2 {
		if sqlrcvr.char < 0 {
			sqlrcvr.char, sqltoken = sqllex1(sqllex, &sqlrcvr.lval)
		}

		/* look through exception table */
		xi := 0
		for {
			if sqlExca[xi+0] == -1 && sqlExca[xi+1] == sqlstate {
				break
			}
			xi += 2
		}
		for xi += 2; ; xi += 2 {
			sqln = sqlExca[xi+0]
			if sqln < 0 || sqln == sqltoken {
				break
			}
		}
		sqln = sqlExca[xi+1]
		if sqln < 0 {
			goto ret0
		}
	}
	if sqln == 0 {
		/* error ... attempt to resume parsing */
		switch Errflag {
		case 0: /* brand new error */
			sqllex.Error(sqlErrorMessage(sqlstate, sqltoken))
			Nerrs++
			if sqlDebug >= 1 {
				__yyfmt__.Printf("%s", sqlStatname(sqlstate))
				__yyfmt__.Printf(" saw %s\n", sqlTokname(sqltoken))
			}
			fallthrough

		case 1, 2: /* incompletely recovered error ... try again */
			Errflag = 3

			/* find a state where "error" is a legal shift action */
			for sqlp >= 0 {
				sqln = sqlPact[sqlS[sqlp].yys] + sqlErrCode
				if sqln >= 0 && sqln < sqlLast {
					sqlstate = sqlAct[sqln] /* simulate a shift of "error" */
					if sqlChk[sqlstate] == sqlErrCode {
						goto sqlstack
					}
				}

				/* the current p has no shift on "error", pop stack */
				if sqlDebug >= 2 {
					__yyfmt__.Printf("error recovery pops state %d\n", sqlS[sqlp].yys)
				}
				sqlp--
			}
			/* there is no state on the stack with an error shift ... abort */
			goto ret1

		case 3: /* no shift yet; clobber input char */
			if sqlDebug >= 2 {
				__yyfmt__.Printf("error recovery discards %s\n", sqlTokname(sqltoken))
			}
			if sqltoken == sqlEofCode {
				goto ret1
			}
			sqlrcvr.char = -1
			sqltoken = -1
			goto sqlnewstate /* try again in the same state */
		}
	}

	/* reduction by production sqln */
	if sqlDebug >= 2 {
		__yyfmt__.Printf("reduce %v in:\n\t%v\n", sqln, sqlStatname(sqlstate))
	}

	sqlnt := sqln
	sqlpt := sqlp
	_ = sqlpt // guard against "declared and not used"

	sqlp -= sqlR2[sqln]
	// sqlp is now the index of $0. Perform the default action. Iff the
	// reduced production is ε, $1 is possibly out of range.
	if sqlp+1 >= len(sqlS) {
		nyys := make([]sqlSymType, len(sqlS)*2)
		copy(nyys, sqlS)
		sqlS = nyys
	}
	sqlVAL = sqlS[sqlp+1]

	/* consult goto table to find next state */
	sqln = sqlR1[sqln]
	sqlg := sqlPgo[sqln]
	sqlj := sqlg + sqlS[sqlp].yys + 1

	if sqlj >= sqlLast {
		sqlstate = sqlAct[sqlg]
	} else {
		sqlstate = sqlAct[sqlj]
		if sqlChk[sqlstate] != -sqln {
			sqlstate = sqlAct[sqlg]
		}
	}
	// dummy call; replaced with literal code
	switch sqlnt {

	case 1:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:647
		{
			sqllex.(*scanner).stmts = sqlDollar[1].union.stmts()
		}
	case 2:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:653
		{
			if sqlDollar[3].union.stmt() != nil {
				sqlVAL.union.val = append(sqlDollar[1].union.stmts(), sqlDollar[3].union.stmt())
			}
		}
	case 3:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:659
		{
			if sqlDollar[1].union.stmt() != nil {
				sqlVAL.union.val = []Statement{sqlDollar[1].union.stmt()}
			} else {
				sqlVAL.union.val = []Statement(nil)
			}
		}
	case 14:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:679
		{
			sqlVAL.union.val = sqlDollar[1].union.slct()
		}
	case 21:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:689
		{
			sqlVAL.union.val = Statement(nil)
		}
	case 22:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:695
		{
			sqlVAL.union.val = &AlterTable{Table: sqlDollar[3].union.qname(), IfExists: false, Cmds: sqlDollar[4].union.alterTableCmds()}
		}
	case 23:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:699
		{
			sqlVAL.union.val = &AlterTable{Table: sqlDollar[5].union.qname(), IfExists: true, Cmds: sqlDollar[6].union.alterTableCmds()}
		}
	case 24:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:705
		{
			sqlVAL.union.val = AlterTableCmds{sqlDollar[1].union.alterTableCmd()}
		}
	case 25:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:709
		{
			sqlVAL.union.val = append(sqlDollar[1].union.alterTableCmds(), sqlDollar[3].union.alterTableCmd())
		}
	case 26:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:716
		{
			sqlVAL.union.val = &AlterTableAddColumn{columnKeyword: false, IfNotExists: false, ColumnDef: sqlDollar[2].union.colDef()}
		}
	case 27:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:721
		{
			sqlVAL.union.val = &AlterTableAddColumn{columnKeyword: false, IfNotExists: true, ColumnDef: sqlDollar[5].union.colDef()}
		}
	case 28:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:726
		{
			sqlVAL.union.val = &AlterTableAddColumn{columnKeyword: true, IfNotExists: false, ColumnDef: sqlDollar[3].union.colDef()}
		}
	case 29:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:731
		{
			sqlVAL.union.val = &AlterTableAddColumn{columnKeyword: true, IfNotExists: true, ColumnDef: sqlDollar[6].union.colDef()}
		}
	case 30:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:735
		{
			unimplemented()
		}
	case 31:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:737
		{
			unimplemented()
		}
	case 32:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:739
		{
			unimplemented()
		}
	case 33:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:742
		{
			sqlVAL.union.val = &AlterTableDropColumn{columnKeyword: sqlDollar[2].union.bool(), IfExists: true, Column: sqlDollar[5].str}
		}
	case 34:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:747
		{
			sqlVAL.union.val = &AlterTableDropColumn{columnKeyword: sqlDollar[2].union.bool(), IfExists: false, Column: sqlDollar[3].str}
		}
	case 35:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:752
		{
		}
	case 36:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:755
		{
			sqlVAL.union.val = &AlterTableAddConstraint{ConstraintDef: sqlDollar[2].union.constraintDef()}
		}
	case 37:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:759
		{
			unimplemented()
		}
	case 38:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:761
		{
			unimplemented()
		}
	case 39:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:764
		{
			sqlVAL.union.val = &AlterTableDropConstraint{IfExists: true, Constraint: sqlDollar[5].str}
		}
	case 40:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:769
		{
			sqlVAL.union.val = &AlterTableDropConstraint{IfExists: false, Constraint: sqlDollar[3].str}
		}
	case 41:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:774
		{
			unimplemented()
		}
	case 42:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:775
		{
			unimplemented()
		}
	case 43:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:778
		{
			unimplemented()
		}
	case 44:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:779
		{
			unimplemented()
		}
	case 45:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:780
		{
		}
	case 46:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:783
		{
			unimplemented()
		}
	case 47:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:784
		{
		}
	case 48:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:787
		{
			unimplemented()
		}
	case 49:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:788
		{
		}
	case 53:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:799
		{
			sqlVAL.union.val = &Delete{Table: sqlDollar[4].union.tblExpr(), Where: newWhere(astWhere, sqlDollar[5].union.expr()), Returning: sqlDollar[6].union.retExprs()}
		}
	case 54:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:806
		{
			sqlVAL.union.val = &DropDatabase{Name: Name(sqlDollar[3].str), IfExists: false}
		}
	case 55:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:810
		{
			sqlVAL.union.val = &DropDatabase{Name: Name(sqlDollar[5].str), IfExists: true}
		}
	case 56:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:814
		{
			sqlVAL.union.val = &DropIndex{IndexList: sqlDollar[3].union.tableWithIdxList(), IfExists: false}
		}
	case 57:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:818
		{
			sqlVAL.union.val = &DropIndex{IndexList: sqlDollar[5].union.tableWithIdxList(), IfExists: true}
		}
	case 58:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:822
		{
			sqlVAL.union.val = &DropTable{Names: sqlDollar[3].union.qnames(), IfExists: false}
		}
	case 59:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:826
		{
			sqlVAL.union.val = &DropTable{Names: sqlDollar[5].union.qnames(), IfExists: true}
		}
	case 60:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:832
		{
			sqlVAL.union.val = QualifiedNames{sqlDollar[1].union.qname()}
		}
	case 61:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:836
		{
			sqlVAL.union.val = append(sqlDollar[1].union.qnames(), sqlDollar[3].union.qname())
		}
	case 62:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:842
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str)}
		}
	case 63:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:846
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str), Indirect: sqlDollar[2].union.indirect()}
		}
	case 64:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:852
		{
			sqlVAL.union.val = Indirection{NameIndirection(sqlDollar[2].str)}
		}
	case 65:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:856
		{
			sqlVAL.union.val = append(sqlDollar[1].union.indirect(), NameIndirection(sqlDollar[3].str))
		}
	case 66:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:863
		{
			sqlVAL.union.val = &Explain{Statement: sqlDollar[2].union.stmt()}
		}
	case 67:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:867
		{
			sqlVAL.union.val = &Explain{Options: sqlDollar[3].union.strs(), Statement: sqlDollar[5].union.stmt()}
		}
	case 68:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:873
		{
			sqlVAL.union.val = sqlDollar[1].union.slct()
		}
	case 72:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:882
		{
			sqlVAL.union.val = []string{sqlDollar[1].str}
		}
	case 73:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:886
		{
			sqlVAL.union.val = append(sqlDollar[1].union.strs(), sqlDollar[3].str)
		}
	case 75:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:896
		{
			sqlVAL.union.val = &Grant{Privileges: sqlDollar[2].union.privilegeList(), Grantees: NameList(sqlDollar[6].union.strs()), Targets: sqlDollar[4].union.targetList()}
		}
	case 76:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:903
		{
			sqlVAL.union.val = &Revoke{Privileges: sqlDollar[2].union.privilegeList(), Grantees: NameList(sqlDollar[6].union.strs()), Targets: sqlDollar[4].union.targetList()}
		}
	case 77:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:910
		{
			sqlVAL.union.val = TargetList{Tables: QualifiedNames(sqlDollar[1].union.qnames())}
		}
	case 78:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:914
		{
			sqlVAL.union.val = TargetList{Tables: QualifiedNames(sqlDollar[2].union.qnames())}
		}
	case 79:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:918
		{
			sqlVAL.union.val = TargetList{Databases: NameList(sqlDollar[2].union.strs())}
		}
	case 80:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:925
		{
			sqlVAL.union.val = privilege.List{privilege.ALL}
		}
	case 81:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:928
		{
		}
	case 82:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:932
		{
			sqlVAL.union.val = privilege.List{sqlDollar[1].union.privilegeType()}
		}
	case 83:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:936
		{
			sqlVAL.union.val = append(sqlDollar[1].union.privilegeList(), sqlDollar[3].union.privilegeType())
		}
	case 84:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:943
		{
			sqlVAL.union.val = privilege.CREATE
		}
	case 85:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:947
		{
			sqlVAL.union.val = privilege.DROP
		}
	case 86:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:951
		{
			sqlVAL.union.val = privilege.GRANT
		}
	case 87:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:955
		{
			sqlVAL.union.val = privilege.SELECT
		}
	case 88:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:959
		{
			sqlVAL.union.val = privilege.INSERT
		}
	case 89:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:963
		{
			sqlVAL.union.val = privilege.DELETE
		}
	case 90:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:967
		{
			sqlVAL.union.val = privilege.UPDATE
		}
	case 91:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:975
		{
			sqlVAL.union.val = []string{sqlDollar[1].str}
		}
	case 92:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:979
		{
			sqlVAL.union.val = append(sqlDollar[1].union.strs(), sqlDollar[3].str)
		}
	case 93:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:987
		{
			sqlVAL.union.val = sqlDollar[2].union.stmt()
		}
	case 94:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:991
		{
			sqlVAL.union.val = sqlDollar[3].union.stmt()
		}
	case 95:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:995
		{
			sqlVAL.union.val = &SetDefaultIsolation{Isolation: sqlDollar[6].union.isoLevel()}
		}
	case 96:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:999
		{
			sqlVAL.union.val = sqlDollar[3].union.stmt()
		}
	case 97:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1005
		{
			sqlVAL.union.val = sqlDollar[2].union.stmt()
		}
	case 99:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1012
		{
			sqlVAL.union.val = &SetTransaction{Isolation: sqlDollar[1].union.isoLevel(), UserPriority: UnspecifiedUserPriority}
		}
	case 100:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1016
		{
			sqlVAL.union.val = &SetTransaction{Isolation: UnspecifiedIsolation, UserPriority: sqlDollar[1].union.userPriority()}
		}
	case 101:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1020
		{
			sqlVAL.union.val = &SetTransaction{Isolation: sqlDollar[1].union.isoLevel(), UserPriority: sqlDollar[3].union.userPriority()}
		}
	case 102:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1024
		{
			sqlVAL.union.val = &SetTransaction{Isolation: sqlDollar[3].union.isoLevel(), UserPriority: sqlDollar[1].union.userPriority()}
		}
	case 103:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1031
		{
			sqlVAL.union.val = sqlDollar[2].union.userPriority()
		}
	case 104:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1037
		{
			sqlVAL.union.val = &Set{Name: sqlDollar[1].union.qname(), Values: sqlDollar[3].union.exprs()}
		}
	case 105:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1041
		{
			sqlVAL.union.val = &Set{Name: sqlDollar[1].union.qname(), Values: sqlDollar[3].union.exprs()}
		}
	case 106:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1045
		{
			sqlVAL.union.val = &Set{Name: sqlDollar[1].union.qname()}
		}
	case 107:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1049
		{
			sqlVAL.union.val = &Set{Name: sqlDollar[1].union.qname()}
		}
	case 109:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1056
		{
			unimplemented()
		}
	case 110:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1059
		{
			sqlVAL.union.val = &SetTimeZone{Value: sqlDollar[3].union.expr()}
		}
	case 111:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1062
		{
			unimplemented()
		}
	case 113:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1069
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr()}
		}
	case 114:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1073
		{
			sqlVAL.union.val = append(sqlDollar[1].union.exprs(), sqlDollar[3].union.expr())
		}
	case 117:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1081
		{
			sqlVAL.union.val = ValArg{name: sqlDollar[1].str}
		}
	case 118:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1087
		{
			sqlVAL.union.val = SnapshotIsolation
		}
	case 119:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1091
		{
			sqlVAL.union.val = SnapshotIsolation
		}
	case 120:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1095
		{
			sqlVAL.union.val = SnapshotIsolation
		}
	case 121:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1099
		{
			sqlVAL.union.val = SerializableIsolation
		}
	case 122:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1103
		{
			sqlVAL.union.val = SerializableIsolation
		}
	case 123:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1109
		{
			sqlVAL.union.val = Low
		}
	case 124:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1113
		{
			sqlVAL.union.val = Normal
		}
	case 125:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1117
		{
			sqlVAL.union.val = High
		}
	case 126:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1123
		{
			sqlVAL.union.val = DBool(true)
		}
	case 127:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1127
		{
			sqlVAL.union.val = DBool(false)
		}
	case 128:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1131
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 130:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1146
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 131:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1150
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 132:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1154
		{
			expr := &CastExpr{Expr: DString(sqlDollar[2].str), Type: sqlDollar[1].union.colType()}
			var ctx EvalContext
			d, err := expr.Eval(ctx)
			if err != nil {
				sqllex.Error("cannot evaluate to an interval type")
				return 1
			}
			if _, ok := d.(DInterval); !ok {
				panic("not an interval type")
			}
			sqlVAL.union.val = d
		}
	case 134:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1169
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 135:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1173
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 136:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1178
		{
			unimplemented()
		}
	case 137:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1179
		{
			unimplemented()
		}
	case 138:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1180
		{
		}
	case 139:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1184
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 140:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1188
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 141:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1194
		{
			sqlVAL.union.val = &Show{Name: sqlDollar[2].str}
		}
	case 142:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1198
		{
			sqlVAL.union.val = &Show{Name: sqlDollar[2].str}
		}
	case 143:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1202
		{
			sqlVAL.union.val = &ShowColumns{Table: sqlDollar[4].union.qname()}
		}
	case 144:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1206
		{
			sqlVAL.union.val = &ShowDatabases{}
		}
	case 145:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1210
		{
			sqlVAL.union.val = &ShowGrants{Targets: sqlDollar[3].union.targetListPtr(), Grantees: sqlDollar[4].union.strs()}
		}
	case 146:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1214
		{
			sqlVAL.union.val = &ShowIndex{Table: sqlDollar[4].union.qname()}
		}
	case 147:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1218
		{
			sqlVAL.union.val = &ShowIndex{Table: sqlDollar[4].union.qname()}
		}
	case 148:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1222
		{
			sqlVAL.union.val = &ShowIndex{Table: sqlDollar[4].union.qname()}
		}
	case 149:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1226
		{
			sqlVAL.union.val = &ShowTables{Name: sqlDollar[3].union.qname()}
		}
	case 150:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1230
		{
			sqlVAL.union.val = &Show{Name: "TIME ZONE"}
		}
	case 151:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1234
		{
			sqlVAL.union.val = &Show{Name: "TRANSACTION ISOLATION LEVEL"}
		}
	case 152:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1238
		{
			sqlVAL.union.val = &Show{Name: "TRANSACTION PRIORITY"}
		}
	case 153:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1242
		{
			sqlVAL.union.val = Statement(nil)
		}
	case 154:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1248
		{
			sqlVAL.union.val = sqlDollar[2].union.qname()
		}
	case 155:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1252
		{
			sqlVAL.union.val = (*QualifiedName)(nil)
		}
	case 156:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1258
		{
			tmp := sqlDollar[2].union.targetList()
			sqlVAL.union.val = &tmp
		}
	case 157:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1263
		{
			sqlVAL.union.val = (*TargetList)(nil)
		}
	case 158:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1269
		{
			sqlVAL.union.val = sqlDollar[2].union.strs()
		}
	case 159:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1273
		{
			sqlVAL.union.val = []string(nil)
		}
	case 160:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:1280
		{
			sqlVAL.union.val = &CreateTable{Table: sqlDollar[3].union.qname(), IfNotExists: false, Defs: sqlDollar[5].union.tblDefs()}
		}
	case 161:
		sqlDollar = sqlS[sqlpt-9 : sqlpt+1]
		//line sql.y:1284
		{
			sqlVAL.union.val = &CreateTable{Table: sqlDollar[6].union.qname(), IfNotExists: true, Defs: sqlDollar[8].union.tblDefs()}
		}
	case 163:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1291
		{
			sqlVAL.union.val = TableDefs(nil)
		}
	case 164:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1297
		{
			sqlVAL.union.val = TableDefs{sqlDollar[1].union.tblDef()}
		}
	case 165:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1301
		{
			sqlVAL.union.val = append(sqlDollar[1].union.tblDefs(), sqlDollar[3].union.tblDef())
		}
	case 166:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1307
		{
			sqlVAL.union.val = sqlDollar[1].union.colDef()
		}
	case 168:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1312
		{
			sqlVAL.union.val = sqlDollar[1].union.constraintDef()
		}
	case 169:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1318
		{
			sqlVAL.union.val = newColumnTableDef(Name(sqlDollar[1].str), sqlDollar[2].union.colType(), sqlDollar[3].union.colQuals())
		}
	case 170:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1324
		{
			sqlVAL.union.val = append(sqlDollar[1].union.colQuals(), sqlDollar[2].union.colQual())
		}
	case 171:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1328
		{
			sqlVAL.union.val = []ColumnQualification(nil)
		}
	case 172:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1334
		{
			sqlVAL.union.val = sqlDollar[3].union.colQual()
		}
	case 174:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1338
		{
			unimplemented()
		}
	case 175:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1354
		{
			sqlVAL.union.val = NotNullConstraint{}
		}
	case 176:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1358
		{
			sqlVAL.union.val = NullConstraint{}
		}
	case 177:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1362
		{
			sqlVAL.union.val = UniqueConstraint{}
		}
	case 178:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1366
		{
			sqlVAL.union.val = PrimaryKeyConstraint{}
		}
	case 179:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1369
		{
			unimplemented()
		}
	case 180:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1371
		{
			if ContainsVars(sqlDollar[2].union.expr()) {
				sqllex.Error("default expression contains a variable")
				return 1
			}
			if containsSubquery(sqlDollar[2].union.expr()) {
				sqllex.Error("default expression contains a subquery")
				return 1
			}
			sqlVAL.union.val = &ColumnDefault{Expr: sqlDollar[2].union.expr()}
		}
	case 181:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1382
		{
			unimplemented()
		}
	case 182:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:1386
		{
			sqlVAL.union.val = &IndexTableDef{
				Name:    Name(sqlDollar[2].str),
				Columns: sqlDollar[4].union.idxElems(),
				Storing: sqlDollar[6].union.strs(),
			}
		}
	case 183:
		sqlDollar = sqlS[sqlpt-7 : sqlpt+1]
		//line sql.y:1394
		{
			sqlVAL.union.val = &UniqueConstraintTableDef{
				IndexTableDef: IndexTableDef{
					Name:    Name(sqlDollar[3].str),
					Columns: sqlDollar[5].union.idxElems(),
					Storing: sqlDollar[7].union.strs(),
				},
			}
		}
	case 184:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1409
		{
			sqlVAL.union.val = sqlDollar[3].union.constraintDef()
			sqlVAL.union.val.(ConstraintTableDef).setName(Name(sqlDollar[2].str))
		}
	case 185:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1414
		{
			sqlVAL.union.val = sqlDollar[1].union.constraintDef()
		}
	case 186:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1419
		{
			unimplemented()
		}
	case 187:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1421
		{
			sqlVAL.union.val = &UniqueConstraintTableDef{
				IndexTableDef: IndexTableDef{
					Columns: NameListToIndexElems(sqlDollar[3].union.strs()),
					Storing: sqlDollar[5].union.strs(),
				},
			}
		}
	case 188:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1430
		{
			sqlVAL.union.val = &UniqueConstraintTableDef{
				IndexTableDef: IndexTableDef{
					Columns: NameListToIndexElems(sqlDollar[4].union.strs()),
				},
				PrimaryKey: true,
			}
		}
	case 189:
		sqlDollar = sqlS[sqlpt-10 : sqlpt+1]
		//line sql.y:1439
		{
			unimplemented()
		}
	case 192:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1456
		{
			sqlVAL.union.val = sqlDollar[3].union.strs()
		}
	case 193:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1460
		{
			sqlVAL.union.val = []string(nil)
		}
	case 194:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1466
		{
			sqlVAL.union.val = sqlDollar[2].union.strs()
		}
	case 195:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1470
		{
			sqlVAL.union.val = []string(nil)
		}
	case 196:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1475
		{
			unimplemented()
		}
	case 197:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1476
		{
			unimplemented()
		}
	case 198:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1477
		{
			unimplemented()
		}
	case 199:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1478
		{
		}
	case 200:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1485
		{
			unimplemented()
		}
	case 201:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1486
		{
			unimplemented()
		}
	case 202:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1487
		{
			unimplemented()
		}
	case 203:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1488
		{
			unimplemented()
		}
	case 204:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1489
		{
		}
	case 205:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1492
		{
			unimplemented()
		}
	case 206:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1495
		{
			unimplemented()
		}
	case 207:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1498
		{
			unimplemented()
		}
	case 208:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1499
		{
			unimplemented()
		}
	case 209:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1500
		{
			unimplemented()
		}
	case 210:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1501
		{
			unimplemented()
		}
	case 211:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1502
		{
			unimplemented()
		}
	case 212:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1506
		{
			sqlVAL.union.val = NumVal(sqlDollar[1].str)
		}
	case 213:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1510
		{
			sqlVAL.union.val = NumVal("-" + sqlDollar[2].str)
		}
	case 214:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1514
		{
			sqlVAL.union.val = DInt(sqlDollar[1].union.ival().Val)
		}
	case 215:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1521
		{
			sqlVAL.union.val = &Truncate{Tables: sqlDollar[3].union.qnames()}
		}
	case 216:
		sqlDollar = sqlS[sqlpt-10 : sqlpt+1]
		//line sql.y:1528
		{
			sqlVAL.union.val = &CreateIndex{
				Name:    Name(sqlDollar[4].str),
				Table:   sqlDollar[6].union.qname(),
				Unique:  sqlDollar[2].union.bool(),
				Columns: sqlDollar[8].union.idxElems(),
				Storing: sqlDollar[10].union.strs(),
			}
		}
	case 217:
		sqlDollar = sqlS[sqlpt-13 : sqlpt+1]
		//line sql.y:1538
		{
			sqlVAL.union.val = &CreateIndex{
				Name:        Name(sqlDollar[7].str),
				Table:       sqlDollar[9].union.qname(),
				Unique:      sqlDollar[2].union.bool(),
				IfNotExists: true,
				Columns:     sqlDollar[11].union.idxElems(),
				Storing:     sqlDollar[13].union.strs(),
			}
		}
	case 218:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1551
		{
			sqlVAL.union.val = true
		}
	case 219:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1555
		{
			sqlVAL.union.val = false
		}
	case 220:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1561
		{
			sqlVAL.union.val = IndexElemList{sqlDollar[1].union.idxElem()}
		}
	case 221:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1565
		{
			sqlVAL.union.val = append(sqlDollar[1].union.idxElems(), sqlDollar[3].union.idxElem())
		}
	case 222:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1574
		{
			sqlVAL.union.val = IndexElem{Column: Name(sqlDollar[1].str), Direction: sqlDollar[3].union.dir()}
		}
	case 223:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1577
		{
			unimplemented()
		}
	case 224:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1578
		{
			unimplemented()
		}
	case 225:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1581
		{
			unimplemented()
		}
	case 226:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1582
		{
		}
	case 227:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1586
		{
			sqlVAL.union.val = Ascending
		}
	case 228:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1590
		{
			sqlVAL.union.val = Descending
		}
	case 229:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1594
		{
			sqlVAL.union.val = DefaultDirection
		}
	case 230:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:1601
		{
			sqlVAL.union.val = &RenameDatabase{Name: Name(sqlDollar[3].str), NewName: Name(sqlDollar[6].str)}
		}
	case 231:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:1605
		{
			sqlVAL.union.val = &RenameTable{Name: sqlDollar[3].union.qname(), NewName: sqlDollar[6].union.qname(), IfExists: false}
		}
	case 232:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1609
		{
			sqlVAL.union.val = &RenameTable{Name: sqlDollar[5].union.qname(), NewName: sqlDollar[8].union.qname(), IfExists: true}
		}
	case 233:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:1613
		{
			sqlVAL.union.val = &RenameIndex{Index: sqlDollar[3].union.tableWithIdx(), NewName: Name(sqlDollar[6].str), IfExists: false}
		}
	case 234:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1617
		{
			sqlVAL.union.val = &RenameIndex{Index: sqlDollar[5].union.tableWithIdx(), NewName: Name(sqlDollar[8].str), IfExists: true}
		}
	case 235:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1621
		{
			sqlVAL.union.val = &RenameColumn{Table: sqlDollar[3].union.qname(), Name: Name(sqlDollar[6].str), NewName: Name(sqlDollar[8].str), IfExists: false}
		}
	case 236:
		sqlDollar = sqlS[sqlpt-10 : sqlpt+1]
		//line sql.y:1625
		{
			sqlVAL.union.val = &RenameColumn{Table: sqlDollar[5].union.qname(), Name: Name(sqlDollar[8].str), NewName: Name(sqlDollar[10].str), IfExists: true}
		}
	case 237:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1629
		{
			sqlVAL.union.val = Statement(nil)
		}
	case 238:
		sqlDollar = sqlS[sqlpt-10 : sqlpt+1]
		//line sql.y:1633
		{
			sqlVAL.union.val = Statement(nil)
		}
	case 239:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1639
		{
			sqlVAL.union.val = true
		}
	case 240:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1643
		{
			sqlVAL.union.val = false
		}
	case 241:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1648
		{
		}
	case 242:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1649
		{
		}
	case 243:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1653
		{
			sqlVAL.union.val = &ReleaseSavepoint{Savepoint: sqlDollar[2].str}
		}
	case 244:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1659
		{
			sqlVAL.union.val = &Savepoint{Name: sqlDollar[2].str}
		}
	case 245:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1666
		{
			sqlVAL.union.val = sqlDollar[3].union.stmt()
		}
	case 246:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1670
		{
			sqlVAL.union.val = sqlDollar[3].union.stmt()
		}
	case 247:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1674
		{
			sqlVAL.union.val = &CommitTransaction{}
		}
	case 248:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1678
		{
			sqlVAL.union.val = &CommitTransaction{}
		}
	case 249:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1682
		{
			if sqlDollar[2].str != "" {
				sqlVAL.union.val = &RollbackToSavepoint{Savepoint: sqlDollar[2].str}
			} else {
				sqlVAL.union.val = &RollbackTransaction{}
			}
		}
	case 250:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1691
		{
		}
	case 251:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1692
		{
		}
	case 252:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1696
		{
			sqlVAL.str = ""
		}
	case 253:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1700
		{
			sqlVAL.str = sqlDollar[3].str
		}
	case 254:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1704
		{
			sqlVAL.str = sqlDollar[2].str
		}
	case 255:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1708
		{
			sqlVAL.str = ""
		}
	case 256:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1714
		{
			sqlVAL.str = sqlDollar[2].str
		}
	case 257:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1718
		{
			sqlVAL.str = sqlDollar[1].str
		}
	case 258:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1724
		{
			sqlVAL.union.val = &BeginTransaction{Isolation: sqlDollar[1].union.isoLevel(), UserPriority: UnspecifiedUserPriority}
		}
	case 259:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1728
		{
			sqlVAL.union.val = &BeginTransaction{Isolation: UnspecifiedIsolation, UserPriority: sqlDollar[1].union.userPriority()}
		}
	case 260:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1732
		{
			sqlVAL.union.val = &BeginTransaction{Isolation: sqlDollar[1].union.isoLevel(), UserPriority: sqlDollar[3].union.userPriority()}
		}
	case 261:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1736
		{
			sqlVAL.union.val = &BeginTransaction{Isolation: sqlDollar[3].union.isoLevel(), UserPriority: sqlDollar[1].union.userPriority()}
		}
	case 262:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1740
		{
			sqlVAL.union.val = &BeginTransaction{Isolation: UnspecifiedIsolation, UserPriority: UnspecifiedUserPriority}
		}
	case 263:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1746
		{
			sqlVAL.union.val = sqlDollar[3].union.isoLevel()
		}
	case 264:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1752
		{
			sqlVAL.union.val = &CreateDatabase{Name: Name(sqlDollar[3].str)}
		}
	case 265:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:1756
		{
			sqlVAL.union.val = &CreateDatabase{IfNotExists: true, Name: Name(sqlDollar[6].str)}
		}
	case 266:
		sqlDollar = sqlS[sqlpt-7 : sqlpt+1]
		//line sql.y:1762
		{
			sqlVAL.union.val = sqlDollar[5].union.stmt()
			sqlVAL.union.val.(*Insert).Table = sqlDollar[4].union.qname()
			sqlVAL.union.val.(*Insert).Returning = sqlDollar[7].union.retExprs()
		}
	case 269:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1779
		{
			sqlVAL.union.val = &Insert{Rows: sqlDollar[1].union.slct()}
		}
	case 270:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1783
		{
			sqlVAL.union.val = &Insert{Columns: sqlDollar[2].union.qnames(), Rows: sqlDollar[4].union.slct()}
		}
	case 271:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1787
		{
			sqlVAL.union.val = &Insert{Rows: &Select{}}
		}
	case 272:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1794
		{
			unimplemented()
		}
	case 273:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1795
		{
			unimplemented()
		}
	case 274:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1796
		{
		}
	case 275:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1799
		{
			unimplemented()
		}
	case 276:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1800
		{
			unimplemented()
		}
	case 277:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1801
		{
		}
	case 278:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1805
		{
			sqlVAL.union.val = sqlDollar[2].union.selExprs()
		}
	case 279:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:1809
		{
			sqlVAL.union.val = SelectExprs(nil)
		}
	case 280:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1816
		{
			sqlVAL.union.val = &Update{Table: sqlDollar[3].union.tblExpr(), Exprs: sqlDollar[5].union.updateExprs(), Where: newWhere(astWhere, sqlDollar[7].union.expr()), Returning: sqlDollar[8].union.retExprs()}
		}
	case 281:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1822
		{
			sqlVAL.union.val = UpdateExprs{sqlDollar[1].union.updateExpr()}
		}
	case 282:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1826
		{
			sqlVAL.union.val = append(sqlDollar[1].union.updateExprs(), sqlDollar[3].union.updateExpr())
		}
	case 285:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1836
		{
			sqlVAL.union.val = &UpdateExpr{Names: QualifiedNames{sqlDollar[1].union.qname()}, Expr: sqlDollar[3].union.expr()}
		}
	case 286:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1848
		{
			sqlVAL.union.val = &UpdateExpr{Tuple: true, Names: sqlDollar[2].union.qnames(), Expr: &Tuple{sqlDollar[5].union.exprs()}}
		}
	case 287:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:1852
		{
			sqlVAL.union.val = &UpdateExpr{Tuple: true, Names: sqlDollar[2].union.qnames(), Expr: &Subquery{Select: sqlDollar[5].union.selectStmt()}}
		}
	case 289:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1896
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[1].union.selectStmt()}
		}
	case 290:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1902
		{
			sqlVAL.union.val = &ParenSelect{Select: sqlDollar[2].union.slct()}
		}
	case 291:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1906
		{
			sqlVAL.union.val = &ParenSelect{Select: &Select{Select: sqlDollar[2].union.selectStmt()}}
		}
	case 292:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:1921
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[1].union.selectStmt()}
		}
	case 293:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1925
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[1].union.selectStmt(), OrderBy: sqlDollar[2].union.orderBy()}
		}
	case 294:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1929
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[1].union.selectStmt(), OrderBy: sqlDollar[2].union.orderBy(), Limit: sqlDollar[3].union.limit()}
		}
	case 295:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1933
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[2].union.selectStmt()}
		}
	case 296:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:1937
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[2].union.selectStmt(), OrderBy: sqlDollar[3].union.orderBy()}
		}
	case 297:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:1941
		{
			sqlVAL.union.val = &Select{Select: sqlDollar[2].union.selectStmt(), OrderBy: sqlDollar[3].union.orderBy(), Limit: sqlDollar[4].union.limit()}
		}
	case 300:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1975
		{
			sqlVAL.union.val = &SelectClause{
				Exprs:   sqlDollar[3].union.selExprs(),
				From:    sqlDollar[4].union.tblExprs(),
				Where:   newWhere(astWhere, sqlDollar[5].union.expr()),
				GroupBy: sqlDollar[6].union.groupBy(),
				Having:  newWhere(astHaving, sqlDollar[7].union.expr()),
			}
		}
	case 301:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:1987
		{
			sqlVAL.union.val = &SelectClause{
				Distinct: sqlDollar[2].union.bool(),
				Exprs:    sqlDollar[3].union.selExprs(),
				From:     sqlDollar[4].union.tblExprs(),
				Where:    newWhere(astWhere, sqlDollar[5].union.expr()),
				GroupBy:  sqlDollar[6].union.groupBy(),
				Having:   newWhere(astHaving, sqlDollar[7].union.expr()),
			}
		}
	case 303:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:1999
		{
			sqlVAL.union.val = &SelectClause{
				Exprs:       SelectExprs{starSelectExpr()},
				From:        TableExprs{&AliasedTableExpr{Expr: sqlDollar[2].union.qname()}},
				tableSelect: true,
			}
		}
	case 304:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2007
		{
			sqlVAL.union.val = &UnionClause{
				Type:  UnionOp,
				Left:  &Select{Select: sqlDollar[1].union.selectStmt()},
				Right: &Select{Select: sqlDollar[4].union.selectStmt()},
				All:   sqlDollar[3].union.bool(),
			}
		}
	case 305:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2016
		{
			sqlVAL.union.val = &UnionClause{
				Type:  IntersectOp,
				Left:  &Select{Select: sqlDollar[1].union.selectStmt()},
				Right: &Select{Select: sqlDollar[4].union.selectStmt()},
				All:   sqlDollar[3].union.bool(),
			}
		}
	case 306:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2025
		{
			sqlVAL.union.val = &UnionClause{
				Type:  ExceptOp,
				Left:  &Select{Select: sqlDollar[1].union.selectStmt()},
				Right: &Select{Select: sqlDollar[4].union.selectStmt()},
				All:   sqlDollar[3].union.bool(),
			}
		}
	case 307:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2043
		{
			unimplemented()
		}
	case 308:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2044
		{
			unimplemented()
		}
	case 309:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2045
		{
			unimplemented()
		}
	case 310:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2048
		{
			unimplemented()
		}
	case 311:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2049
		{
			unimplemented()
		}
	case 312:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:2052
		{
			unimplemented()
		}
	case 313:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2056
		{
			sqlVAL.union.val = sqlDollar[1].union.slct()
		}
	case 317:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2064
		{
			unimplemented()
		}
	case 318:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2065
		{
		}
	case 319:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2068
		{
		}
	case 320:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2069
		{
		}
	case 321:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2073
		{
			sqlVAL.union.val = true
		}
	case 322:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2077
		{
			sqlVAL.union.val = false
		}
	case 323:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2081
		{
			sqlVAL.union.val = false
		}
	case 324:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2087
		{
			sqlVAL.union.val = true
		}
	case 325:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2092
		{
		}
	case 326:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2093
		{
		}
	case 327:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2097
		{
			sqlVAL.union.val = sqlDollar[1].union.orderBy()
		}
	case 328:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2101
		{
			sqlVAL.union.val = OrderBy(nil)
		}
	case 329:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2107
		{
			sqlVAL.union.val = OrderBy(sqlDollar[3].union.orders())
		}
	case 330:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2113
		{
			sqlVAL.union.val = []*Order{sqlDollar[1].union.order()}
		}
	case 331:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2117
		{
			sqlVAL.union.val = append(sqlDollar[1].union.orders(), sqlDollar[3].union.order())
		}
	case 332:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2123
		{
			sqlVAL.union.val = &Order{Expr: sqlDollar[1].union.expr(), Direction: sqlDollar[2].union.dir()}
		}
	case 333:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2131
		{
			if sqlDollar[1].union.limit() == nil {
				sqlVAL.union.val = sqlDollar[2].union.limit()
			} else {
				sqlVAL.union.val = sqlDollar[1].union.limit()
				sqlVAL.union.val.(*Limit).Offset = sqlDollar[2].union.limit().Offset
			}
		}
	case 334:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2140
		{
			sqlVAL.union.val = sqlDollar[1].union.limit()
			if sqlDollar[2].union.limit() != nil {
				sqlVAL.union.val.(*Limit).Count = sqlDollar[2].union.limit().Count
			}
		}
	case 337:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2151
		{
			if sqlDollar[2].union.expr() == nil {
				sqlVAL.union.val = (*Limit)(nil)
			} else {
				sqlVAL.union.val = &Limit{Count: sqlDollar[2].union.expr()}
			}
		}
	case 338:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2164
		{
			sqlVAL.union.val = &Limit{Offset: sqlDollar[2].union.expr()}
		}
	case 339:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2171
		{
			sqlVAL.union.val = &Limit{Offset: sqlDollar[2].union.expr()}
		}
	case 341:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2178
		{
			sqlVAL.union.val = Expr(nil)
		}
	case 342:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2192
		{
		}
	case 343:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2193
		{
		}
	case 344:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2219
		{
			sqlVAL.union.val = GroupBy(sqlDollar[3].union.exprs())
		}
	case 345:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2223
		{
			sqlVAL.union.val = GroupBy(nil)
		}
	case 346:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2229
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 347:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2233
		{
			sqlVAL.union.val = Expr(nil)
		}
	case 348:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2239
		{
			sqlVAL.union.val = &ValuesClause{[]*Tuple{{sqlDollar[2].union.exprs()}}}
		}
	case 349:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2243
		{
			valNode := sqlDollar[1].union.selectStmt().(*ValuesClause)
			valNode.Tuples = append(valNode.Tuples, &Tuple{sqlDollar[3].union.exprs()})
			sqlVAL.union.val = valNode
		}
	case 350:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2255
		{
			sqlVAL.union.val = sqlDollar[2].union.tblExprs()
		}
	case 351:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2259
		{
			sqlVAL.union.val = TableExprs(nil)
		}
	case 352:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2265
		{
			sqlVAL.union.val = TableExprs{sqlDollar[1].union.tblExpr()}
		}
	case 353:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2269
		{
			sqlVAL.union.val = append(sqlDollar[1].union.tblExprs(), sqlDollar[3].union.tblExpr())
		}
	case 354:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2275
		{
			sqlVAL.union.val = &IndexHints{Index: Name(sqlDollar[3].str)}
		}
	case 355:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2280
		{
			sqlVAL.union.val = &IndexHints{NoIndexJoin: true}
		}
	case 356:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2286
		{
			sqlVAL.union.val = sqlDollar[1].union.indexHints()
		}
	case 357:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2291
		{
			a := sqlDollar[1].union.indexHints()
			b := sqlDollar[3].union.indexHints()
			index := a.Index
			if index == "" {
				index = b.Index
			} else if b.Index != "" {
				sqllex.Error("FORCE_INDEX specified multiple times")
				return 1
			}
			if a.NoIndexJoin && b.NoIndexJoin {
				sqllex.Error("NO_INDEX_JOIN specified multiple times")
				return 1
			}
			noIndexJoin := a.NoIndexJoin || b.NoIndexJoin
			sqlVAL.union.val = &IndexHints{Index: index, NoIndexJoin: noIndexJoin}
		}
	case 358:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2311
		{
			sqlVAL.union.val = &IndexHints{Index: Name(sqlDollar[2].str)}
		}
	case 359:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2315
		{
			sqlVAL.union.val = sqlDollar[3].union.indexHints()
		}
	case 360:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2319
		{
			sqlVAL.union.val = (*IndexHints)(nil)
		}
	case 361:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2326
		{
			sqlVAL.union.val = &AliasedTableExpr{Expr: sqlDollar[1].union.qname(), Hints: sqlDollar[2].union.indexHints(), As: sqlDollar[3].union.aliasClause()}
		}
	case 362:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2330
		{
			sqlVAL.union.val = &AliasedTableExpr{Expr: &Subquery{Select: sqlDollar[1].union.selectStmt()}, As: sqlDollar[2].union.aliasClause()}
		}
	case 364:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2334
		{
			unimplemented()
		}
	case 365:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2352
		{
			sqlVAL.union.val = &ParenTableExpr{Expr: sqlDollar[2].union.tblExpr()}
		}
	case 366:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2356
		{
			sqlVAL.union.val = &JoinTableExpr{Join: astCrossJoin, Left: sqlDollar[1].union.tblExpr(), Right: sqlDollar[4].union.tblExpr()}
		}
	case 367:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2360
		{
			sqlVAL.union.val = &JoinTableExpr{Join: sqlDollar[2].str, Left: sqlDollar[1].union.tblExpr(), Right: sqlDollar[4].union.tblExpr(), Cond: sqlDollar[5].union.joinCond()}
		}
	case 368:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2364
		{
			sqlVAL.union.val = &JoinTableExpr{Join: astJoin, Left: sqlDollar[1].union.tblExpr(), Right: sqlDollar[3].union.tblExpr(), Cond: sqlDollar[4].union.joinCond()}
		}
	case 369:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2368
		{
			sqlVAL.union.val = &JoinTableExpr{Join: astNaturalJoin, Left: sqlDollar[1].union.tblExpr(), Right: sqlDollar[5].union.tblExpr()}
		}
	case 370:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2372
		{
			sqlVAL.union.val = &JoinTableExpr{Join: astNaturalJoin, Left: sqlDollar[1].union.tblExpr(), Right: sqlDollar[4].union.tblExpr()}
		}
	case 371:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2378
		{
			sqlVAL.union.val = AliasClause{Alias: Name(sqlDollar[2].str), Cols: NameList(sqlDollar[4].union.strs())}
		}
	case 372:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2382
		{
			sqlVAL.union.val = AliasClause{Alias: Name(sqlDollar[2].str)}
		}
	case 373:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2386
		{
			sqlVAL.union.val = AliasClause{Alias: Name(sqlDollar[1].str), Cols: NameList(sqlDollar[3].union.strs())}
		}
	case 374:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2390
		{
			sqlVAL.union.val = AliasClause{Alias: Name(sqlDollar[1].str)}
		}
	case 376:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2397
		{
			sqlVAL.union.val = AliasClause{}
		}
	case 377:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2403
		{
			sqlVAL.str = astFullJoin
		}
	case 378:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2407
		{
			sqlVAL.str = astLeftJoin
		}
	case 379:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2411
		{
			sqlVAL.str = astRightJoin
		}
	case 380:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2415
		{
			sqlVAL.str = astInnerJoin
		}
	case 381:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2421
		{
		}
	case 382:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2422
		{
		}
	case 383:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2433
		{
			sqlVAL.union.val = &UsingJoinCond{Cols: NameList(sqlDollar[3].union.strs())}
		}
	case 384:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2437
		{
			sqlVAL.union.val = &OnJoinCond{Expr: sqlDollar[2].union.expr()}
		}
	case 385:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2443
		{
			sqlVAL.union.val = sqlDollar[1].union.qname()
		}
	case 386:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2447
		{
			sqlVAL.union.val = sqlDollar[1].union.qname()
		}
	case 387:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2451
		{
			sqlVAL.union.val = sqlDollar[2].union.qname()
		}
	case 388:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2455
		{
			sqlVAL.union.val = sqlDollar[3].union.qname()
		}
	case 389:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2461
		{
			sqlVAL.union.val = QualifiedNames{sqlDollar[1].union.qname()}
		}
	case 390:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2465
		{
			sqlVAL.union.val = append(sqlDollar[1].union.qnames(), sqlDollar[3].union.qname())
		}
	case 391:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2478
		{
			sqlVAL.union.val = &AliasedTableExpr{Expr: sqlDollar[1].union.qname()}
		}
	case 392:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2482
		{
			sqlVAL.union.val = &AliasedTableExpr{Expr: sqlDollar[1].union.qname(), As: AliasClause{Alias: Name(sqlDollar[2].str)}}
		}
	case 393:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2486
		{
			sqlVAL.union.val = &AliasedTableExpr{Expr: sqlDollar[1].union.qname(), As: AliasClause{Alias: Name(sqlDollar[3].str)}}
		}
	case 394:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2492
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 395:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2496
		{
			sqlVAL.union.val = Expr(nil)
		}
	case 396:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2508
		{
			sqlVAL.union.val = sqlDollar[1].union.colType()
		}
	case 397:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2512
		{
			unimplemented()
		}
	case 398:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2513
		{
			unimplemented()
		}
	case 399:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2516
		{
			unimplemented()
		}
	case 400:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2517
		{
			unimplemented()
		}
	case 401:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2518
		{
		}
	case 407:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2526
		{
			unimplemented()
		}
	case 408:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2528
		{
			sqlVAL.union.val = &BytesType{Name: "BLOB"}
		}
	case 409:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2532
		{
			sqlVAL.union.val = &BytesType{Name: "BYTES"}
		}
	case 410:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2536
		{
			sqlVAL.union.val = &BytesType{Name: "BYTEA"}
		}
	case 411:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2540
		{
			sqlVAL.union.val = &StringType{Name: "TEXT"}
		}
	case 412:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2544
		{
			sqlVAL.union.val = &StringType{Name: "STRING"}
		}
	case 417:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2565
		{
			sqlVAL.union.val = &DecimalType{Prec: int(sqlDollar[2].union.ival().Val)}
		}
	case 418:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2569
		{
			sqlVAL.union.val = &DecimalType{Prec: int(sqlDollar[2].union.ival().Val), Scale: int(sqlDollar[4].union.ival().Val)}
		}
	case 419:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2573
		{
			sqlVAL.union.val = &DecimalType{}
		}
	case 420:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2580
		{
			sqlVAL.union.val = &IntType{Name: "INT"}
		}
	case 421:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2584
		{
			sqlVAL.union.val = &IntType{Name: "INT64"}
		}
	case 422:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2588
		{
			sqlVAL.union.val = &IntType{Name: "INTEGER"}
		}
	case 423:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2592
		{
			sqlVAL.union.val = &IntType{Name: "SMALLINT"}
		}
	case 424:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2596
		{
			sqlVAL.union.val = &IntType{Name: "BIGINT"}
		}
	case 425:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2600
		{
			sqlVAL.union.val = &FloatType{Name: "REAL"}
		}
	case 426:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2604
		{
			sqlVAL.union.val = &FloatType{Name: "FLOAT", Prec: int(sqlDollar[2].union.ival().Val)}
		}
	case 427:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2608
		{
			sqlVAL.union.val = &FloatType{Name: "DOUBLE PRECISION"}
		}
	case 428:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2612
		{
			sqlVAL.union.val = sqlDollar[2].union.colType()
			sqlVAL.union.val.(*DecimalType).Name = "DECIMAL"
		}
	case 429:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2617
		{
			sqlVAL.union.val = sqlDollar[2].union.colType()
			sqlVAL.union.val.(*DecimalType).Name = "DEC"
		}
	case 430:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2622
		{
			sqlVAL.union.val = sqlDollar[2].union.colType()
			sqlVAL.union.val.(*DecimalType).Name = "NUMERIC"
		}
	case 431:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2627
		{
			sqlVAL.union.val = &BoolType{Name: "BOOLEAN"}
		}
	case 432:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2631
		{
			sqlVAL.union.val = &BoolType{Name: "BOOL"}
		}
	case 433:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2637
		{
			sqlVAL.union.val = sqlDollar[2].union.ival()
		}
	case 434:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2641
		{
			sqlVAL.union.val = IntVal{}
		}
	case 439:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2659
		{
			sqlVAL.union.val = &IntType{Name: "BIT", N: int(sqlDollar[4].union.ival().Val)}
		}
	case 440:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2665
		{
			sqlVAL.union.val = &IntType{Name: "BIT"}
		}
	case 445:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2681
		{
			sqlVAL.union.val = sqlDollar[1].union.colType()
			sqlVAL.union.val.(*StringType).N = int(sqlDollar[3].union.ival().Val)
		}
	case 446:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2688
		{
			sqlVAL.union.val = sqlDollar[1].union.colType()
		}
	case 447:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2694
		{
			sqlVAL.union.val = &StringType{Name: "CHAR"}
		}
	case 448:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2698
		{
			sqlVAL.union.val = &StringType{Name: "CHAR"}
		}
	case 449:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2702
		{
			sqlVAL.union.val = &StringType{Name: "VARCHAR"}
		}
	case 450:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2707
		{
		}
	case 451:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2708
		{
		}
	case 452:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2713
		{
			sqlVAL.union.val = &DateType{}
		}
	case 453:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2717
		{
			sqlVAL.union.val = &TimestampType{}
		}
	case 454:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2722
		{
			sqlVAL.union.val = &IntervalType{}
		}
	case 455:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2727
		{
			unimplemented()
		}
	case 456:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2728
		{
			unimplemented()
		}
	case 457:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2729
		{
			unimplemented()
		}
	case 458:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2730
		{
			unimplemented()
		}
	case 459:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2731
		{
			unimplemented()
		}
	case 460:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2732
		{
			unimplemented()
		}
	case 461:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2733
		{
			unimplemented()
		}
	case 462:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2734
		{
			unimplemented()
		}
	case 463:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2735
		{
			unimplemented()
		}
	case 464:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2736
		{
			unimplemented()
		}
	case 465:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2737
		{
			unimplemented()
		}
	case 466:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2738
		{
			unimplemented()
		}
	case 467:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2739
		{
			unimplemented()
		}
	case 468:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:2740
		{
		}
	case 469:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:2743
		{
			unimplemented()
		}
	case 470:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2744
		{
			unimplemented()
		}
	case 472:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2768
		{
			sqlVAL.union.val = &CastExpr{Expr: sqlDollar[1].union.expr(), Type: sqlDollar[3].union.colType()}
		}
	case 473:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2771
		{
			unimplemented()
		}
	case 474:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2772
		{
			unimplemented()
		}
	case 475:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2781
		{
			sqlVAL.union.val = &UnaryExpr{Operator: UnaryPlus, Expr: sqlDollar[2].union.expr()}
		}
	case 476:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2785
		{
			sqlVAL.union.val = &UnaryExpr{Operator: UnaryMinus, Expr: sqlDollar[2].union.expr()}
		}
	case 477:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2789
		{
			sqlVAL.union.val = &UnaryExpr{Operator: UnaryComplement, Expr: sqlDollar[2].union.expr()}
		}
	case 478:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2793
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Plus, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 479:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2797
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Minus, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 480:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2801
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Mult, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 481:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2805
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Div, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 482:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2809
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Mod, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 483:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2813
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitxor, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 484:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2817
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitxor, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 485:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2821
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitand, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 486:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2825
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitor, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 487:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2829
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: LT, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 488:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2833
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: GT, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 489:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2837
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: EQ, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 490:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2841
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Concat, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 491:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2845
		{
			sqlVAL.union.val = &BinaryExpr{Operator: LShift, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 492:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2849
		{
			sqlVAL.union.val = &BinaryExpr{Operator: RShift, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 493:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2853
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: LE, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 494:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2857
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: GE, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 495:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2861
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: NE, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 496:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2865
		{
			sqlVAL.union.val = &AndExpr{Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 497:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2869
		{
			sqlVAL.union.val = &OrExpr{Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 498:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2873
		{
			sqlVAL.union.val = &NotExpr{Expr: sqlDollar[2].union.expr()}
		}
	case 499:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2877
		{
			sqlVAL.union.val = &NotExpr{Expr: sqlDollar[2].union.expr()}
		}
	case 500:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2881
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: Like, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 501:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2885
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: NotLike, Left: sqlDollar[1].union.expr(), Right: sqlDollar[4].union.expr()}
		}
	case 502:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2889
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: SimilarTo, Left: sqlDollar[1].union.expr(), Right: sqlDollar[4].union.expr()}
		}
	case 503:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2893
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: NotSimilarTo, Left: sqlDollar[1].union.expr(), Right: sqlDollar[5].union.expr()}
		}
	case 504:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2897
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: Is, Left: sqlDollar[1].union.expr(), Right: DNull}
		}
	case 505:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2901
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsNot, Left: sqlDollar[1].union.expr(), Right: DNull}
		}
	case 506:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2904
		{
			unimplemented()
		}
	case 507:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2906
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: Is, Left: sqlDollar[1].union.expr(), Right: DBool(true)}
		}
	case 508:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2910
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsNot, Left: sqlDollar[1].union.expr(), Right: DBool(true)}
		}
	case 509:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2914
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: Is, Left: sqlDollar[1].union.expr(), Right: DBool(false)}
		}
	case 510:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2918
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsNot, Left: sqlDollar[1].union.expr(), Right: DBool(false)}
		}
	case 511:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2922
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: Is, Left: sqlDollar[1].union.expr(), Right: DNull}
		}
	case 512:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2926
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsNot, Left: sqlDollar[1].union.expr(), Right: DNull}
		}
	case 513:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:2930
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsDistinctFrom, Left: sqlDollar[1].union.expr(), Right: sqlDollar[5].union.expr()}
		}
	case 514:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:2934
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsNotDistinctFrom, Left: sqlDollar[1].union.expr(), Right: sqlDollar[6].union.expr()}
		}
	case 515:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:2938
		{
			sqlVAL.union.val = &IsOfTypeExpr{Expr: sqlDollar[1].union.expr(), Types: sqlDollar[5].union.colTypes()}
		}
	case 516:
		sqlDollar = sqlS[sqlpt-7 : sqlpt+1]
		//line sql.y:2942
		{
			sqlVAL.union.val = &IsOfTypeExpr{Not: true, Expr: sqlDollar[1].union.expr(), Types: sqlDollar[6].union.colTypes()}
		}
	case 517:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:2946
		{
			sqlVAL.union.val = &RangeCond{Left: sqlDollar[1].union.expr(), From: sqlDollar[4].union.expr(), To: sqlDollar[6].union.expr()}
		}
	case 518:
		sqlDollar = sqlS[sqlpt-7 : sqlpt+1]
		//line sql.y:2950
		{
			sqlVAL.union.val = &RangeCond{Not: true, Left: sqlDollar[1].union.expr(), From: sqlDollar[5].union.expr(), To: sqlDollar[7].union.expr()}
		}
	case 519:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:2954
		{
			sqlVAL.union.val = &RangeCond{Left: sqlDollar[1].union.expr(), From: sqlDollar[4].union.expr(), To: sqlDollar[6].union.expr()}
		}
	case 520:
		sqlDollar = sqlS[sqlpt-7 : sqlpt+1]
		//line sql.y:2958
		{
			sqlVAL.union.val = &RangeCond{Not: true, Left: sqlDollar[1].union.expr(), From: sqlDollar[5].union.expr(), To: sqlDollar[7].union.expr()}
		}
	case 521:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2962
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: In, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 522:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:2966
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: NotIn, Left: sqlDollar[1].union.expr(), Right: sqlDollar[4].union.expr()}
		}
	case 524:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2983
		{
			sqlVAL.union.val = &CastExpr{Expr: sqlDollar[1].union.expr(), Type: sqlDollar[3].union.colType()}
		}
	case 525:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2987
		{
			sqlVAL.union.val = &UnaryExpr{Operator: UnaryPlus, Expr: sqlDollar[2].union.expr()}
		}
	case 526:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2991
		{
			sqlVAL.union.val = &UnaryExpr{Operator: UnaryMinus, Expr: sqlDollar[2].union.expr()}
		}
	case 527:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:2995
		{
			sqlVAL.union.val = &UnaryExpr{Operator: UnaryComplement, Expr: sqlDollar[2].union.expr()}
		}
	case 528:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:2999
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Plus, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 529:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3003
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Minus, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 530:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3007
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Mult, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 531:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3011
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Div, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 532:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3015
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Mod, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 533:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3019
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitxor, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 534:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3023
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitxor, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 535:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3027
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitand, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 536:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3031
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Bitor, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 537:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3035
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: LT, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 538:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3039
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: GT, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 539:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3043
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: EQ, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 540:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3047
		{
			sqlVAL.union.val = &BinaryExpr{Operator: Concat, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 541:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3051
		{
			sqlVAL.union.val = &BinaryExpr{Operator: LShift, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 542:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3055
		{
			sqlVAL.union.val = &BinaryExpr{Operator: RShift, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 543:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3059
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: LE, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 544:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3063
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: GE, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 545:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3067
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: NE, Left: sqlDollar[1].union.expr(), Right: sqlDollar[3].union.expr()}
		}
	case 546:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3071
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsDistinctFrom, Left: sqlDollar[1].union.expr(), Right: sqlDollar[5].union.expr()}
		}
	case 547:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3075
		{
			sqlVAL.union.val = &ComparisonExpr{Operator: IsNotDistinctFrom, Left: sqlDollar[1].union.expr(), Right: sqlDollar[6].union.expr()}
		}
	case 548:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3079
		{
			sqlVAL.union.val = &IsOfTypeExpr{Expr: sqlDollar[1].union.expr(), Types: sqlDollar[5].union.colTypes()}
		}
	case 549:
		sqlDollar = sqlS[sqlpt-7 : sqlpt+1]
		//line sql.y:3083
		{
			sqlVAL.union.val = &IsOfTypeExpr{Not: true, Expr: sqlDollar[1].union.expr(), Types: sqlDollar[6].union.colTypes()}
		}
	case 550:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3095
		{
			sqlVAL.union.val = sqlDollar[1].union.qname()
		}
	case 552:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3100
		{
			sqlVAL.union.val = ValArg{name: sqlDollar[1].str}
		}
	case 553:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3104
		{
			sqlVAL.union.val = &ParenExpr{Expr: sqlDollar[2].union.expr()}
		}
	case 556:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3110
		{
			sqlVAL.union.val = &Subquery{Select: sqlDollar[1].union.selectStmt()}
		}
	case 557:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3114
		{
			sqlVAL.union.val = &Subquery{Select: sqlDollar[1].union.selectStmt()}
		}
	case 558:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3118
		{
			sqlVAL.union.val = &ExistsExpr{Subquery: &Subquery{Select: sqlDollar[2].union.selectStmt()}}
		}
	case 559:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3124
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 560:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3128
		{
			sqlVAL.union.val = sqlDollar[1].union.expr()
		}
	case 561:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3132
		{
			sqlVAL.union.val = sqlDollar[1].union.expr()
		}
	case 562:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3140
		{
			sqlVAL.union.val = &FuncExpr{Name: sqlDollar[1].union.qname()}
		}
	case 563:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3144
		{
			sqlVAL.union.val = &FuncExpr{Name: sqlDollar[1].union.qname(), Exprs: sqlDollar[3].union.exprs()}
		}
	case 564:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3147
		{
			unimplemented()
		}
	case 565:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:3148
		{
			unimplemented()
		}
	case 566:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3150
		{
			sqlVAL.union.val = &FuncExpr{Name: sqlDollar[1].union.qname(), Type: All, Exprs: sqlDollar[4].union.exprs()}
		}
	case 567:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3154
		{
			sqlVAL.union.val = &FuncExpr{Name: sqlDollar[1].union.qname(), Type: Distinct, Exprs: sqlDollar[4].union.exprs()}
		}
	case 568:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3158
		{
			sqlVAL.union.val = &FuncExpr{Name: sqlDollar[1].union.qname(), Exprs: Exprs{StarExpr()}}
		}
	case 569:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3171
		{
			sqlVAL.union.val = sqlDollar[1].union.expr()
		}
	case 570:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3175
		{
			sqlVAL.union.val = sqlDollar[1].union.expr()
		}
	case 571:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3184
		{
			unimplemented()
		}
	case 572:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3185
		{
			unimplemented()
		}
	case 573:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3189
		{
			unimplemented()
		}
	case 574:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3191
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}}
		}
	case 575:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3195
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}}
		}
	case 576:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3199
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}}
		}
	case 577:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3203
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}}
		}
	case 578:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3206
		{
			unimplemented()
		}
	case 579:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3207
		{
			unimplemented()
		}
	case 580:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3208
		{
			unimplemented()
		}
	case 581:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3209
		{
			unimplemented()
		}
	case 582:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3211
		{
			sqlVAL.union.val = &CastExpr{Expr: sqlDollar[3].union.expr(), Type: sqlDollar[5].union.colType()}
		}
	case 583:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3215
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}, Exprs: sqlDollar[3].union.exprs()}
		}
	case 584:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3219
		{
			sqlVAL.union.val = &OverlayExpr{FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}, Exprs: sqlDollar[3].union.exprs()}}
		}
	case 585:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3223
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: "STRPOS"}, Exprs: sqlDollar[3].union.exprs()}
		}
	case 586:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3227
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}, Exprs: sqlDollar[3].union.exprs()}
		}
	case 587:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3230
		{
			unimplemented()
		}
	case 588:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3232
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: "BTRIM"}, Exprs: sqlDollar[4].union.exprs()}
		}
	case 589:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3236
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: "LTRIM"}, Exprs: sqlDollar[4].union.exprs()}
		}
	case 590:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3240
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: "RTRIM"}, Exprs: sqlDollar[4].union.exprs()}
		}
	case 591:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3244
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: "BTRIM"}, Exprs: sqlDollar[3].union.exprs()}
		}
	case 592:
		sqlDollar = sqlS[sqlpt-8 : sqlpt+1]
		//line sql.y:3248
		{
			sqlVAL.union.val = &IfExpr{Cond: sqlDollar[3].union.expr(), True: sqlDollar[5].union.expr(), Else: sqlDollar[7].union.expr()}
		}
	case 593:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3252
		{
			sqlVAL.union.val = &NullIfExpr{Expr1: sqlDollar[3].union.expr(), Expr2: sqlDollar[5].union.expr()}
		}
	case 594:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3256
		{
			sqlVAL.union.val = &CoalesceExpr{Name: "IFNULL", Exprs: Exprs{sqlDollar[3].union.expr(), sqlDollar[5].union.expr()}}
		}
	case 595:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3260
		{
			sqlVAL.union.val = &CoalesceExpr{Name: "COALESCE", Exprs: sqlDollar[3].union.exprs()}
		}
	case 596:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3264
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}, Exprs: sqlDollar[3].union.exprs()}
		}
	case 597:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3268
		{
			sqlVAL.union.val = &FuncExpr{Name: &QualifiedName{Base: Name(sqlDollar[1].str)}, Exprs: sqlDollar[3].union.exprs()}
		}
	case 598:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3274
		{
			unimplemented()
		}
	case 599:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3275
		{
		}
	case 600:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3278
		{
			unimplemented()
		}
	case 601:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3279
		{
		}
	case 602:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3283
		{
			unimplemented()
		}
	case 603:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3284
		{
		}
	case 604:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3287
		{
			unimplemented()
		}
	case 605:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3288
		{
			unimplemented()
		}
	case 606:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3291
		{
			unimplemented()
		}
	case 607:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3294
		{
			unimplemented()
		}
	case 608:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3295
		{
			unimplemented()
		}
	case 609:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3296
		{
		}
	case 610:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3300
		{
			unimplemented()
		}
	case 611:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3311
		{
			unimplemented()
		}
	case 612:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3312
		{
		}
	case 613:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3315
		{
			unimplemented()
		}
	case 614:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3316
		{
		}
	case 615:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3324
		{
			unimplemented()
		}
	case 616:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3325
		{
			unimplemented()
		}
	case 617:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3326
		{
		}
	case 618:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3329
		{
			unimplemented()
		}
	case 619:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3330
		{
			unimplemented()
		}
	case 620:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3336
		{
			unimplemented()
		}
	case 621:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3337
		{
			unimplemented()
		}
	case 622:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3338
		{
			unimplemented()
		}
	case 623:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3339
		{
			unimplemented()
		}
	case 624:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3340
		{
			unimplemented()
		}
	case 625:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3351
		{
			sqlVAL.union.val = &Row{sqlDollar[3].union.exprs()}
		}
	case 626:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3355
		{
			sqlVAL.union.val = &Row{nil}
		}
	case 627:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3359
		{
			sqlVAL.union.val = &Tuple{append(sqlDollar[2].union.exprs(), sqlDollar[4].union.expr())}
		}
	case 628:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3365
		{
			sqlVAL.union.val = &Row{sqlDollar[3].union.exprs()}
		}
	case 629:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3369
		{
			sqlVAL.union.val = &Row{nil}
		}
	case 630:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3375
		{
			sqlVAL.union.val = &Tuple{append(sqlDollar[2].union.exprs(), sqlDollar[4].union.expr())}
		}
	case 631:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3416
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr()}
		}
	case 632:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3420
		{
			sqlVAL.union.val = append(sqlDollar[1].union.exprs(), sqlDollar[3].union.expr())
		}
	case 633:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3426
		{
			sqlVAL.union.val = []ColumnType{sqlDollar[1].union.colType()}
		}
	case 634:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3430
		{
			sqlVAL.union.val = append(sqlDollar[1].union.colTypes(), sqlDollar[3].union.colType())
		}
	case 635:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3436
		{
			sqlVAL.union.val = &Array{sqlDollar[2].union.exprs()}
		}
	case 636:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3440
		{
			sqlVAL.union.val = &Array{sqlDollar[2].union.exprs()}
		}
	case 637:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3444
		{
			sqlVAL.union.val = &Array{nil}
		}
	case 638:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3450
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr()}
		}
	case 639:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3454
		{
			sqlVAL.union.val = append(sqlDollar[1].union.exprs(), sqlDollar[3].union.expr())
		}
	case 640:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3460
		{
			sqlVAL.union.val = Exprs{DString(sqlDollar[1].str), sqlDollar[3].union.expr()}
		}
	case 648:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3482
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr(), sqlDollar[2].union.expr(), sqlDollar[3].union.expr(), sqlDollar[4].union.expr()}
		}
	case 649:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3486
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr(), sqlDollar[2].union.expr(), sqlDollar[3].union.expr()}
		}
	case 650:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3492
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 651:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3499
		{
			sqlVAL.union.val = Exprs{sqlDollar[3].union.expr(), sqlDollar[1].union.expr()}
		}
	case 652:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3503
		{
			sqlVAL.union.val = Exprs(nil)
		}
	case 653:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3520
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr(), sqlDollar[2].union.expr(), sqlDollar[3].union.expr()}
		}
	case 654:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3524
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr(), sqlDollar[3].union.expr(), sqlDollar[2].union.expr()}
		}
	case 655:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3528
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr(), sqlDollar[2].union.expr()}
		}
	case 656:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3532
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr(), DInt(1), sqlDollar[2].union.expr()}
		}
	case 657:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3536
		{
			sqlVAL.union.val = sqlDollar[1].union.exprs()
		}
	case 658:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3540
		{
			sqlVAL.union.val = Exprs(nil)
		}
	case 659:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3546
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 660:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3552
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 661:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3558
		{
			sqlVAL.union.val = append(sqlDollar[3].union.exprs(), sqlDollar[1].union.expr())
		}
	case 662:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3562
		{
			sqlVAL.union.val = sqlDollar[2].union.exprs()
		}
	case 663:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3566
		{
			sqlVAL.union.val = sqlDollar[1].union.exprs()
		}
	case 664:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3572
		{
			sqlVAL.union.val = &Subquery{Select: sqlDollar[1].union.selectStmt()}
		}
	case 665:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3576
		{
			sqlVAL.union.val = &Tuple{sqlDollar[2].union.exprs()}
		}
	case 666:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3587
		{
			sqlVAL.union.val = &CaseExpr{Expr: sqlDollar[2].union.expr(), Whens: sqlDollar[3].union.whens(), Else: sqlDollar[4].union.expr()}
		}
	case 667:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3594
		{
			sqlVAL.union.val = []*When{sqlDollar[1].union.when()}
		}
	case 668:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3598
		{
			sqlVAL.union.val = append(sqlDollar[1].union.whens(), sqlDollar[2].union.when())
		}
	case 669:
		sqlDollar = sqlS[sqlpt-4 : sqlpt+1]
		//line sql.y:3604
		{
			sqlVAL.union.val = &When{Cond: sqlDollar[2].union.expr(), Val: sqlDollar[4].union.expr()}
		}
	case 670:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3610
		{
			sqlVAL.union.val = sqlDollar[2].union.expr()
		}
	case 671:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3614
		{
			sqlVAL.union.val = Expr(nil)
		}
	case 673:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3621
		{
			sqlVAL.union.val = Expr(nil)
		}
	case 674:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3627
		{
			sqlVAL.union.val = sqlDollar[1].union.indirectElem()
		}
	case 675:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3631
		{
			sqlVAL.union.val = sqlDollar[1].union.indirectElem()
		}
	case 676:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3635
		{
			sqlVAL.union.val = &ArrayIndirection{Begin: sqlDollar[2].union.expr()}
		}
	case 677:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3639
		{
			sqlVAL.union.val = &ArrayIndirection{Begin: sqlDollar[2].union.expr(), End: sqlDollar[4].union.expr()}
		}
	case 678:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3645
		{
			sqlVAL.union.val = NameIndirection(sqlDollar[2].str)
		}
	case 679:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3651
		{
			sqlVAL.union.val = qualifiedStar
		}
	case 680:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3657
		{
			sqlVAL.union.val = Indirection{sqlDollar[1].union.indirectElem()}
		}
	case 681:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3661
		{
			sqlVAL.union.val = append(sqlDollar[1].union.indirect(), sqlDollar[2].union.indirectElem())
		}
	case 682:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3666
		{
		}
	case 683:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3667
		{
		}
	case 685:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3676
		{
			sqlVAL.union.val = DefaultVal{}
		}
	case 686:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3682
		{
			sqlVAL.union.val = Exprs{sqlDollar[1].union.expr()}
		}
	case 687:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3686
		{
			sqlVAL.union.val = append(sqlDollar[1].union.exprs(), sqlDollar[3].union.expr())
		}
	case 688:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3695
		{
			sqlVAL.union.val = sqlDollar[2].union.exprs()
		}
	case 689:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3701
		{
			sqlVAL.union.val = SelectExprs{sqlDollar[1].union.selExpr()}
		}
	case 690:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3705
		{
			sqlVAL.union.val = append(sqlDollar[1].union.selExprs(), sqlDollar[3].union.selExpr())
		}
	case 691:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3711
		{
			sqlVAL.union.val = SelectExpr{Expr: sqlDollar[1].union.expr(), As: Name(sqlDollar[3].str)}
		}
	case 692:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3720
		{
			sqlVAL.union.val = SelectExpr{Expr: sqlDollar[1].union.expr(), As: Name(sqlDollar[2].str)}
		}
	case 693:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3724
		{
			sqlVAL.union.val = SelectExpr{Expr: sqlDollar[1].union.expr()}
		}
	case 694:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3728
		{
			sqlVAL.union.val = starSelectExpr()
		}
	case 695:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3736
		{
			sqlVAL.union.val = QualifiedNames{sqlDollar[1].union.qname()}
		}
	case 696:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3740
		{
			sqlVAL.union.val = append(sqlDollar[1].union.qnames(), sqlDollar[3].union.qname())
		}
	case 697:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3746
		{
			sqlVAL.union.val = TableNameWithIndexList{sqlDollar[1].union.tableWithIdx()}
		}
	case 698:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3750
		{
			sqlVAL.union.val = append(sqlDollar[1].union.tableWithIdxList(), sqlDollar[3].union.tableWithIdx())
		}
	case 699:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3756
		{
			sqlVAL.union.val = QualifiedNames{sqlDollar[1].union.qname()}
		}
	case 700:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3760
		{
			sqlVAL.union.val = append(sqlDollar[1].union.qnames(), sqlDollar[3].union.qname())
		}
	case 701:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3771
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str)}
		}
	case 702:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3775
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str), Indirect: sqlDollar[2].union.indirect()}
		}
	case 703:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3781
		{
			sqlVAL.union.val = &TableNameWithIndex{Table: sqlDollar[1].union.qname(), Index: Name(sqlDollar[3].str)}
		}
	case 704:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3792
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str)}
		}
	case 705:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3796
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str), Indirect: Indirection{sqlDollar[2].union.indirectElem()}}
		}
	case 706:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3800
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str), Indirect: Indirection{sqlDollar[2].union.indirectElem()}}
		}
	case 707:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3804
		{
			sqlVAL.union.val = &QualifiedName{Indirect: Indirection{unqualifiedStar}}
		}
	case 708:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3810
		{
			sqlVAL.union.val = []string{sqlDollar[1].str}
		}
	case 709:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3814
		{
			sqlVAL.union.val = append(sqlDollar[1].union.strs(), sqlDollar[3].str)
		}
	case 710:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3820
		{
			sqlVAL.union.val = sqlDollar[2].union.strs()
		}
	case 711:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3823
		{
		}
	case 712:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3833
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str)}
		}
	case 713:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3837
		{
			sqlVAL.union.val = &QualifiedName{Base: Name(sqlDollar[1].str), Indirect: sqlDollar[2].union.indirect()}
		}
	case 714:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3844
		{
			sqlVAL.union.val = &IntVal{Val: sqlDollar[1].union.ival().Val, Str: sqlDollar[1].union.ival().Str}
		}
	case 715:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3848
		{
			sqlVAL.union.val = NumVal(sqlDollar[1].str)
		}
	case 716:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3852
		{
			sqlVAL.union.val = DString(sqlDollar[1].str)
		}
	case 717:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3856
		{
			sqlVAL.union.val = DBytes(sqlDollar[1].str)
		}
	case 718:
		sqlDollar = sqlS[sqlpt-6 : sqlpt+1]
		//line sql.y:3859
		{
			unimplemented()
		}
	case 719:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3861
		{
			sqlVAL.union.val = &CastExpr{Expr: DString(sqlDollar[2].str), Type: sqlDollar[1].union.colType()}
		}
	case 720:
		sqlDollar = sqlS[sqlpt-3 : sqlpt+1]
		//line sql.y:3865
		{
			sqlVAL.union.val = &CastExpr{Expr: DString(sqlDollar[2].str), Type: sqlDollar[1].union.colType()}
		}
	case 721:
		sqlDollar = sqlS[sqlpt-5 : sqlpt+1]
		//line sql.y:3869
		{
			sqlVAL.union.val = &CastExpr{Expr: DString(sqlDollar[5].str), Type: sqlDollar[1].union.colType()}
		}
	case 722:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3873
		{
			sqlVAL.union.val = DBool(true)
		}
	case 723:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3877
		{
			sqlVAL.union.val = DBool(false)
		}
	case 724:
		sqlDollar = sqlS[sqlpt-1 : sqlpt+1]
		//line sql.y:3881
		{
			sqlVAL.union.val = DNull
		}
	case 726:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3888
		{
			sqlVAL.union.val = sqlDollar[2].union.ival()
		}
	case 727:
		sqlDollar = sqlS[sqlpt-2 : sqlpt+1]
		//line sql.y:3892
		{
			sqlVAL.union.val = IntVal{Val: -sqlDollar[2].union.ival().Val, Str: "-" + sqlDollar[2].union.ival().Str}
		}
	case 732:
		sqlDollar = sqlS[sqlpt-0 : sqlpt+1]
		//line sql.y:3914
		{
			sqlVAL.str = ""
		}
	}
	goto sqlstack /* stack new state and value */
}
